////////////////////////////////////////////
// Per NT 4.00 e Successive
// Realizzato da: Francesco Germinara
// CBseInfo.cpp Implementazione Classe CBseInfo 
// Storia: 
// Data Creazione: 01.02.2000
////////////////////////////////////////////
#include "stdafx.h"
#include "CBseInfo.h"
          
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Costruttore
CBseInfo::CBseInfo(){
 //Impostazione di Default
 m_fInsRap=FALSE;    
 m_fRegUsrLogon=TRUE;
 m_fRegUsrOper=FALSE;
 m_strRegKey1="Germinara Francesco SofTech";
 m_strRegKey2="fgSMS";
 m_strRegKey3="V. 1.00";

 //Variabili dei percorsi
 m_strPathPrg     ="C:\\NEWFGSMS\\DEBUG\\";     
 m_strPathDati    ="D:\\FGSMS\\DATI\\";     
 m_strPathWord    ="C:\\Program Files\\Microsoft Office\\Office\\";     
 m_strPathExcel   ="C:\\Program Files\\Microsoft Office\\Office\\";     
 m_strPathWordDoc ="D:\\FGSMS\\DOC\\";     
 m_strPathExcelDoc="D:\\FGSMS\\DOC\\";     
 m_strPathImp     ="D:\\FGSMS\\IMPORT\\";     
 m_strPathExp     ="D:\\FGSMS\\EXPORT\\";     
 m_strPathHTML    ="D:\\FGSMS\\HTML\\";     
 m_strPathPRT     ="D:\\FGSMS\\STAMPE\\";     
 m_strSrvPrtName  ="Testreport";     

 
 //Variabili di Informazioni Generali 
 m_nPL=0;
 m_strCodUte="";
 m_strPWUte="";
 m_strIdTerm="0001";
 m_UsrNameLogon="";
 m_InfoStsBarUser="";
 m_tmUsrLogon="";     
 m_tmUsrLogoff="";    

 m_strTmLogo="10000";      

 //Operazioni Consentite all'utente
 m_fCanInsert=FALSE;
 m_fCanModify=FALSE;
 m_fCanRead=TRUE;
 m_fCanDelete=FALSE;
 m_fCanTX=FALSE;
 m_fCanPrint=TRUE;
 m_fCanDeleteAll=FALSE;
 m_fCanExit=TRUE;

 //Variabili del Database e impostazioni SQL
 m_strCONNECT="DSN=DBFGSMS;UID=sa;PWD="; 

 //BGR
 m_colorSfoDocConf=RGB(255,255,240);

}

//Imposto Valori di Default su REGEDIT
BOOL CBseInfo::SetRegEdit(){
 HKEY key,rKey1,rKey2,rKey3;
 DWORD Tipo,Size=100;
 char Dati[100];

 CTime time=CTime::GetCurrentTime();
 int nAnno=time.GetYear();
 int nMese=time.GetMonth();
 int nGiorno=time.GetDay();

 if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\", 0, KEY_WRITE, &key)==ERROR_SUCCESS){
  RegCreateKeyEx(key,m_strRegKey1,0,"LPBYTE",REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&rKey1,&Tipo);
  RegCreateKeyEx(rKey1,m_strRegKey2,0,"LPBYTE",REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&rKey2,&Tipo);
  RegCreateKeyEx(rKey2,m_strRegKey3,0,"LPBYTE",REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&rKey3,&Tipo);
  if(Tipo==REG_CREATED_NEW_KEY){
   strcpy(Dati,m_strCONNECT);     if(RegSetValueEx(rKey3,"ODBC_CONNECT",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strPathPrg);     if(RegSetValueEx(rKey3,"PATH_PRG",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strPathDati);    if(RegSetValueEx(rKey3,"PATH_DATI",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strPathWord);    if(RegSetValueEx(rKey3,"PATH_WORD",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strPathExcel);   if(RegSetValueEx(rKey3,"PATH_EXCEL",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strPathWordDoc); if(RegSetValueEx(rKey3,"PATH_WORD_DOC",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strPathExcelDoc);if(RegSetValueEx(rKey3,"PATH_WORD_EXCEL",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strPathImp);     if(RegSetValueEx(rKey3,"PATH_IMPORT",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strPathExp);     if(RegSetValueEx(rKey3,"PATH_EXPORT",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strCodUte);      if(RegSetValueEx(rKey3,"USR_CODE",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strPWUte);       if(RegSetValueEx(rKey3,"USR_PASSWORD",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}
   strcpy(Dati,m_strIdTerm);      if(RegSetValueEx(rKey3,"ID_TERM",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}   
   strcpy(Dati,m_strTmLogo);      if(RegSetValueEx(rKey3,"TM_DISPLAY_LOGO",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}   
   strcpy(Dati,m_strPathHTML);    if(RegSetValueEx(rKey3,"PATH_HTML",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}   
   strcpy(Dati,m_strPathPRT); if(RegSetValueEx(rKey3,"PATH_PRT",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}   
   strcpy(Dati,m_strSrvPrtName);     if(RegSetValueEx(rKey3,"SRVPRTNAME",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}   

   if(m_fInsRap) 
	strcpy(Dati,"VERO"); 
   else 
	strcpy(Dati,"FALSO");      
   if(RegSetValueEx(rKey3,"FLG_FAST_INSERT",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}   

   if(m_fRegUsrLogon) 
	strcpy(Dati,"VERO"); 
   else 
	strcpy(Dati,"FALSO");      
   if(RegSetValueEx(rKey3,"FLG_LOG_LOGON",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}   
   
   if(m_fRegUsrOper) 
	strcpy(Dati,"VERO"); 
   else 
	strcpy(Dati,"FALSO");      
   if(RegSetValueEx(rKey3,"FLG_LOG_OPER",NULL,REG_SZ,(LPBYTE)Dati,strlen(Dati)+1)==ERROR_SUCCESS){ RegFlushKey(rKey3);}   

  }
  RegCloseKey(rKey3);
  RegCloseKey(rKey2);
  RegCloseKey(rKey1);
  RegCloseKey(key);
  return TRUE;
 }
 //Problema ...
 AfxMessageBox("ATTENZIONE: Non  stato possibile aggiornare\ni dati tramite il registro di WINNT\nControllare se si  in possesso dei necessari\ndiritti e riprovare.\n\nGrazie per la collaborazione.");
 return FALSE;
}


//Leggo Valori di  da REGEDIT
BOOL CBseInfo::GetRegEdit(){
 HKEY rKey3;
 DWORD Tipo,Size=100;
 char Dati[100];
 CString m_strFlg; 
 if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\"+m_strRegKey1+"\\"+m_strRegKey2+"\\"+m_strRegKey3, 0, KEY_READ, &rKey3)==ERROR_SUCCESS){
  Size=100; if(RegQueryValueEx(rKey3,"ODBC_CONNECT",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strCONNECT=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"PATH_PRG",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathPrg=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"PATH_DATI",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathDati=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"PATH_WORD",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathWord=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"PATH_EXCEL",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathExcel=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"PATH_WORD_DOC",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathWordDoc=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"PATH_WORD_EXCEL",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathExcelDoc=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"PATH_IMPORT",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathImp=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"PATH_EXPORT",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathExp=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"USR_CODE",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strCodUte=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"USR_PASSWORD",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPWUte=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"ID_TERM",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strIdTerm=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"FLG_FAST_INSERT",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strFlg=((char *)Dati); }
  Size=100; if(RegQueryValueEx(rKey3,"PATH_HTML",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathHTML=((char *)Dati); } 
  
  Size=100; if(RegQueryValueEx(rKey3,"PATH_PRT",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strPathPRT=((char *)Dati); } 
  Size=100; if(RegQueryValueEx(rKey3,"SRVPRTNAME",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strSrvPrtName=((char *)Dati); } 


  if(m_strFlg=="VERO")  m_fInsRap=TRUE; 
  if(m_strFlg=="FALSO") m_fInsRap=FALSE;
  Size=100; if(RegQueryValueEx(rKey3,"TM_DISPLAY_LOGO",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strTmLogo=((char *)Dati); }

  Size=100; if(RegQueryValueEx(rKey3,"FLG_LOG_LOGON",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strFlg=((char *)Dati); }
  if(m_strFlg=="VERO")  m_fRegUsrLogon=TRUE; 
  if(m_strFlg=="FALSO") m_fRegUsrLogon=FALSE;

  Size=100; if(RegQueryValueEx(rKey3,"FLG_LOG_OPER",NULL,&Tipo,(LPBYTE)Dati,&Size)==ERROR_SUCCESS){ m_strFlg=((char *)Dati); }
  if(m_strFlg=="VERO")  m_fRegUsrOper=TRUE; 
  if(m_strFlg=="FALSO") m_fRegUsrOper=FALSE;

  RegCloseKey(rKey3);
  return TRUE;
 }
 //Problema ...
 AfxMessageBox("Avviso: Non sono presenti informazioni\nparticolari per il programma.\nVerranno impostate le informazioni di base.\n");
 return FALSE;
}

//Abilita Operazioni per l'utente, in funzione del privilegio
void CBseInfo::EnableUsrOperation(){ 
 switch(m_nPL){ //Livello Privilegio Utente
  case 0:  SetFlags(FALSE,FALSE,TRUE,FALSE,FALSE,FALSE,FALSE,FALSE); break; //Solo Leggere e NON puo' Uscire dal programma
  case 1:  SetFlags(FALSE,FALSE,TRUE,FALSE,FALSE,FALSE,FALSE,TRUE); break;  //Solo Leggere
  case 2:  SetFlags(FALSE,FALSE,TRUE,FALSE,FALSE,TRUE,FALSE,TRUE); break;   //Legge e Stampa
  case 3:  SetFlags(FALSE,TRUE,TRUE,FALSE,FALSE,TRUE,FALSE,TRUE); break;    //Legge,Stampa e Modifica
  case 4:  SetFlags(FALSE,TRUE,TRUE,TRUE,FALSE,TRUE,FALSE,TRUE); break;     //Legge,Stampa,Modifica e Cancella
  case 5:  SetFlags(TRUE,TRUE,TRUE,FALSE,FALSE,TRUE,FALSE,TRUE); break;     //Inserisce,Legge,Stampa,Modifica 
  case 6:  SetFlags(TRUE,TRUE,TRUE,TRUE,FALSE,TRUE,FALSE,TRUE); break;      //Inserisce,Legge,Stampa,Modifica e Cancella
  case 7:  SetFlags(FALSE,FALSE,TRUE,FALSE,TRUE,TRUE,FALSE,TRUE); break;    //Legge e Trasmette
  case 8:  SetFlags(TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,FALSE,TRUE); break;       //Inserisce,Legge,Stampa,Modifica e Cancella e Trasmette
  case 9:  SetFlags(TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE); break;        //Admin
  default: SetFlags(FALSE,FALSE,TRUE,FALSE,FALSE,FALSE,FALSE,TRUE); break;  //Solo Leggere
 }
}

//Imposta Flags Operazioni Consentite dall'Utente
void CBseInfo::SetFlags(BOOL fCanInsert,BOOL fCanModify,BOOL fCanRead,BOOL fCanDelete,BOOL fCanTX,BOOL fCanPrint,BOOL fCanDeleteAll,BOOL fCanExit){
 m_fCanInsert=fCanInsert;
 m_fCanModify=fCanModify;
 m_fCanRead=fCanRead;
 m_fCanDelete=fCanDelete;
 m_fCanTX=fCanTX;
 m_fCanPrint=fCanPrint;
 m_fCanDeleteAll=fCanDeleteAll;
 m_fCanExit=fCanExit;
}

//Controllo Se posso fare una certa operazione
BOOL CBseInfo::IcanDO(int Operation){
 if(Operation== BI_USR_INSERT   && m_fCanInsert) return TRUE;
 if(Operation== BI_USR_MODIFY   && m_fCanModify) return TRUE;
 if(Operation== BI_USR_READ     && m_fCanRead)   return TRUE;
 if(Operation== BI_USR_DELETE   && m_fCanDelete)   return TRUE;
 if(Operation== BI_USR_TRANSMIT && m_fCanTX)   return TRUE;
 if(Operation== BI_USR_PRINT    && m_fCanPrint)   return TRUE;
 if(Operation== BI_USR_DELETALL && m_fCanDeleteAll)   return TRUE;
 if(Operation== BI_USR_EXIT     && m_fCanExit)   return TRUE;
 return FALSE;
}

//Fine
