//Classe per Edit per le Date
//By Franco Germinara (c) Nov. '96
//Upd. 22.7.99

#if !defined(CDATEDIT_H)
#define CDATEDIT_H

class CDatEdit : public CEdit
{
 private:

 public:
 
 CDatEdit();
 CString m_Dato;   //Valore Immesso da Utente
 int m_pos_cur;    //Posizione del cursore durante l'immissione dati
 int m_cxChar; 
 int m_cyChar; 
 UINT m_ID;

 CPoint m_ptCaretPos;

 BOOL IsBisestile(int aaaa);
 BOOL IsDateValid();
 BOOL IsValid(UINT nChar);
 void SetOggi();
 void SetStrData(CString strDate);
 void SetData(int gg, int mm, int aaaa);
 void GetData(int *gg, int *mm, int *aaaa);
 void XformData(int Tipo,char *dtXform);
 void XformData(int Tipo,CString& dtxfd);
 void Reset();
 void Refresh(); //Visualizza valore del campo

 protected:
 afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
 afx_msg void OnKeyUp (UINT, UINT, UINT);
 afx_msg void OnSysKeyUp (UINT, UINT, UINT);
 afx_msg void OnSysKeyDown (UINT, UINT, UINT);
 afx_msg void OnChar (UINT, UINT, UINT);
 afx_msg void OnSysChar (UINT, UINT, UINT);

 afx_msg void OnSetFocus(CWnd *OldWnd);
 afx_msg void OnKillFocus(CWnd *NewWnd);
  

 DECLARE_MESSAGE_MAP ()
};

#endif