// CDlgCfgGruppi.cpp : implementation file
//

#include "stdafx.h"
#include "FGSms.h"
#include "CDlgCfgGruppi.h"

//La Classe Applicazione 
extern CFGSmsApp theApp;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgGruppi dialog


CDlgCfgGruppi::CDlgCfgGruppi(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCfgGruppi::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCfgGruppi)
	m_strDescr = _T("");
	m_strGruppo = _T("");
	m_strCost = _T("");
	//}}AFX_DATA_INIT
}


void CDlgCfgGruppi::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCfgGruppi)
	DDX_Control(pDX, IDC_LST_ELEGRP, m_lstEleGrp);
	DDX_Control(pDX, IDC_EDT_COST, m_edtCost);
	DDX_Control(pDX, IDC_EDT_DESCR, m_edtDescr);
	DDX_Control(pDX, IDC_EDT_GRP, m_edtGruppo);
	DDX_Text(pDX, IDC_EDT_DESCR, m_strDescr);
	DDX_Text(pDX, IDC_EDT_GRP, m_strGruppo);
	DDX_Text(pDX, IDC_EDT_COST, m_strCost);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCfgGruppi, CDialog)
	//{{AFX_MSG_MAP(CDlgCfgGruppi)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_BTN_MODIFICA, OnBtnModifica)
	ON_BN_CLICKED(IDC_BTN_REGISTRA, OnBtnRegistra)
	ON_BN_CLICKED(IDC_BTN_CANCELLA, OnBtnCancella)
	//}}AFX_MSG_MAP
    ON_NOTIFY(LVN_ITEMACTIVATE,IDC_LST_ELEGRP,OnItemActivate)
    ON_NOTIFY(LVN_KEYDOWN,IDC_LST_ELEGRP,OnItemKeyActivate)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgGruppi message handlers

HBRUSH CDlgCfgGruppi::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

BOOL CDlgCfgGruppi::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_edtGruppo.SetLimitText(theApp.m_pTabGroup->m_len_IdGroup);
	m_edtDescr.SetLimitText(theApp.m_pTabGroup->m_len_Description);
	m_edtCost.SetLimitText(theApp.m_pTabGroup->m_len_CostOfService);
	
	EnableCtrl(FALSE);

	CreaIntestazione(&m_lstEleGrp);

	m_strFiltro="";
	theApp.m_pTabGroup->MakeList(&m_lstEleGrp,&m_IntTab,NULL,m_strFiltro);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//Creazione dell'intestazione di colonna
void CDlgCfgGruppi::CreaIntestazione(CListCtrl *m_Listview){
 LV_COLUMN lvc; //Crea la struttura per la gestione delle colonne
 lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
 lvc.fmt  = LVCFMT_LEFT;

 ListView_SetExtendedListViewStyle(m_Listview->m_hWnd,LVS_EX_FULLROWSELECT | LVS_EX_TRACKSELECT | LVS_EX_UNDERLINEHOT | LVS_EX_TWOCLICKACTIVATE);

 m_IntTab.setnumcol(3); 

 m_strNomeCampo.LoadString(IDS_CAMPO_CODICE_GRP); 
 m_IntTab.setlargcolV(0,90);
 m_IntTab.setlargcolS(0,11);
 m_IntTab.setdesccol(0,m_strNomeCampo);


 m_strNomeCampo.LoadString(IDS_CAMPO_DESCRIZIONE); 
 m_IntTab.setlargcolV(1,160);
 m_IntTab.setlargcolS(1,11);
 m_IntTab.setdesccol(1,m_strNomeCampo);

 m_strNomeCampo.LoadString(IDS_CAMPO_COSTO); 
 m_IntTab.setlargcolV(2,100);
 m_IntTab.setlargcolS(2,11);
 m_IntTab.setdesccol(2,m_strNomeCampo);

 int i=0;
 for(i=0;i<m_IntTab.getnumcol();i++){
  lvc.cx=m_IntTab.getlargcolV(i);
  lvc.pszText=m_IntTab.getdesccol(i);
  lvc.iSubItem = i; 
  lvc.iImage = 0;
  m_Listview->InsertColumn(i,&lvc);
 }
} 


void CDlgCfgGruppi::OnBtnModifica() 
{
  int sts=0;	 
  UpdateData(TRUE);	
  sts=theApp.m_pTabGroup->LoadDati(m_strGruppo);
  if(sts==RC_SI){
   m_strDescr=theApp.m_pTabGroup->m_Description;
   m_strCost=theApp.m_pTabGroup->m_CostOfService;
   m_strDescr.TrimRight();
   m_strCost.TrimRight();
  }else{
   m_strDescr="";
   m_strCost="0.0";
  }

  UpdateData(FALSE);
  EnableCtrl(TRUE);
  m_edtDescr.SetFocus();
}

void CDlgCfgGruppi::EnableCtrl(int sts){
 m_edtGruppo.EnableWindow(!sts);
 m_edtDescr.EnableWindow(sts);
 m_edtCost.EnableWindow(sts);
}

void CDlgCfgGruppi::OnBtnRegistra() 
{
  int sts=0;
  UpdateData(TRUE);	
  m_strGruppo.TrimRight();
  if(!m_strGruppo.IsEmpty()){
   sts=theApp.m_pTabGroup->Insert(m_strGruppo,m_strDescr,m_strCost);	
   CleanUp();
  }
}


void CDlgCfgGruppi::CleanUp(){
 m_strDescr = _T("");
 m_strGruppo = _T("");
 m_strCost = _T("");
 UpdateData(FALSE);	
 theApp.m_pTabGroup->MakeList(&m_lstEleGrp,&m_IntTab,NULL,m_strFiltro);
 EnableCtrl(FALSE);
 m_edtGruppo.SetFocus();
}



//Con space seleziono la voce
void CDlgCfgGruppi::OnItemKeyActivate(NMHDR* pNMHDR, LRESULT *pResult){
 NMLVKEYDOWN* pNMLVKEYDOWN = (NMLVKEYDOWN*)pNMHDR;
 
 if(pNMLVKEYDOWN->wVKey == VK_SPACE){
  m_nrec_sel=m_lstEleGrp.GetNextItem(-1,LVNI_FOCUSED);
  if(m_nrec_sel>=0){
   CodSel=m_lstEleGrp.GetItemText(m_nrec_sel,0);
   CodSel.TrimRight();
   m_strGruppo=CodSel;
   UpdateData(FALSE);
   OnBtnModifica();
  }else
   CodSel="";
 }
}

//Con doppio click seleziono la voce
void CDlgCfgGruppi::OnItemActivate(NMHDR* pNMHDR, LRESULT *pResult){
 NMLISTVIEW* pNMLISTVIEW = (NMLISTVIEW*)pNMHDR;
 
 m_nrec_sel=m_lstEleGrp.GetNextItem(-1,LVNI_FOCUSED);
 if(m_nrec_sel>=0){
  CodSel=m_lstEleGrp.GetItemText(m_nrec_sel,0);
  CodSel.TrimRight();
  m_strGruppo=CodSel;
  UpdateData(FALSE);
  OnBtnModifica();
 }else
  CodSel="";
}

void CDlgCfgGruppi::OnBtnCancella() 
{
  int sts=0;
  UpdateData(TRUE);
  m_strGruppo.TrimRight();
  if(!m_strGruppo.IsEmpty()){
   sts=theApp.m_pTabGroup->DeleteRec(m_strGruppo);	
   CleanUp();
  }
	
}
