// CDlgCfgSMPT.cpp : implementation file
//

#include "stdafx.h"
#include "FGSms.h"
#include "CDlgCfgSMPT.h"

//La Classe Applicazione 
extern CFGSmsApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgSMPT dialog


CDlgCfgSMPT::CDlgCfgSMPT(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCfgSMPT::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCfgSMPT)
	m_strDomainNameServer = _T("");
	m_strRelaySMTPServer = theApp.m_strSmtpSvr;
	m_strSMTPName = _T("");
	//}}AFX_DATA_INIT
}


//Creazione dell'intestazione di colonna
void CDlgCfgSMPT::CreaIntestazione(CListCtrl *m_Listview){
 LV_COLUMN lvc; //Crea la struttura per la gestione delle colonne
 lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
 lvc.fmt  = LVCFMT_LEFT;

 ListView_SetExtendedListViewStyle(m_Listview->m_hWnd,LVS_EX_FULLROWSELECT | LVS_EX_TRACKSELECT | LVS_EX_UNDERLINEHOT | LVS_EX_TWOCLICKACTIVATE);

 m_IntTab.setnumcol(2); 

 m_strNomeCampo.LoadString(IDS_CAMPO_SRVSMTP_NAME); 
 m_IntTab.setlargcolV(0,160);
 m_IntTab.setlargcolS(0,11);
 m_IntTab.setdesccol(0,m_strNomeCampo);


 m_strNomeCampo.LoadString(IDS_CAMPO_DOMAIN_NAME); 
 m_IntTab.setlargcolV(1,160);
 m_IntTab.setlargcolS(1,11);
 m_IntTab.setdesccol(1,m_strNomeCampo);

 int i=0;
 for(i=0;i<m_IntTab.getnumcol();i++){
  lvc.cx=m_IntTab.getlargcolV(i);
  lvc.pszText=m_IntTab.getdesccol(i);
  lvc.iSubItem = i; 
  lvc.iImage = 0;
  m_Listview->InsertColumn(i,&lvc);
 }
} 


void CDlgCfgSMPT::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCfgSMPT)
	DDX_Control(pDX, IDC_EDT_SMTPNAME, m_edtSMTPName);
	DDX_Control(pDX, IDC_EDT_DNS, m_edtDomainNameServer);
	DDX_Control(pDX, IDC_EDT_SMTPSRV, m_edtRelaySMTPServer);
	DDX_Control(pDX, IDC_LST_ELESRV, m_lstEleSrvSMTP);
	DDX_Text(pDX, IDC_EDT_DNS, m_strDomainNameServer);
	DDX_Text(pDX, IDC_EDT_SMTPSRV, m_strRelaySMTPServer);
	DDX_Text(pDX, IDC_EDT_SMTPNAME, m_strSMTPName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCfgSMPT, CDialog)
	//{{AFX_MSG_MAP(CDlgCfgSMPT)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_BTN_ADD, OnBtnAdd)
	ON_BN_CLICKED(IDC_BTN_MINUS, OnBtnMinus)
	//}}AFX_MSG_MAP
    ON_NOTIFY(LVN_ITEMACTIVATE,IDC_LST_ELESRV,OnItemActivate)
    ON_NOTIFY(LVN_KEYDOWN,IDC_LST_ELESRV,OnItemKeyActivate)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgSMPT message handlers

HBRUSH CDlgCfgSMPT::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CDlgCfgSMPT::OnBtnAdd() 
{
	UpdateData(TRUE);
    m_strSMTPName.TrimRight();
    if(!m_strSMTPName.IsEmpty()){
 	 theApp.m_pTabSMTPSrv->Insert(m_strSMTPName,m_strDomainNameServer);
	 CleanUp();
	}
}

void CDlgCfgSMPT::OnBtnMinus() 
{
	UpdateData(TRUE);
	m_strSMTPName.TrimRight();
	if(!m_strSMTPName.IsEmpty()){
	theApp.m_pTabSMTPSrv->DeleteRec(m_strSMTPName);
	 CleanUp();
	}
}

BOOL CDlgCfgSMPT::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_edtDomainNameServer.SetLimitText(theApp.m_pTabSMTPSrv->m_len_DomainName);
	m_edtSMTPName.SetLimitText(theApp.m_pTabSMTPSrv->m_len_SrvName);
	m_edtRelaySMTPServer.SetLimitText(theApp.m_pTabCfgFgSms->m_len_SmtpSvr);
		
    CreaIntestazione(&m_lstEleSrvSMTP);
	
    m_strFiltro="";
	theApp.m_pTabSMTPSrv->MakeList(&m_lstEleSrvSMTP,&m_IntTab,NULL,m_strFiltro);

	return TRUE;
}

void CDlgCfgSMPT::CleanUp(){
 m_strDomainNameServer = _T("");
 m_strSMTPName = _T("");
 UpdateData(FALSE);
 theApp.m_pTabSMTPSrv->MakeList(&m_lstEleSrvSMTP,&m_IntTab,NULL,m_strFiltro);
}


//Con space seleziono la voce
void CDlgCfgSMPT::OnItemKeyActivate(NMHDR* pNMHDR, LRESULT *pResult){
 NMLVKEYDOWN* pNMLVKEYDOWN = (NMLVKEYDOWN*)pNMHDR;
 
 if(pNMLVKEYDOWN->wVKey == VK_SPACE){
  m_nrec_sel=m_lstEleSrvSMTP.GetNextItem(-1,LVNI_FOCUSED);
  if(m_nrec_sel>=0){
   CodSel=m_lstEleSrvSMTP.GetItemText(m_nrec_sel,0);
   CodSel.TrimRight();
   m_strSMTPName=CodSel;

   CodSel=m_lstEleSrvSMTP.GetItemText(m_nrec_sel,1);
   CodSel.TrimRight();
   m_strDomainNameServer=CodSel;

   UpdateData(FALSE);
  }else
   CodSel="";
 }
}

//Con doppio click seleziono la voce
void CDlgCfgSMPT::OnItemActivate(NMHDR* pNMHDR, LRESULT *pResult){
 NMLISTVIEW* pNMLISTVIEW = (NMLISTVIEW*)pNMHDR;
 
 m_nrec_sel=m_lstEleSrvSMTP.GetNextItem(-1,LVNI_FOCUSED);
 if(m_nrec_sel>=0){
  CodSel=m_lstEleSrvSMTP.GetItemText(m_nrec_sel,0);
  CodSel.TrimRight();
  m_strSMTPName=CodSel;

  CodSel=m_lstEleSrvSMTP.GetItemText(m_nrec_sel,1);
  CodSel.TrimRight();
  m_strDomainNameServer=CodSel;

  UpdateData(FALSE);
 }else
  CodSel="";
}
