//Implementazione della classe CDlgVisTabGenerica
// By FG 28.05.98
// U.M.. 12/10/99

#include "stdafx.h"
#include "resource.h"
#include "CDlgVisTabGenerica.h"
#include "CDlgFiltro.h"


BEGIN_MESSAGE_MAP(CDlgVisTabGenerica, CDialog)
 ON_BN_CLICKED(IDC_BTN_FILTRO_GEN,OnSendBtnFiltro)
 ON_NOTIFY(LVN_ITEMACTIVATE,IDC_VIS_GENERICA,OnItemActivate)
 ON_NOTIFY(LVN_KEYDOWN,IDC_VIS_GENERICA,OnItemKeyActivate)
END_MESSAGE_MAP()

CDlgVisTabGenerica::CDlgVisTabGenerica(void *m_pTabGen,int nc,int *pLen,char str_val[][101],CString titolo,CWnd *pParentWnd=NULL,CString filtro,CString NomiPerFiltro):CDialog(IDD_VIS_GENERICA,pParentWnd){

 m_pTabGenerica=((CTabVirtual *)m_pTabGen);
 m_num_col=nc; 
 m_len_col=pLen;
 m_Title=titolo;
 m_filtro=filtro;
 m_nomi=NomiPerFiltro;
 int i=0;
 flgShowFiltro=false; 
 flgUseOrderBy=true; 
 flgUseInternalVersion=false;
 for(i=0;i<nc;i++)
  strcpy(m_str_col[i],str_val[i]);
}  


//Pulisce i campi di Input
void CDlgVisTabGenerica::Pulisce(){
 Codice="";
 Codice2="";
 Codice3="";
 Codice4="";
 Codice5="";
}


BOOL CDlgVisTabGenerica::OnInitDialog(){
 CString msg;
 m_filtro.TrimRight();
 msg=m_Title;
 if(m_filtro.GetLength()==0)
  msg=m_Title+" (tutti)";
 else
  msg=m_Title+" ("+m_filtro+")";
 SetWindowText(msg);
 //ricavo puntatore alla CListView
 m_Listview=((CListCtrl *)GetDlgItem(IDC_VIS_GENERICA));

 //Creo impostazione delle colonne
 CreaIntestazione(m_Listview);

 //Barra progresso operazione
 CProgressCtrl progBar;
 WINDOWPLACEMENT wp; // Per Ricavare Posizione Dimensione Windows
 wp.length=sizeof(WINDOWPLACEMENT);
 GetDlgItem(IDC_RIQ_PRG)->GetWindowPlacement( &wp);

 progBar.Create(WS_OVERLAPPED|WS_VISIBLE,(CRect&)wp.rcNormalPosition,this,0);
 progBar.SetRange(10,100);
 progBar.SetPos(10);
 progBar.SetStep(10);
 progBar.StepIt();

 
 //Riempio la listbox
 if(flgUseOrderBy)
  m_pTabGenerica->MakeList(m_Listview,&m_IntTabGenerica,&progBar,m_filtro);
 else
  m_pTabGenerica->MakeList(m_Listview,NULL,&progBar,m_filtro);
 m_Listview->SetItemState(0,1,LVNI_FOCUSED);
  
 Pulisce();

 if(flgShowFiltro==true)
  GetDlgItem(IDC_BTN_FILTRO_GEN)->ShowWindow(SW_NORMAL);
 else
  GetDlgItem(IDC_BTN_FILTRO_GEN)->ShowWindow(SW_HIDE); 
 return FALSE;
}

//Con space seleziono la voce
void CDlgVisTabGenerica::OnItemKeyActivate(NMHDR* pNMHDR, LRESULT *pResult){
 NMLVKEYDOWN* pNMLVKEYDOWN = (NMLVKEYDOWN*)pNMHDR;
 
 if(pNMLVKEYDOWN->wVKey == VK_SPACE){
  m_nrec_sel=m_Listview->GetNextItem(-1,LVNI_FOCUSED);
  if(m_nrec_sel>=0)
  Codice=m_Listview->GetItemText(m_nrec_sel,0);
  if( m_num_col >=2)
   Codice2=m_Listview->GetItemText(m_nrec_sel,1);
  if( m_num_col >=3)
   Codice3=m_Listview->GetItemText(m_nrec_sel,2);
  if( m_num_col >=3)
   Codice4=m_Listview->GetItemText(m_nrec_sel,3);
  if( m_num_col >=4)
   Codice5=m_Listview->GetItemText(m_nrec_sel,4);
  EndDialog(IDOK);
 }else{
  Codice="";
  Codice2="";
  Codice3="";
  Codice4="";
  Codice5="";
 }
}

//Con doppio clic seleziono la voce
void CDlgVisTabGenerica::OnItemActivate(NMHDR* pNMHDR, LRESULT *pResult){
 NMLISTVIEW* pNMLISTVIEW = (NMLISTVIEW*)pNMHDR;

 m_nrec_sel=m_Listview->GetNextItem(-1,LVNI_FOCUSED);
 if(m_nrec_sel>=0){
  Codice=m_Listview->GetItemText(m_nrec_sel,0);
  if( m_num_col >=2)
   Codice2=m_Listview->GetItemText(m_nrec_sel,1);
  if( m_num_col >=3)
   Codice3=m_Listview->GetItemText(m_nrec_sel,2);
  if( m_num_col >=3)
   Codice4=m_Listview->GetItemText(m_nrec_sel,3);
  if( m_num_col >=4)
   Codice5=m_Listview->GetItemText(m_nrec_sel,4);
  EndDialog(IDOK);
 }else{
  Codice="";
  Codice2="";
  Codice3="";
  Codice4="";
  Codice5="";
 }
}

//Creazione dell'intestazione di colonna
void CDlgVisTabGenerica::CreaIntestazione(CListCtrl *m_Listview){
 LV_COLUMN lvc; //Crea la struttura per la gestione delle colonne
 lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
 lvc.fmt  = LVCFMT_LEFT;

 //Attivo visualizzazione della barra su tutti i campi 
 ListView_SetExtendedListViewStyle(m_Listview->m_hWnd,LVS_EX_FULLROWSELECT);

 m_IntTabGenerica.setnumcol(m_num_col); //Codice,Nome,Cognome,Privilegio

 int j=0;
 for(j=0;j<m_num_col;j++){
  m_IntTabGenerica.setlargcolV(j,m_len_col[j]); //Lunghezza campo
  m_IntTabGenerica.setlargcolS(j,0);
  m_IntTabGenerica.setdesccol(j,m_str_col[j]); //Descrizione
 }

 int i=0;
 for(i=0;i<m_num_col;i++){
  lvc.cx=m_IntTabGenerica.getlargcolV(i);
  lvc.pszText=m_IntTabGenerica.getdesccol(i);
  lvc.iSubItem = i; 
  m_Listview->InsertColumn(i,&lvc);
 }
} 

//Attivo pulsante Filtro
void CDlgVisTabGenerica::SetFiltroOn(){
 flgShowFiltro=true; 
}

//Ridirigo il messaggio alla finestra genitrice
void CDlgVisTabGenerica::OnSendBtnFiltro(){
 if(!flgUseInternalVersion)
  GetParent()->SendMessage(WM_COMMAND,MAKEWPARAM(IDC_BTN_FILTRO_GEN, BN_CLICKED),(LPARAM)this->m_hWnd);
 else
  OnBtnFiltro();
}

//Ridirigo il messaggio alla finestra genitrice
void CDlgVisTabGenerica::OnBtnFiltro(){
 CDlgFiltro dlgFiltro;
 CString filtro;
 dlgFiltro.filtro="";
 dlgFiltro.nomi=m_nomi;
 if(dlgFiltro.DoModal()==IDOK){
  filtro=dlgFiltro.filtro;
 }
 Refresh(filtro);
}


//Rielaboro il filtro
void CDlgVisTabGenerica::Refresh(CString filtro){
 CString oldFiltro;
 CString msg;
 //Barra progresso operazione
 CProgressCtrl progBar;
 WINDOWPLACEMENT wp; // Per Ricavare Posizione Dimensione Windows
 wp.length=sizeof(WINDOWPLACEMENT);
 GetDlgItem(IDC_RIQ_PRG)->GetWindowPlacement( &wp);

 progBar.Create(WS_OVERLAPPED|WS_VISIBLE,(CRect&)wp.rcNormalPosition,this,0);
 progBar.SetRange(10,100);
 progBar.SetPos(10);
 progBar.SetStep(10);
 progBar.StepIt();

 //Salvo vecchio filtro
 oldFiltro=m_filtro;
 m_filtro=filtro;

 //Riempio la listbox
 m_pTabGenerica->MakeList(m_Listview,&m_IntTabGenerica,&progBar,m_filtro);
 m_Listview->SetItemState(0,1,LVNI_FOCUSED);

 if(m_Listview->GetItemCount( )==0){
  AfxMessageBox("Errore: Nessun dato soddisfa il filtro impostato\n("+m_filtro+");\n\nViene riapplicato il filtro precedente\n("+oldFiltro+")");
  m_filtro=oldFiltro;
  //Riempio la listbox
  m_pTabGenerica->MakeList(m_Listview,&m_IntTabGenerica,&progBar,m_filtro);
  m_Listview->SetItemState(0,1,LVNI_FOCUSED);
 }
 Pulisce();
 m_filtro.TrimRight();
 msg=m_Title;
 if(m_filtro.GetLength()==0)
  msg=m_Title+" (tutti)";
 else
  msg=m_Title+" ("+m_filtro+")";
 SetWindowText(msg);
}

//Fine