// Gestione Tabella Generica
// By Franco Germinara 12.04.99

#ifndef CLASS_CDlgVisTabGenerica_INCLUDED
#define CLASS_CDlgVisTabGenerica_INCLUDED
//

#include "resource.h"
#include "CTabVirtual.h"

class CDlgVisTabGenerica : public CDialog{
private:
 bool flgShowFiltro;

public:
 CTabVirtual *m_pTabGenerica; 

 BOOL flgUseInternalVersion; //TRUE SE DEVO USARE LA OnBtnFiltro() interna
  
public:
 CString Codice; //Codice selezionato
 CString Codice2; //Codice selezionato
 CString Codice3; //Codice selezionato
 CString Codice4; //Codice selezionato
 CString Codice5; //Codice selezionato

 BOOL flgUseOrderBy; //FALSE=Non usa m_IntTabGenerica per ricavare l'ordinamento in quanto  tutto presente nel m_filtro

 void SetFiltroOn(); //Attiva Pulsante Impostazione filtro


 int m_num_col;  //Numero di colonne nella visualizzazione
 int *m_len_col;
 char m_str_col[50][101];
 CString m_Title;
 CString m_filtro;
 CString m_nomi;
 

 //Finestra Visualizzazione
 qtHead m_IntTabGenerica;
  
 CListCtrl *m_Listview;
 int m_nrec_sel;     //Numero record selezionato 0=primo
 void CreaIntestazione(CListCtrl *m_Listview);

 void Pulisce();
 
 //Costruttore della Classe
 CDlgVisTabGenerica(void *m_pTabGen,int nc,int *pLen,char str_val[][101],CString titolo,CWnd *pParentWnd,CString filtro="",CString NomiPerFiltro="");
 void OnSendBtnFiltro();
 void Refresh(CString filtro);
 void OnBtnFiltro();
  
protected:
 virtual BOOL OnInitDialog();
 afx_msg void OnItemActivate(NMHDR* pNMHDR, LRESULT *pResult);
 afx_msg void OnItemKeyActivate(NMHDR* pNMHDR, LRESULT *pResult);
 afx_msg void OnColClick(NMHDR* pNMHDR, LRESULT *pResult);

 DECLARE_MESSAGE_MAP()
};

#endif