////////////////////////////////////////////
// Per NT 4.00 e Successive
// Realizzato da: Francesco Germinara
// CFGSmsDB.h Classe per l'accesso al DataBase 
// Storia:
// Data Creazione: 01/06/2001
// (c) SofTech di Germinara Francesco 
////////////////////////////////////////////

#include "stdafx.h"
#include "FGSms.h"
#include "CFGSmsDB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//La Classe Applicazione 
extern CFGSmsApp theApp;

IMPLEMENT_DYNAMIC(CFGSmsDB, CDatabase)

//Costruttore dell'oggetto database
CFGSmsDB::CFGSmsDB(){

}

//Apertura del database - crea la connessione
BOOL CFGSmsDB::OpenDB(){
 BOOL sts;

 //Leggo il valore predefinito nel RegEdit
 CString strConn=theApp.bseInfo.m_strCONNECT;
 
 try{ //Provo ad aprire la connessione
  sts=OpenEx(_T(strConn),0);
 }catch( CDBException* e ){ //problema ...
  AfxMessageBox("ERRORE: Impossibile trovare la connessione ODBC.\n\n["+strConn+"]\n\n"+"Impossibile Proseguire. \n\nSuggerimento:\n(Verificare la connessione ODBC o la chiave ODBC_CONNECT)",MB_ICONSTOP );
  e->Delete();
  sts=FALSE;
 }
 //Accesso al Database Server 
 return sts;
}

//Fine