//Collection of standard GSM AT MODEM COMMAND BY Francesco Germinara (c) 2001
//21/04/2001

#if !defined(_INCLUDED_AT_GSMCOMMANDS_)
#define _INCLUDED_AT_GSMCOMMANDS_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include"CGsmAtCommand.h"

#define GSM_AT_MAX_COMMAND 100

class CGsmAtCommands{
private:
 int m_nNumOfCmd;

 CGsmAtCommand *m_pCGsmAtCommands[GSM_AT_MAX_COMMAND]; //Array of AT commands

public:
 // Construction
  CGsmAtCommands();
 ~CGsmAtCommands();//Destructor

public:
 //Operation 
 int SetupCommands(); //Fill command information

 CString LookUpCmd(CString code,int& nIndex); //Return the name of command and the numeric index of command
 CString GetCmd(CString name,int& nIndex); //Return the complete string to send and the numeric index of command
 CString GetCmd(int nIndex); //Return the complete string to send
 CGsmAtCommand *GetPtrCmd(int nIndex); //Return ptr of command object

};

#endif 
