////////////////////////////////////////////
// Per NT 4.00 e Successive
// Realizzato da: Francesco Germinara
// CSplitMsg.h:  Divisione del messaggio in n messaggi per SMS
// Storia:
// Data Creazione: 22.10.2001
// (c) SofTech di Germinara Francesco
////////////////////////////////////////////

#ifndef CLASS_CSplitMsg_INCLUDED
#define CLASS_CSplitMsg_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CSplitMsg
{
private:
 CString m_orgMsg; //Messaggio originale

 int m_nMaxSize;  //Dimensione massima del messaggio
public:
	CSplitMsg(){ m_nMaxSize = 160; }

	void SetMsg(CString msg) { m_orgMsg = msg; }
	CString  GetMsg() { return m_orgMsg; }

	void SetMaxSize(int value) { m_nMaxSize = value; }
	int GetMaxSize() { return m_nMaxSize; }


    CStringArray m_astr; //Array dei messaggi divisi

	int SplitMsg() { //Effettua l'operazione
     int nElement=0,len=0;
	 if(m_nMaxSize<=0) m_nMaxSize = 160; //default value
	 len = m_orgMsg.GetLength();
	 nElement = int ( len/ m_nMaxSize);
	 if(len % m_nMaxSize)
	  nElement++;
	 m_astr.RemoveAll();
	 for(int n=0;n<nElement;n++){
      m_astr.Add(m_orgMsg.Mid(m_nMaxSize * n ,m_nMaxSize));
	 }
	 return m_astr.GetSize();
	}
};

#endif