////////////////////////////////////////////
// Programma:       
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabCfgFgSms.h 
// Storia:
// Data Creazione: 10/06/2001
// (c) 2001 SofTech di Germinara Francesco 
////////////////////////////////////////////////
// Ultima Modifica al tracciato base 22/05/2001/
////////////////////////////////////////////////

#include "stdafx.h"

#ifndef CLASS_CTabCfgFgSms_INCLUDED
#define CLASS_CTabCfgFgSms_INCLUDED
//
/////////////////////////////////////////////////////////////////////////////
class CTabCfgFgSms : public CRecordset
{
public:
	CTabCfgFgSms(CDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CTabCfgFgSms)
 
    CDatabase *m_pDB; //Puntatore al Database aperto

// Campi
	CString m_IdSess;
	CString m_SmtpSvr;
	CString m_ComPort;
	CString m_BaudRate;
	CString m_DataBit;
	CString m_StopBit;
	CString m_Parity;
	CString m_TypeParity;
	CString m_Mode;
	CString m_SMSCNumber;
	CString m_PollingTime;
	CString m_DirLogFiles;
	CString m_NameSharedMem;
	CString m_PassWordCfg;
	CString m_CfgMode;
	CString m_EnableLogs;
	CString m_UseParallelPort;
	CString m_ParallelPortNum;
	CString m_UseIOcard;
//Fine Elenco Campi della tabella di database --- 

//Lunghezze dei campi
	int m_len_IdSess;
	int m_len_SmtpSvr;
	int m_len_ComPort;
	int m_len_BaudRate;
	int m_len_DataBit;
	int m_len_StopBit;
	int m_len_Parity;
	int m_len_TypeParity;
	int m_len_Mode;
	int m_len_SMSCNumber;
	int m_len_PollingTime;
	int m_len_DirLogFiles;
	int m_len_NameSharedMem;
	int m_len_PassWordCfg;
	int m_len_CfgMode;
	int m_len_EnableLogs;
	int m_len_UseParallelPort;
	int m_len_ParallelPortNum;
	int m_len_UseIOcard;
//Fine Elenco Variabili per dimensione campi della tabella di database --- 

	public:

	//Funzioni di accesso alla tabella del database
	virtual CString GetDefaultConnect(); 
	virtual CString GetDefaultSQL(); 	
	virtual void DoFieldExchange(CFieldExchange* pFX);	

	//Funzioni Standard implementate su ciascuna Tabella

    //Restituisce il numero di record nella tabella
	virtual long int Count(CString filtro=""); 
    
	//Riempio ListBox per visualizzazione
    virtual int MakeList(CListCtrl *m_listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro="");

    //Trova il record indicato
	int LoadDati(CString& IdSess); 

	//Inserisce/Varia record di dato
    int Insert(
	 CString& IdSess,
	 CString& SmtpSvr,
	 CString& ComPort,
	 CString& BaudRate,
	 CString& DataBit,
	 CString& StopBit,
	 CString& Parity,
	 CString& TypeParity,
	 CString& Mode,
	 CString& SMSCNumber,
	 CString& PollingTime,
	 CString& DirLogFiles,
	 CString& NameSharedMem,
	 CString& PassWordCfg,
	 CString& CfgMode,
	 CString& EnableLogs,
	 CString& UseParallelPort,
	 CString& ParallelPortNum,
	 CString& UseIOcard
	); 

	//Cancella Singolo Record
    int DeleteRec(CString& IdSess);

	//Cancello Tutto
	int DeleteAll();

    //Esportazione dati in file ASCII
    void Export(CProgressCtrl *progBar);
    
	//Importazione dati da file ASCII
    void Import(CProgressCtrl *progBar);

	//Apertura File per la stampa
    virtual int OpenRecordSet(qtHead *m_inttab,CString filtro="");

	//Riempio una riga con il record corrente
	virtual int GetRecordForDispInfo(CListCtrl *m_qtListCtrl,LVITEM* pItem);
	

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
#endif

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001