////////////////////////////////////////////
// Programma:       
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabGroup.h 
// Storia:
// Data Creazione: 10/06/2001
// (c) 2001 SofTech di Germinara Francesco 
////////////////////////////////////////////////
// Ultima Modifica al tracciato base 22/05/2001/
////////////////////////////////////////////////

#include "stdafx.h"

#ifndef CLASS_CTabGroup_INCLUDED
#define CLASS_CTabGroup_INCLUDED
//
/////////////////////////////////////////////////////////////////////////////
class CTabGroup : public CRecordset
{
public:
	CTabGroup(CDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CTabGroup)
 
    CDatabase *m_pDB; //Puntatore al Database aperto

// Campi
	CString m_IdGroup;
	CString m_Description;
	CString m_CostOfService;
//Fine Elenco Campi della tabella di database --- 

//Lunghezze dei campi
	int m_len_IdGroup;
	int m_len_Description;
	int m_len_CostOfService;
//Fine Elenco Variabili per dimensione campi della tabella di database --- 

	public:

	//Funzioni di accesso alla tabella del database
	virtual CString GetDefaultConnect(); 
	virtual CString GetDefaultSQL(); 	
	virtual void DoFieldExchange(CFieldExchange* pFX);	

	//Funzioni Standard implementate su ciascuna Tabella

    //Restituisce il numero di record nella tabella
	virtual long int Count(CString filtro=""); 
    
	//Riempio ListBox per visualizzazione
    virtual int MakeList(CListCtrl *m_listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro="");

    //Trova il record indicato
	int LoadDati(CString& IdGroup); 

	//Inserisce/Varia record di dato
    int Insert(
	 CString& IdGroup,
	 CString& Description,
	 CString& CostOfService
	); 

	//Cancella Singolo Record
    int DeleteRec(CString& IdGroup);

	//Cancello Tutto
	int DeleteAll();

    //Esportazione dati in file ASCII
    void Export(CProgressCtrl *progBar);
    
	//Importazione dati da file ASCII
    void Import(CProgressCtrl *progBar);

	//Apertura File per la stampa
    virtual int OpenRecordSet(qtHead *m_inttab,CString filtro="");

	//Riempio una riga con il record corrente
	virtual int GetRecordForDispInfo(CListCtrl *m_qtListCtrl,LVITEM* pItem);
	

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
#endif

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001