////////////////////////////////////////////
// Programma:       
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabSMTPSrv.h 
// Storia:
// Data Creazione: 10/06/2001
// (c) 2001 SofTech di Germinara Francesco 
////////////////////////////////////////////////
// Ultima Modifica al tracciato base 22/05/2001/
////////////////////////////////////////////////

#include "stdafx.h"

#ifndef CLASS_CTabSMTPSrv_INCLUDED
#define CLASS_CTabSMTPSrv_INCLUDED
//
/////////////////////////////////////////////////////////////////////////////
class CTabSMTPSrv : public CRecordset
{
public:
	CTabSMTPSrv(CDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CTabSMTPSrv)
 
    CDatabase *m_pDB; //Puntatore al Database aperto

// Campi
	CString m_SrvName;
	CString m_DomainName;
//Fine Elenco Campi della tabella di database --- 

//Lunghezze dei campi
	int m_len_SrvName;
	int m_len_DomainName;
//Fine Elenco Variabili per dimensione campi della tabella di database --- 

	public:

	//Funzioni di accesso alla tabella del database
	virtual CString GetDefaultConnect(); 
	virtual CString GetDefaultSQL(); 	
	virtual void DoFieldExchange(CFieldExchange* pFX);	

	//Funzioni Standard implementate su ciascuna Tabella

    //Restituisce il numero di record nella tabella
	virtual long int Count(CString filtro=""); 
    
	//Riempio ListBox per visualizzazione
    virtual int MakeList(CListCtrl *m_listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro="");

    //Trova il record indicato
	int LoadDati(CString& SrvName); 

	//Inserisce/Varia record di dato
    int Insert(
	 CString& SrvName,
	 CString& DomainName
	); 

	//Cancella Singolo Record
    int DeleteRec(CString& SrvName);

	//Cancello Tutto
	int DeleteAll();

    //Esportazione dati in file ASCII
    void Export(CProgressCtrl *progBar);
    
	//Importazione dati da file ASCII
    void Import(CProgressCtrl *progBar);

	//Apertura File per la stampa
    virtual int OpenRecordSet(qtHead *m_inttab,CString filtro="");

	//Riempio una riga con il record corrente
	virtual int GetRecordForDispInfo(CListCtrl *m_qtListCtrl,LVITEM* pItem);

	
    int SearchSrvName(CString& DomainName);

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
#endif

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001