////////////////////////////////////////////
// Programma:       
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabStoricoMsg.h 
// Storia:
// Data Creazione: 28/11/2001
// (c) 2001 SofTech di Germinara Francesco 
////////////////////////////////////////////////
// Ultima Modifica al tracciato base 22/05/2001/
////////////////////////////////////////////////

#include "stdafx.h"

#ifndef CLASS_CTabStoricoMsg_INCLUDED
#define CLASS_CTabStoricoMsg_INCLUDED
//
/////////////////////////////////////////////////////////////////////////////
class CTabStoricoMsg : public CRecordset
{
public:
	CTabStoricoMsg(CDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CTabStoricoMsg)
 
    CDatabase *m_pDB; //Puntatore al Database aperto

// Campi
	CString m_idMSG;
	CString m_textMSG;
	CString m_flgSts;
	CString m_nTelef;
	CString m_data;
	CString m_ora;
	CString m_idUser;
//Fine Elenco Campi della tabella di database --- 

//Lunghezze dei campi
	int m_len_idMSG;
	int m_len_textMSG;
	int m_len_flgSts;
	int m_len_nTelef;
	int m_len_data;
	int m_len_ora;
	int m_len_idUser;
//Fine Elenco Variabili per dimensione campi della tabella di database --- 

	public:

	//Funzioni di accesso alla tabella del database
	virtual CString GetDefaultConnect(); 
	virtual CString GetDefaultSQL(); 	
	virtual void DoFieldExchange(CFieldExchange* pFX);	

	//Funzioni Standard implementate su ciascuna Tabella

    //Restituisce il numero di record nella tabella
	virtual long int Count(CString filtro=""); 
    
	//Riempio ListBox per visualizzazione
    virtual int MakeList(CListCtrl *m_listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro="");

    //Trova il record indicato
	int LoadDati(CString& idMSG,CString& nTelef,CString& data,CString& ora); 

	//Inserisce/Varia record di dato
    int Insert(
	 CString& idMSG,
	 CString& textMSG,
	 CString& flgSts,
	 CString& nTelef,
	 CString& data,
	 CString& ora,
	 CString& idUser
	); 

	//Cancella Singolo Record
    int DeleteRec(CString& idMSG,CString& nTelef,CString& data,CString& ora);

	//Cancello Tutto
	int DeleteAll();

    //Esportazione dati in file ASCII
    void Export(CProgressCtrl *progBar);
    
	//Importazione dati da file ASCII
    void Import(CProgressCtrl *progBar);

	//Apertura File per la stampa
    virtual int OpenRecordSet(qtHead *m_inttab,CString filtro="");

	//Riempio una riga con il record corrente
	virtual int GetRecordForDispInfo(CListCtrl *m_qtListCtrl,LVITEM* pItem);
	

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
#endif

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001