////////////////////////////////////////////
// Programma:
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabUser.cpp 
// Storia:
// Data Creazione: 08/07/2001
// (c) 2001 SofTech di Germinara Francesco
////////////////////////////////////////////
// Data Ultima Modifica: 20/10/2001

#include "stdafx.h"
#include "FGSms.h"
#include "CTabUser.h"

//La Classe Applicazione 
extern CFGSmsApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNAMIC(CTabUser, CRecordset)

CTabUser::CTabUser(CDatabase* pdb)
	: CRecordset(pdb)
{
    //Inizializzazione dei campi, del numero di campi
	//e del tipo di gestione del database
	m_IdUser= _T("");
	m_UsrName= _T("");
	m_UsrGrp= _T("");
	m_ServiceEnable= _T("");
	m_ExpirationDate= _T("");
	m_ChkReqDays= _T("");
	m_mailAddress= _T("");
	m_mailPassword= _T("");
	m_mailPOP3svr= _T("");
	m_phoneNumber= _T("");
	m_phoneSIMNumber= _T("");
	m_phonePassword= _T("");
	m_CMOnlyOne= _T("");
	m_CMShortMode= _T("");
	m_CMNotifyEnable= _T("");
	m_CMFlashMode= _T("");
	m_PMStandByMsg= _T("");
	m_PMSendConfirm= _T("");
	m_DMCanDeleteMsg= _T("");
	m_DMMakeCopyMsg= _T("");
	m_STCanScheduleMsg= _T("");
	m_STCanUseBatchCmd= _T("");
	m_CostOfService= _T("");
 m_mailAccount= _T("");
 m_nMsgSend= _T("");
 m_nMsgReceived= _T("");
 m_nLpt= _T("");
 m_nBits= _T("");
 m_nLastValue= _T("");

	m_nFields = 29;

	m_nDefaultType = dynamic; //dynaset
	m_pDB=pdb; //Assegno il puntatore al database aperto
	
	//Lunghezze dei campi della tabella
	m_len_IdUser= 10;
	m_len_UsrName= 100;
	m_len_UsrGrp= 10;
	m_len_ServiceEnable= 1;
	m_len_ExpirationDate= 8;
	m_len_ChkReqDays= 3;
	m_len_mailAddress= 100;
	m_len_mailPassword= 50;
	m_len_mailPOP3svr= 100;
	m_len_phoneNumber= 50;
	m_len_phoneSIMNumber= 50;
	m_len_phonePassword= 50;
	m_len_CMOnlyOne= 1;
	m_len_CMShortMode= 1;
	m_len_CMNotifyEnable= 1;
	m_len_CMFlashMode= 1;
	m_len_PMStandByMsg= 1;
	m_len_PMSendConfirm= 1;
	m_len_DMCanDeleteMsg= 1;
	m_len_DMMakeCopyMsg= 1;
	m_len_STCanScheduleMsg= 1;
	m_len_STCanUseBatchCmd= 1;
	m_len_CostOfService= 15;
 m_len_mailAccount=50;
 m_len_nMsgSend= 10;
 m_len_nMsgReceived=10;
 m_len_nLpt= 1;
 m_len_nBits= 3;
 m_len_nLastValue=3;
}

//Connessione con il database
CString CTabUser::GetDefaultConnect()
{
 //Apre la connessione stabilita con il database
 return _T(m_pDB->GetConnect());
}

//Connessione con la tabella
CString CTabUser::GetDefaultSQL()
{
 //Nessuna operazione iniziale
 return _T("");
}

//Funzione per interscambio dati da/verso tabella del DB
void CTabUser::DoFieldExchange(CFieldExchange* pFX)
{
   	pFX->SetFieldType(CFieldExchange::outputColumn);
	 RFX_Text(pFX, _T("[IdUser]"),m_IdUser);
	if(m_nFields>1){
	 RFX_Text(pFX, _T("[UsrName]"),m_UsrName);
	 RFX_Text(pFX, _T("[UsrGrp]"),m_UsrGrp);
	 RFX_Text(pFX, _T("[ServiceEnable]"),m_ServiceEnable);
	 RFX_Text(pFX, _T("[ExpirationDate]"),m_ExpirationDate);
	 RFX_Text(pFX, _T("[ChkReqDays]"),m_ChkReqDays);
	 RFX_Text(pFX, _T("[mailAddress]"),m_mailAddress);
	 RFX_Text(pFX, _T("[mailPassword]"),m_mailPassword);
	 RFX_Text(pFX, _T("[mailPOP3svr]"),m_mailPOP3svr);
	 RFX_Text(pFX, _T("[phoneNumber]"),m_phoneNumber);
	 RFX_Text(pFX, _T("[phoneSIMNumber]"),m_phoneSIMNumber);
	 RFX_Text(pFX, _T("[phonePassword]"),m_phonePassword);
	 RFX_Text(pFX, _T("[CMOnlyOne]"),m_CMOnlyOne);
	 RFX_Text(pFX, _T("[CMShortMode]"),m_CMShortMode);
	 RFX_Text(pFX, _T("[CMNotifyEnable]"),m_CMNotifyEnable);
	 RFX_Text(pFX, _T("[CMFlashMode]"),m_CMFlashMode);
	 RFX_Text(pFX, _T("[PMStandByMsg]"),m_PMStandByMsg);
	 RFX_Text(pFX, _T("[PMSendConfirm]"),m_PMSendConfirm);
	 RFX_Text(pFX, _T("[DMCanDeleteMsg]"),m_DMCanDeleteMsg);
	 RFX_Text(pFX, _T("[DMMakeCopyMsg]"),m_DMMakeCopyMsg);
	 RFX_Text(pFX, _T("[STCanScheduleMsg]"),m_STCanScheduleMsg);
	 RFX_Text(pFX, _T("[STCanUseBatchCmd]"),m_STCanUseBatchCmd);
	 RFX_Text(pFX, _T("[CostOfService]"),m_CostOfService);
	 RFX_Text(pFX, _T("[mailAccount]"),m_mailAccount);

	 RFX_Text(pFX, _T("[nMsgSend]"),m_nMsgSend);
		RFX_Text(pFX, _T("[nMsgReceived]"),m_nMsgReceived);
		RFX_Text(pFX, _T("[nLpt]"),m_nLpt);
		RFX_Text(pFX, _T("[nBits]"),m_nBits);
	 RFX_Text(pFX, _T("[nLastValue]"),m_nLastValue);
	}
}

//ESPORTA IN FILE ASCII
void CTabUser::Export(CProgressCtrl *progBar=NULL){
  long nrec=0L;
  CString fit;

  //Definizione dei nomi dei files
  CString nFile,msg;
  char dati[1001];
  FILE *m_idFile;
  bool FileIsOpen;
  nFile=theApp.bseInfo.m_strPathExp;
  nFile+="CFGUSER.EXP";

  Open(CRecordset::dynamic,"SELECT * FROM CFGUSER ",CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   return;
  }
  //Apertura del file ascii
  m_idFile=fopen(nFile,"w+");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile generare il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(!IsEOF()&&FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();

	fit.Format("%10s",m_IdUser);strcpy(dati,fit);
	fit.Format("%100s",m_UsrName);strcat(dati,fit);
	fit.Format("%10s",m_UsrGrp);strcat(dati,fit);
	fit.Format("%1s",m_ServiceEnable);strcat(dati,fit);
	fit.Format("%8s",m_ExpirationDate);strcat(dati,fit);
	fit.Format("%3s",m_ChkReqDays);strcat(dati,fit);
	fit.Format("%100s",m_mailAddress);strcat(dati,fit);
	fit.Format("%50s",m_mailPassword);strcat(dati,fit);
	fit.Format("%100s",m_mailPOP3svr);strcat(dati,fit);
	fit.Format("%50s",m_phoneNumber);strcat(dati,fit);
	fit.Format("%50s",m_phoneSIMNumber);strcat(dati,fit);
	fit.Format("%50s",m_phonePassword);strcat(dati,fit);
	fit.Format("%1s",m_CMOnlyOne);strcat(dati,fit);
	fit.Format("%1s",m_CMShortMode);strcat(dati,fit);
	fit.Format("%1s",m_CMNotifyEnable);strcat(dati,fit);
	fit.Format("%1s",m_CMFlashMode);strcat(dati,fit);
	fit.Format("%1s",m_PMStandByMsg);strcat(dati,fit);
	fit.Format("%1s",m_PMSendConfirm);strcat(dati,fit);
	fit.Format("%1s",m_DMCanDeleteMsg);strcat(dati,fit);
	fit.Format("%1s",m_DMMakeCopyMsg);strcat(dati,fit);
	fit.Format("%1s",m_STCanScheduleMsg);strcat(dati,fit);
	fit.Format("%1s",m_STCanUseBatchCmd);strcat(dati,fit);
	fit.Format("%15s",m_CostOfService);strcat(dati,fit);
	fit.Format("%50s",m_mailAccount);strcat(dati,fit);
	fit.Format("%10s",m_nMsgSend);strcat(dati,fit);
	fit.Format("%10s",m_nMsgReceived);strcat(dati,fit);
	fit.Format("%1s",m_nLpt);strcat(dati,fit);
	fit.Format("%3s",m_nBits);strcat(dati,fit);
	fit.Format("%3s",m_nLastValue);strcat(dati,fit);
 
   fputs(dati,m_idFile);
   fputs("\n",m_idFile);
   MoveNext();
  }
  Close();
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}

//IMPORTA IL FILE ASCII
void CTabUser::Import(CProgressCtrl *progBar){
  long nrec=0L;
  CString fit;
  
  //Definizione dei nomi dei files
  CString nFile,msg;
	CString IdUser;
	CString UsrName;
	CString UsrGrp;
	CString ServiceEnable;
	CString ExpirationDate;
	CString ChkReqDays;
	CString mailAddress;
	CString mailPassword;
	CString mailPOP3svr;
	CString phoneNumber;
	CString phoneSIMNumber;
	CString phonePassword;
	CString CMOnlyOne;
	CString CMShortMode;
	CString CMNotifyEnable;
	CString CMFlashMode;
	CString PMStandByMsg;
	CString PMSendConfirm;
	CString DMCanDeleteMsg;
	CString DMMakeCopyMsg;
	CString STCanScheduleMsg;
	CString STCanUseBatchCmd;
	CString CostOfService;
	CString mailAccount;
 CString nMsgSend;
 CString nMsgReceived;
 CString nLpt;
 CString nBits;
 CString nLastValue;

  char dati[1001];
  char *result;
  FILE *m_idFile;
  bool FileIsOpen;
  int pos=0;
  nFile=theApp.bseInfo.m_strPathImp;
  nFile+="CFGUSER.EXP";
  
  //Apertura del file ascii in lettura
  m_idFile=fopen(nFile,"r");
  if(m_idFile==NULL){ //Non c'e', visualizzo errore.
   msg.Format("Errore: Impossibile leggere il file [%s].",nFile);
   AfxMessageBox(msg);
   FileIsOpen=false;
  }else
   FileIsOpen=true;
 
  while(FileIsOpen){
   if(progBar!=NULL)
    progBar->StepIt();
   result=fgets(dati,999,m_idFile);
   if(result==NULL)
    break;
   fit=(const char *)dati;
  
   pos=0;

	IdUser=fit.Mid(pos,10);pos+=10;
	UsrName=fit.Mid(pos,100);pos+=100;
	UsrGrp=fit.Mid(pos,10);pos+=10;
	ServiceEnable=fit.Mid(pos,1);pos+=1;
	ExpirationDate=fit.Mid(pos,8);pos+=8;
	ChkReqDays=fit.Mid(pos,3);pos+=3;
	mailAddress=fit.Mid(pos,100);pos+=100;
	mailPassword=fit.Mid(pos,50);pos+=50;
	mailPOP3svr=fit.Mid(pos,100);pos+=100;
	phoneNumber=fit.Mid(pos,50);pos+=50;
	phoneSIMNumber=fit.Mid(pos,50);pos+=50;
	phonePassword=fit.Mid(pos,50);pos+=50;
	CMOnlyOne=fit.Mid(pos,1);pos+=1;
	CMShortMode=fit.Mid(pos,1);pos+=1;
	CMNotifyEnable=fit.Mid(pos,1);pos+=1;
	CMFlashMode=fit.Mid(pos,1);pos+=1;
	PMStandByMsg=fit.Mid(pos,1);pos+=1;
	PMSendConfirm=fit.Mid(pos,1);pos+=1;
	DMCanDeleteMsg=fit.Mid(pos,1);pos+=1;
	DMMakeCopyMsg=fit.Mid(pos,1);pos+=1;
	STCanScheduleMsg=fit.Mid(pos,1);pos+=1;
	STCanUseBatchCmd=fit.Mid(pos,1);pos+=1;
	CostOfService=fit.Mid(pos,15);pos+=15;
	mailAccount=fit.Mid(pos,50);pos+=50;
 nMsgSend=fit.Mid(pos,10);pos+=10;
 nMsgReceived=fit.Mid(pos,10);pos+=10;
 nLpt=fit.Mid(pos,1);pos+=1;
 nBits=fit.Mid(pos,3);pos+=3;
 nLastValue=fit.Mid(pos,3);pos+=3;
   
	Insert(
	 IdUser,
	 UsrName,
	 UsrGrp,
	 ServiceEnable,
	 ExpirationDate,
	 ChkReqDays,
	 mailAddress,
	 mailPassword,
	 mailPOP3svr,
	 phoneNumber,
	 phoneSIMNumber,
	 phonePassword,
	 CMOnlyOne,
	 CMShortMode,
	 CMNotifyEnable,
	 CMFlashMode,
	 PMStandByMsg,
	 PMSendConfirm,
	 DMCanDeleteMsg,
	 DMMakeCopyMsg,
	 STCanScheduleMsg,
	 STCanUseBatchCmd,
	 CostOfService,
	 mailAccount,
  nMsgSend,
  nMsgReceived,
  nLpt,
  nBits,
  nLastValue
   );
  }
  //Chiudo File ASCII
  if(FileIsOpen)
   fclose(m_idFile);
}



long int CTabUser::Count(CString filtro){
  CWaitCursor wait;
  long nrec=0L;
  int nOldFiled=m_nFields;
  m_nFields=1;

  CString qry;
  qry="SELECT COUNT(*) FROM CFGUSER ";
  if(filtro!="")
   qry+=filtro;

  Open(CRecordset::dynamic,qry,CRecordset::none); //forwardOnly
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
  }else{
   
	nrec=atol(m_IdUser);

   Close();
  }

  m_nFields=nOldFiled;
  return nrec;
}

//Controlla se esiste il codice specificato, se esiste carica i dati
//nelle rispettive variabili
int CTabUser::LoadDati(CString& IdUser){
  int sts=0;
  CString qry;
  qry="SELECT * FROM CFGUSER WHERE IdUser='"+IdUser+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
 
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   sts=RC_ERR; //Errore
  }
  if(IsEOF()){ //NON TROVATO
   sts=RC_NO;
  }else{
   //Variazione dati
   Edit(); 
   sts=RC_SI;
  }
  Close();
  return(sts);
}

//Immissione dati
int CTabUser::Insert(
	 CString& IdUser,
	 CString& UsrName,
	 CString& UsrGrp,
	 CString& ServiceEnable,
	 CString& ExpirationDate,
	 CString& ChkReqDays,
	 CString& mailAddress,
	 CString& mailPassword,
	 CString& mailPOP3svr,
	 CString& phoneNumber,
	 CString& phoneSIMNumber,
	 CString& phonePassword,
	 CString& CMOnlyOne,
	 CString& CMShortMode,
	 CString& CMNotifyEnable,
	 CString& CMFlashMode,
	 CString& PMStandByMsg,
	 CString& PMSendConfirm,
	 CString& DMCanDeleteMsg,
	 CString& DMMakeCopyMsg,
	 CString& STCanScheduleMsg,
	 CString& STCanUseBatchCmd,
	 CString& CostOfService,
	 CString& mailAccount,
  CString& nMsgSend,
  CString& nMsgReceived,
  CString& nLpt,
  CString& nBits,
  CString& nLastValue

 ){
 int sts=RC_SI;
 CString qry;
 qry="SELECT * FROM CFGUSER WHERE IdUser='"+IdUser+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //ESISTE ?
   sts=RC_NO; 
   AddNew();
  }else{
   Edit();
   sts=RC_SI; 
  }

  //Assegno il valore ai vari campi
	m_IdUser=IdUser;
	m_UsrName=UsrName;
	m_UsrGrp=UsrGrp;
	m_ServiceEnable=ServiceEnable;
	m_ExpirationDate=ExpirationDate;
	m_ChkReqDays=ChkReqDays;
	m_mailAddress=mailAddress;
	m_mailPassword=mailPassword;
	m_mailPOP3svr=mailPOP3svr;
	m_phoneNumber=phoneNumber;
	m_phoneSIMNumber=phoneSIMNumber;
	m_phonePassword=phonePassword;
	m_CMOnlyOne=CMOnlyOne;
	m_CMShortMode=CMShortMode;
	m_CMNotifyEnable=CMNotifyEnable;
	m_CMFlashMode=CMFlashMode;
	m_PMStandByMsg=PMStandByMsg;
	m_PMSendConfirm=PMSendConfirm;
	m_DMCanDeleteMsg=DMCanDeleteMsg;
	m_DMMakeCopyMsg=DMMakeCopyMsg;
	m_STCanScheduleMsg=STCanScheduleMsg;
	m_STCanUseBatchCmd=STCanUseBatchCmd;
	m_CostOfService=CostOfService;
 m_mailAccount=mailAccount;
 m_nMsgSend=nMsgSend;
 m_nMsgReceived=nMsgReceived;
 m_nLpt=nLpt;
 m_nBits=nBits;
 m_nLastValue=nLastValue;
  
  //Gestione delle eccezioni
  try{
   Update(); 
  }catch( CDBException* e ){
   AfxMessageBox("Errore su Update1 (CFGUSER)\n"+e->m_strError,MB_ICONEXCLAMATION );
   e->Delete();
  }
  Close();
  return(sts);
}

//Cancellazione Singolo Dato
int CTabUser::DeleteRec(CString& IdUser){
  int sts=RC_SI;
  CString qry;
  qry="SELECT * FROM CFGUSER WHERE IdUser='"+IdUser+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   sts= RC_ERR; //Errore
  }
  if(IsEOF()){ //esiste ?
   AfxMessageBox("Impossibile cancellare. Dato non presente!");
   sts=RC_NO;
  }else{
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su Delete (CFGUSER)\n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
  }
  Close();
  return(sts);
}

//Cancello tutti i dati 
int CTabUser::DeleteAll(){
  long nrec=0L;
  Open(CRecordset::dynamic,"SELECT * FROM CFGUSER ",CRecordset::none);
   if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   return RC_ERR;
  }

  //Conto il numero di record 
  while(!IsEOF()){
   //Gestione delle eccezioni
   try{
    Delete(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su DeleteAll (CFGUSER) \n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
   MoveNext(); //Vado sul record successivo
  }
  Close();
  return RC_SI;
}

//Inserisce i record nella listview
int CTabUser::MakeList(CListCtrl *m_Listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro){

  LV_ITEM lvi;
  lvi.mask=LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
  lvi.iSubItem=0;

  CString clausola;
  int nrec=0;

  clausola="SELECT * FROM CFGUSER ";
  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY IdUser"; break;
   default: clausola=clausola+" ORDER BY IdUser"; break;
  }
  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";
  
  Open(CRecordset::dynamic,clausola,CRecordset::none);

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   return 0;
  }

  //Inserisco dati dei singoli record
  m_Listview->DeleteAllItems();
  nrec=0;
  while(!IsEOF()){

   if(progBar!=NULL)
    progBar->StepIt();

   lvi.iItem=nrec; 
   lvi.pszText="";
   lvi.cchTextMax=5;
   lvi.lParam = (LPARAM) nrec; 
   lvi.iImage = 0; 
   m_Listview->InsertItem(&lvi);

	m_Listview->SetItemText(nrec,0,m_IdUser);
	m_Listview->SetItemText(nrec,1,m_UsrName);
	m_Listview->SetItemText(nrec,2,m_UsrGrp);
	m_Listview->SetItemText(nrec,3,m_ServiceEnable);
	m_Listview->SetItemText(nrec,4,m_ExpirationDate);
	m_Listview->SetItemText(nrec,5,m_ChkReqDays);
	m_Listview->SetItemText(nrec,6,m_mailAddress);
	m_Listview->SetItemText(nrec,7,m_mailPassword);
	m_Listview->SetItemText(nrec,8,m_mailPOP3svr);
	m_Listview->SetItemText(nrec,9,m_phoneNumber);
	m_Listview->SetItemText(nrec,10,m_phoneSIMNumber);
	m_Listview->SetItemText(nrec,11,m_phonePassword);
	m_Listview->SetItemText(nrec,12,m_CMOnlyOne);
	m_Listview->SetItemText(nrec,13,m_CMShortMode);
	m_Listview->SetItemText(nrec,14,m_CMNotifyEnable);
	m_Listview->SetItemText(nrec,15,m_CMFlashMode);
	m_Listview->SetItemText(nrec,16,m_PMStandByMsg);
	m_Listview->SetItemText(nrec,17,m_PMSendConfirm);
	m_Listview->SetItemText(nrec,18,m_DMCanDeleteMsg);
	m_Listview->SetItemText(nrec,19,m_DMMakeCopyMsg);
	m_Listview->SetItemText(nrec,20,m_STCanScheduleMsg);
	m_Listview->SetItemText(nrec,21,m_STCanUseBatchCmd);
	m_Listview->SetItemText(nrec,22,m_CostOfService);
	m_Listview->SetItemText(nrec,23,m_mailAccount);
	
	m_Listview->SetItemText(nrec,24,m_nMsgSend);
	m_Listview->SetItemText(nrec,25,m_nMsgReceived);
	m_Listview->SetItemText(nrec,26,m_nLpt);
	m_Listview->SetItemText(nrec,27,m_nBits);
	m_Listview->SetItemText(nrec,28,m_nLastValue);

   nrec++;
   MoveNext();
  }
  Close();
  return nrec;
}


//Inserisce i record nella listview Virtuale
int CTabUser::GetRecordForDispInfo(CListCtrl *m_FG,LVITEM* pItem){
	if(pItem->iSubItem == 0){ //Solo al cambio del record leggo 
		                      //dati dalla tabella
   MoveFirst();
   Move(pItem->iItem);
   if(!IsEOF()){
    //pItem->iImage = atoi(xxx); 
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_IdUser); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_UsrName); break; 
	case 2: lstrcpy(pItem->pszText, (LPCTSTR) m_UsrGrp); break; 
	case 3: lstrcpy(pItem->pszText, (LPCTSTR) m_ServiceEnable); break; 
	case 4: lstrcpy(pItem->pszText, (LPCTSTR) m_ExpirationDate); break; 
	case 5: lstrcpy(pItem->pszText, (LPCTSTR) m_ChkReqDays); break; 
	case 6: lstrcpy(pItem->pszText, (LPCTSTR) m_mailAddress); break; 
	case 7: lstrcpy(pItem->pszText, (LPCTSTR) m_mailPassword); break; 
	case 8: lstrcpy(pItem->pszText, (LPCTSTR) m_mailPOP3svr); break; 
	case 9: lstrcpy(pItem->pszText, (LPCTSTR) m_phoneNumber); break; 
	case 10: lstrcpy(pItem->pszText, (LPCTSTR) m_phoneSIMNumber); break; 
	case 11: lstrcpy(pItem->pszText, (LPCTSTR) m_phonePassword); break; 
	case 12: lstrcpy(pItem->pszText, (LPCTSTR) m_CMOnlyOne); break; 
	case 13: lstrcpy(pItem->pszText, (LPCTSTR) m_CMShortMode); break; 
	case 14: lstrcpy(pItem->pszText, (LPCTSTR) m_CMNotifyEnable); break; 
	case 15: lstrcpy(pItem->pszText, (LPCTSTR) m_CMFlashMode); break; 
	case 16: lstrcpy(pItem->pszText, (LPCTSTR) m_PMStandByMsg); break; 
	case 17: lstrcpy(pItem->pszText, (LPCTSTR) m_PMSendConfirm); break; 
	case 18: lstrcpy(pItem->pszText, (LPCTSTR) m_DMCanDeleteMsg); break; 
	case 19: lstrcpy(pItem->pszText, (LPCTSTR) m_DMMakeCopyMsg); break; 
	case 20: lstrcpy(pItem->pszText, (LPCTSTR) m_STCanScheduleMsg); break; 
	case 21: lstrcpy(pItem->pszText, (LPCTSTR) m_STCanUseBatchCmd); break; 
	case 22: lstrcpy(pItem->pszText, (LPCTSTR) m_CostOfService); break; 
	case 23: lstrcpy(pItem->pszText, (LPCTSTR) m_mailAccount); break; 
	case 24: lstrcpy(pItem->pszText, (LPCTSTR) m_nMsgSend); break; 
	case 25: lstrcpy(pItem->pszText, (LPCTSTR) m_nMsgReceived); break; 
	case 26: lstrcpy(pItem->pszText, (LPCTSTR) m_nLpt); break; 
	case 27: lstrcpy(pItem->pszText, (LPCTSTR) m_nBits); break; 
	case 28: lstrcpy(pItem->pszText, (LPCTSTR) m_nLastValue); break; 

    }
   }
  }else{
    switch(pItem->iSubItem){ //campo da aggiornare
	case 0: lstrcpy(pItem->pszText, (LPCTSTR) m_IdUser); break; 
	case 1: lstrcpy(pItem->pszText, (LPCTSTR) m_UsrName); break; 
	case 2: lstrcpy(pItem->pszText, (LPCTSTR) m_UsrGrp); break; 
	case 3: lstrcpy(pItem->pszText, (LPCTSTR) m_ServiceEnable); break; 
	case 4: lstrcpy(pItem->pszText, (LPCTSTR) m_ExpirationDate); break; 
	case 5: lstrcpy(pItem->pszText, (LPCTSTR) m_ChkReqDays); break; 
	case 6: lstrcpy(pItem->pszText, (LPCTSTR) m_mailAddress); break; 
	case 7: lstrcpy(pItem->pszText, (LPCTSTR) m_mailPassword); break; 
	case 8: lstrcpy(pItem->pszText, (LPCTSTR) m_mailPOP3svr); break; 
	case 9: lstrcpy(pItem->pszText, (LPCTSTR) m_phoneNumber); break; 
	case 10: lstrcpy(pItem->pszText, (LPCTSTR) m_phoneSIMNumber); break; 
	case 11: lstrcpy(pItem->pszText, (LPCTSTR) m_phonePassword); break; 
	case 12: lstrcpy(pItem->pszText, (LPCTSTR) m_CMOnlyOne); break; 
	case 13: lstrcpy(pItem->pszText, (LPCTSTR) m_CMShortMode); break; 
	case 14: lstrcpy(pItem->pszText, (LPCTSTR) m_CMNotifyEnable); break; 
	case 15: lstrcpy(pItem->pszText, (LPCTSTR) m_CMFlashMode); break; 
	case 16: lstrcpy(pItem->pszText, (LPCTSTR) m_PMStandByMsg); break; 
	case 17: lstrcpy(pItem->pszText, (LPCTSTR) m_PMSendConfirm); break; 
	case 18: lstrcpy(pItem->pszText, (LPCTSTR) m_DMCanDeleteMsg); break; 
	case 19: lstrcpy(pItem->pszText, (LPCTSTR) m_DMMakeCopyMsg); break; 
	case 20: lstrcpy(pItem->pszText, (LPCTSTR) m_STCanScheduleMsg); break; 
	case 21: lstrcpy(pItem->pszText, (LPCTSTR) m_STCanUseBatchCmd); break; 
	case 22: lstrcpy(pItem->pszText, (LPCTSTR) m_CostOfService); break; 
	case 23: lstrcpy(pItem->pszText, (LPCTSTR) m_mailAccount); break; 
	case 24: lstrcpy(pItem->pszText, (LPCTSTR) m_nMsgSend); break; 
	case 25: lstrcpy(pItem->pszText, (LPCTSTR) m_nMsgReceived); break; 
	case 26: lstrcpy(pItem->pszText, (LPCTSTR) m_nLpt); break; 
	case 27: lstrcpy(pItem->pszText, (LPCTSTR) m_nBits); break; 
	case 28: lstrcpy(pItem->pszText, (LPCTSTR) m_nLastValue); break; 

    }
  }
  return 0;
}

//Imposta Recordset
int CTabUser::OpenRecordSet(qtHead *m_inttab,CString filtro){
  CString clausola;
  clausola="SELECT * FROM CFGUSER ";

  if(filtro!="")
   clausola+=filtro;

  //Controllo eventuale ordinamento dati 
  int orderby=m_inttab->getorder();
  switch(orderby){
   case 0 : clausola=clausola+" ORDER BY IdUser"; break;
   default: clausola=clausola+" ORDER BY IdUser"; break;
  }

  int ascend=m_inttab->gettipord();
  if(ascend == 1) //Decrescente
   clausola=clausola+" DESC";

  if(CanBookmark())
   Open(CRecordset::dynamic,clausola,CRecordset::useBookmarks);
  else
   Open(CRecordset::dynamic,clausola,CRecordset::none);  //useBookmarks

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   return RC_ERR; //Errore
  }
  return RC_SI;   //OK
}


/////////////////////////////////////////////////////////////////////////////
// CTabUser Diagnostica

#ifdef _DEBUG
void CTabUser::AssertValid() const
{
	CRecordset::AssertValid();
}

void CTabUser::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG


int CTabUser::FindByNumTel(CString& NumTel){
  int sts=0;
  CString qry;
  qry="SELECT * FROM CFGUSER WHERE phoneNumber='"+NumTel+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
 
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   sts=RC_ERR; //Errore
  }
  if(IsEOF()){ //NON TROVATO
   sts=RC_NO;
  }else{
   //Variazione dati
   Edit(); 
   sts=RC_SI;
  }
  Close();
  return(sts);
}

//Aggiorno Validita
int CTabUser::UpdateExpirationDate(
	 CString& IdUser,
	 CString& ServiceEnable,
	 CString& ExpirationDate
 ){
 int sts=RC_SI;
 CString qry;
 qry="SELECT * FROM CFGUSER WHERE IdUser='"+IdUser+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   sts= RC_ERR; //Errore
  }
  if(!IsEOF()){ //ESISTE ?
   Edit();
   sts=RC_SI; 

   //Assegno il valore ai vari campi
  	m_ServiceEnable=ServiceEnable;
	  m_ExpirationDate=ExpirationDate;
  
   //Gestione delle eccezioni
   try{
    Update(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su Update2 (CFGUSER)\n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
		}
  Close();
  return(sts);
}


//Aggiorno LastValue
int CTabUser::UpdateLastValue(
	 int LastValue
	 ){
	CString nLastValue;

	nLastValue.Format("%d",LastValue);

 int sts=RC_SI;

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   sts= RC_ERR; //Errore
  }
  if(!IsEOF()){ //ESISTE ?
   Edit();
   sts=RC_SI; 

   //Assegno il valore ai vari campi
  	m_nLastValue=nLastValue;
  
   //Gestione delle eccezioni
   try{
    Update(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su Update3 (CFGUSER)\n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
		}
  return(sts);
}


//Aggiorno Stato Servizio
int CTabUser::UpdateServiceEnable(
	 BOOL bServiceEnable
	 ){
	CString nServiceEnable;

	nServiceEnable.Format("%d",bServiceEnable);

 int sts=RC_SI;

  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   sts= RC_ERR; //Errore
  }
  if(!IsEOF()){ //ESISTE ?
   Edit();
   sts=RC_SI; 

   //Assegno il valore ai vari campi
  	m_ServiceEnable=nServiceEnable;
  
   //Gestione delle eccezioni
   try{
    Update(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su Update4 (CFGUSER)\n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
		}
  return(sts);
}


//Aggiorno Contatori Messaggi
int CTabUser::UpdateMsgCounter(
	 CString& IdUser,
	 CString& nMsgSend,
  CString& nMsgReceived
	 ){
 int sts=RC_SI;
 CString qry;
 qry="SELECT * FROM CFGUSER WHERE IdUser='"+IdUser+"'";
  Open(CRecordset::dynamic,qry,CRecordset::none);
  if(!IsOpen()){
   AfxMessageBox("Impossibile aprire la tabella CFGUSER !");
   sts= RC_ERR; //Errore
  }
  if(!IsEOF()){ //ESISTE ?
   Edit();
   sts=RC_SI; 

   //Assegno il valore ai vari campi
   m_nMsgSend= nMsgSend;
   m_nMsgReceived=nMsgReceived;
  
   //Gestione delle eccezioni
   try{
    Update(); 
   }catch( CDBException* e ){
    AfxMessageBox("Errore su Update5 (CFGUSER)\n"+e->m_strError,MB_ICONEXCLAMATION );
    e->Delete();
   }
		}
  Close();
  return(sts);
}


//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001
