////////////////////////////////////////////
// Programma:       
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabUser.h 
// Storia:
// Data Creazione: 08/07/2001
// (c) 2001 SofTech di Germinara Francesco 
////////////////////////////////////////////////
// Ultima Modifica al tracciato base 22/05/2001/
////////////////////////////////////////////////
// Ultima Modifica al tracciato base 20/10/2001/

#include "stdafx.h"

#ifndef CLASS_CTabUser_INCLUDED
#define CLASS_CTabUser_INCLUDED
//
/////////////////////////////////////////////////////////////////////////////
class CTabUser : public CRecordset
{
public:
	CTabUser(CDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CTabUser)
 
    CDatabase *m_pDB; //Puntatore al Database aperto

// Campi
	CString m_IdUser;
	CString m_UsrName;
	CString m_UsrGrp;
	CString m_ServiceEnable;
	CString m_ExpirationDate;
	CString m_ChkReqDays;
	CString m_mailAddress;
	CString m_mailPassword;
	CString m_mailPOP3svr;
	CString m_phoneNumber;
	CString m_phoneSIMNumber;
	CString m_phonePassword;
	CString m_CMOnlyOne;
	CString m_CMShortMode;
	CString m_CMNotifyEnable;
	CString m_CMFlashMode;
	CString m_PMStandByMsg;
	CString m_PMSendConfirm;
	CString m_DMCanDeleteMsg;
	CString m_DMMakeCopyMsg;
	CString m_STCanScheduleMsg;
	CString m_STCanUseBatchCmd;
	CString m_CostOfService;
	CString m_mailAccount;
	CString m_nMsgSend;
	CString m_nMsgReceived;
	CString m_nLpt;
	CString m_nBits;
	CString m_nLastValue;
//Fine Elenco Campi della tabella di database --- 

//Lunghezze dei campi
	int m_len_IdUser;
	int m_len_UsrName;
	int m_len_UsrGrp;
	int m_len_ServiceEnable;
	int m_len_ExpirationDate;
	int m_len_ChkReqDays;
	int m_len_mailAddress;
	int m_len_mailPassword;
	int m_len_mailPOP3svr;
	int m_len_phoneNumber;
	int m_len_phoneSIMNumber;
	int m_len_phonePassword;
	int m_len_CMOnlyOne;
	int m_len_CMShortMode;
	int m_len_CMNotifyEnable;
	int m_len_CMFlashMode;
	int m_len_PMStandByMsg;
	int m_len_PMSendConfirm;
	int m_len_DMCanDeleteMsg;
	int m_len_DMMakeCopyMsg;
	int m_len_STCanScheduleMsg;
	int m_len_STCanUseBatchCmd;
	int m_len_CostOfService;
	int m_len_mailAccount;
	int m_len_nMsgSend;
	int m_len_nMsgReceived;
	int m_len_nLpt;
	int m_len_nBits;
	int m_len_nLastValue;

//Fine Elenco Variabili per dimensione campi della tabella di database --- 

	public:

	//Funzioni di accesso alla tabella del database
	virtual CString GetDefaultConnect(); 
	virtual CString GetDefaultSQL(); 	
	virtual void DoFieldExchange(CFieldExchange* pFX);	

	//Funzioni Standard implementate su ciascuna Tabella

    //Restituisce il numero di record nella tabella
	virtual long int Count(CString filtro=""); 
    
	//Riempio ListBox per visualizzazione
    virtual int MakeList(CListCtrl *m_listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro="");

    //Trova il record indicato
	int LoadDati(CString& IdUser); 

	//Inserisce/Varia record di dato
    int Insert(
	 CString& IdUser,
	 CString& UsrName,
	 CString& UsrGrp,
	 CString& ServiceEnable,
	 CString& ExpirationDate,
	 CString& ChkReqDays,
	 CString& mailAddress,
	 CString& mailPassword,
	 CString& mailPOP3svr,
	 CString& phoneNumber,
	 CString& phoneSIMNumber,
	 CString& phonePassword,
	 CString& CMOnlyOne,
	 CString& CMShortMode,
	 CString& CMNotifyEnable,
	 CString& CMFlashMode,
	 CString& PMStandByMsg,
	 CString& PMSendConfirm,
	 CString& DMCanDeleteMsg,
	 CString& DMMakeCopyMsg,
	 CString& STCanScheduleMsg,
	 CString& STCanUseBatchCmd,
	 CString& CostOfService,
	 CString& mailAccount,
 	CString& m_nMsgSend,
 	CString& m_nMsgReceived,
 	CString& m_nLpt,
 	CString& m_nBits,
 	CString& m_nLastValue
	); 

	//Cancella Singolo Record
    int DeleteRec(CString& IdUser);

	//Cancello Tutto
	int DeleteAll();

    //Esportazione dati in file ASCII
    void Export(CProgressCtrl *progBar);
    
	//Importazione dati da file ASCII
    void Import(CProgressCtrl *progBar);

	//Apertura File per la stampa
    virtual int OpenRecordSet(qtHead *m_inttab,CString filtro="");

	//Riempio una riga con il record corrente
	virtual int GetRecordForDispInfo(CListCtrl *m_qtListCtrl,LVITEM* pItem);
	
 int FindByNumTel(CString& NumTel);

 int UpdateExpirationDate(CString& IdUser,CString& ServiceEnable,CString& ExpirationDate);

	int UpdateLastValue(int lastValue); //NOTA: Il recordset deve essere gi aperto!
	
	int UpdateMsgCounter(CString& IdUser,CString& msgSend, CString& msgReceived);

    int UpdateServiceEnable(BOOL bServiceEnable); //NOTA: Il recordset deve essere gi aperto!


// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
#endif

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001