//Classe intestazione colonne 
//By FG 18/5/98 

#ifndef CLASS_INTESTATAB_INCLUDED
#define CLASS_INTESTATAB_INCLUDED

#define M_CAMPI 50

class Intestatab{
 private:
 int n_col; //Numero di colonne
 char szHtab[M_CAMPI][40]; //50 colonne max, descr 39 ch. max
 int lenVHtab[M_CAMPI];    //Lunghezze delle 50 colonne a video
 int lenSHtab[M_CAMPI];    //Lunghezze delle 50 colonne in stampa
 int lenCMPtab[M_CAMPI];   //Lunghezze del   CAMPO 0=TUTTO
 int m_ordine;        //Numero colonna di ordinamento
 int m_tipord;        //0=Crescente 1=Decrescente
 int flgImm[M_CAMPI]; //0=Immissione non consentita 1=Si
 int flgREQ[M_CAMPI]; //1=Immssissione su un campo chiave
                      //  di conseguenza  necessario
 int flgTipo[M_CAMPI]; //0=Striga 1=Numero 2=data
 int flgDec[M_CAMPI];  //0=Nessun decimale
                      //  ridisegnare tutto. 
 CString *m_campi[M_CAMPI]; //Array dei puntatori ai campi 
 public:
 

 //Costruttore 
 Intestatab(){
  int k=0;
  n_col=0;
  m_tipord=0;
  m_ordine=0;
  for(k=0;k<M_CAMPI;k++){
   strcpy(szHtab[k],"");
   lenVHtab[k]=0;
   lenSHtab[k]=0;
   lenCMPtab[k]=0;
   flgImm[k]=0; 
   setFlgREQ(k,0);
   m_campi[k]=NULL;
   setFlgTipo(k,0);
   setNDec(k,0);
  }
 }

 //Funzioni di accesso
 int getnumcol(){return n_col;}
 int getFlgImm(int col){return flgImm[col];}
 int getFlgREQ(int col){return flgREQ[col];}
 int getFlgTipo(int col){return flgTipo[col];}
 int getNDec(int col){return flgDec[col];}
 int getlargcolV(int col){return lenVHtab[col];}
 int getlargcolS(int col){return lenSHtab[col];}
 int getlargcmp(int col){return lenCMPtab[col];}
 int getorder(){return m_ordine;}
 int gettipord(){return m_tipord;}
 char* getdesccol(int col){return szHtab[col];}
 CString getCampo(int ncampo){ return ((*(CString *)m_campi[ncampo]));}
 CString* getPCampo(int ncampo){ return ((CString *)m_campi[ncampo]);}

 void setCampo(int ncampo,CString *p){ m_campi[ncampo]=p;}
 void setFlgImm(int col,int flg){flgImm[col]=flg;}
 void setFlgREQ(int col,int flg){flgREQ[col]=flg;}
 void setFlgTipo(int col,int flg){flgTipo[col]=flg;}
 void setNDec(int col,int flg){flgDec[col]=flg;}
 void setorder(int ord){m_ordine=ord;}
 void settipord(int ord){m_tipord=ord;}
 void setnumcol(int ncol){n_col=ncol;}
 void setlargcolV(int col,int larg){lenVHtab[col]=larg;}
 void setlargcolS(int col,int larg){lenSHtab[col]=larg;}
 void setlargcmp(int col,int larg){lenCMPtab[col]=larg;}
 void setdesccol(int col, char* descr){strcpy(szHtab[col],descr);}
};

#endif