////////////////////////////////////////////
// Programma:       
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabVirtual.h 
// Storia:
// Data Creazione: 31/12/1999
// (c) SofTech di Germinara Francesco 
////////////////////////////////////////////

#include "stdafx.h"

#ifndef CLASS_CTabVirtual_INCLUDED
#define CLASS_CTabVirtual_INCLUDED

#include "qtHead.h"

//
/////////////////////////////////////////////////////////////////////////////
class CTabVirtual : public CRecordset
{
public:
	CTabVirtual(CDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CTabVirtual)
 
    CDatabase *m_pDB; //Puntatore al Database aperto

    CString m_strElePriv[5]; //Elenco descrizioni privilegio utente

// Campi
	CString m_codute;
	CString m_nome;
	CString m_cogn;
	CString m_flgpw;
	CString m_pw;
	CString m_pl;
	CString m_email;
	CString m_exchangedn;
//Fine Elenco Campi della tabella di database --- 

//Lunghezze dei campi
	int m_len_codute;
	int m_len_nome;
	int m_len_cogn;
	int m_len_flgpw;
	int m_len_pw;
	int m_len_pl;
	int m_len_email;
	int m_len_exchangedn;
//Fine Elenco Variabili per dimensione campi della tabella di database --- 

	public:

	//Funzioni di accesso alla tabella del database
	virtual CString GetDefaultConnect(); 
	virtual CString GetDefaultSQL(); 	
	virtual void DoFieldExchange(CFieldExchange* pFX);	

	//Funzioni Standard implementate su ciascuna Tabella

    //Restituisce il numero di record nella tabella
	virtual long int Count(CString filtro=""); 
    
	//Riempio ListBox per visualizzazione
    virtual int MakeList(CListCtrl *m_listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro="");

    //Trova il record indicato
	int LoadDati(CString& codute); 

	//Inserisce/Varia record di dato
    int Insert(
	 CString& codute,
	 CString& nome,
	 CString& cogn,
	 CString& flgpw,
	 CString& pw,
	 CString& pl,
	 CString& email,
	 CString& exchangedn
	); 

	//Cancella Singolo Record
    int DeleteRec(CString& codute);

	//Cancello Tutto
	int DeleteAll();

    //Esportazione dati in file ASCII
    void Export(CProgressCtrl *progBar);
    
	//Importazione dati da file ASCII
    void Import(CProgressCtrl *progBar);

	//Apertura File per la stampa
    virtual int OpenRecordSet(qtHead *m_inttab,CString filtro="");
	
	//Riempio una riga con il record corrente
	virtual int GetRecordForDispInfo(CListCtrl *m_qtListCtrl,LVITEM* pItem);

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
#endif

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 1999