////////////////////////////////////////////
// Per NT 4.00 e Successive
// Realizzato da: Francesco Germinara
// CBseData.h:  Gestione Operazioni su Date/Ore
// Storia:
// Data Creazione: 01.03.1999
// (c) Cerutti Sistemi Informativi S.r.l.
////////////////////////////////////////////

#ifndef CLASS_CBseData_INCLUDED
#define CLASS_CBseData_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CBseData
{
public:
 CString data; //Data in formato Stringa
 CString datar;//Data in formato di base  sempre aaaammgg
 CTime time;

 char ch_gg[3];  //Data in formato caratteri
 char ch_mm[3];
 char ch_aa[5];

 CString ora;  //Ora in formato Stringa
 char ch_ora[3]; //Ora in formato caratteri
 char ch_min[3];
 char ch_sec[3];

 int n_gg;     //Data in formato numerico
 int n_mm;
 int n_aa;

 int n_ora;    //Ora in formato numerico
 int n_min;
 int n_sec;

public:
 CBseData();

// Attributes
public:
 void MkStrData(char *gg,char *mm,char *aa); 
 void MkStrData(int   gg,int  mm,int aa); 
 void ScomponiData(); //Scompone la data nelle singole parti

 void MkStrOra(char *hh,char *mm,char *ss); 
 void MkStrOra(int   hh,int  mm,int ss); 
 void ScomponiOra(); //Scompone l'ora nelle sinole parti
 void SetDataAAAAMMGG();  //Imposta la data nel formato AAAAMMGG
 void SetDataGGMMAAAA();  //Imposta la data nel formato GGMMAAAA
 void SetVisData();       //Imposta la data nel formato GG/MM/AAAA
 void Oggi();             //Imposta la data corrente e l'ora
 void SetDataR(CString str); //Imposta la datar
 void SetDataVis(CString dtVis); //Imposta la data usando GG/MM/AAAA
 void SetDataVisUsa(CString dtVis); //Imposta la data usando MM/GG/AAAA
 void SetOraHHMMSS(CString ora); //Imposta l'ora usando HH:MM:SS
};
#endif
//Fine
 
