////////////////////////////////////////////
// Per NT 4.00 e Successive
// Realizzato da: Francesco Germinara
// CBseInfo.h: Gestione Informazioni Generali Applicazione e Utenti
// Storia:
// Data Creazione:
// (c) SofTech di Germinara Francesco
////////////////////////////////////////////
// Classe Contentente le Informazioni di Base dell'applicazione

#include"stdafx.h"

//Operazioni che pu svolgere l'utente
#define BI_USR_INSERT   0
#define BI_USR_MODIFY   1
#define BI_USR_READ     2
#define BI_USR_DELETE   3
#define BI_USR_TRANSMIT 4
#define BI_USR_PRINT    5
#define BI_USR_DELETALL 6
#define BI_USR_EXIT     7

#define RC_SI  0
#define RC_NO  1
#define RC_ERR 2

#ifndef CLASS_CBseInfo_INCLUDED
#define CLASS_CBseInfo_INCLUDED
//
/////////////////////////////////////////////////////////////////////////////
class CBseInfo
{
//Membri
public:
	//Flags di impostazione Generale
    BOOL m_fInsRap;      //TRUE=Inserimento Rapido FALSE=CHIEDE CONFERMA
	BOOL m_fRegUsrLogon; //TRUE=Registro accessi al sistema
	BOOL m_fRegUsrOper;  //TRUE=Registro operazioni effettuate da utente

	CString m_strRegKey1; //Percorso della Chiave Nel REGISTRO DI CONFIGURAZIONE
	CString m_strRegKey2; //Percorso della Chiave Nel REGISTRO DI CONFIGURAZIONE SUBKEY
	CString m_strRegKey3; //Percorso della Chiave Nel REGISTRO DI CONFIGURAZIONE SUBKEY
	
	//Variabili dei percorsi
    CString m_strPathPrg;     //Percorso Programma
    CString m_strPathDati;    //Percorso Dati Vari
	CString m_strPathWord;    //Percorso WINWORD.EXE
	CString m_strPathExcel;   //Percorso EXCEL.EXE
    CString m_strPathWordDoc; //Percorso Documenti Word
	CString m_strPathExcelDoc;//Percorso Documenti Excel
	CString m_strPathImp;     //Importazione dati Tabelle
	CString m_strPathExp;     //Esportazione dati Tabelle
	CString m_strPathHTML;    //Percorso HTML
	CString m_strPathPRT;     //Percorso Files della Stampa
	CString m_strSrvPrtName;  //Nome del server di stampa (software) da utilizzare

 
    //Variabili di Informazioni Generali 
	int m_nPL;           //Livello di privilegio user: 0=Minimo 9=Massimo
	CString m_strCodUte; //Utente che sta eseguendo le operazioni
	CString m_strPWUte;  //PW dell'utente
	CString m_strIdTerm; //ID Terminale
	CString m_UsrNameLogon;   //Nome e Cognome Utente che ha effettuato logon
	CString m_InfoStsBarUser; //Stringa di visualizzazione in BARRA DI STATO NEL PANE USER INDICATOR
	CString m_tmUsrLogon;     //Data e Ora del Logon
	CString m_tmUsrLogoff;    //Data e Ora del Logoff

	//Operazioni Consentite all'utente
	BOOL m_fCanInsert;    //Puo' Creare
	BOOL m_fCanModify;    //Puo' Modificare
	BOOL m_fCanRead;      //Puo' Leggere
	BOOL m_fCanDelete;    //Puo' Cancellare
	BOOL m_fCanTX;        //Puo' Trasferire
	BOOL m_fCanPrint;     //Puo' Stampare
	BOOL m_fCanDeleteAll; //Puo' Cancellare Tutto
	BOOL m_fCanExit;      //Puo' Uscire 

	CString m_strTmLogo;  //Tempo Permanenza Logo Programma

	//Variabili del Database e impostazioni SQL
	CString m_strCONNECT;    //Stringa di connessione
	DWORD m_colorSfoDocConf; //Colore di Sfondo del Documento Conficurazione

//Funzioni
public:
	CBseInfo();                //Costruttore
    BOOL SetRegEdit();         //Imposta Chiavi in RegEdit
	BOOL GetRegEdit();         //Leggo   Chiavi in RegEdit
	void EnableUsrOperation(); //Controlla Livello di Priorita USR e Aggiorna Permessi USR
    void SetFlags(BOOL fCanInsert,BOOL fCanModify,BOOL fCanRead,BOOL fCanDelete,BOOL fCanTX,BOOL fCanPrint,BOOL fCanDeleteAll,BOOL fCanExit); //Imposta Flags
    BOOL IcanDO(int Operations); //TRUE se USR puo' compiere l'operazione richiesta
};
#endif

//Fine