// CDlgCfgCell.cpp : implementation file
// By Francesco Germinara (c) 2001 
// Da vedere problema quando arriva messaggio broadcast da nokia!!!
// Revisione del 15 ottobre 2001 - cambiate routine lettura/scrittura su seriale...
// Ultima revisione: 1/11/2001

#include "stdafx.h"
#include "FGSms.h"
#include "CDlgCfgCell.h"
#include "FGSmsDlg.h"
#include "CGsmAtCommand.h"
#include "table7bit.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define ERR_SMS_SEND_AT_CMGS 1
#define ERR_SMS_SENDING 2
#define ERR_SMS_SEND_OK_NO_CONFIRM 3
#define ERR_SMS_SEND_OK_NOT_DELIVERED 4
#define ERR_SMS_READ_AT_CMGL 5
#define ERR_SMS_READ_AT_CMCF 6
#define ERR_SMS_READ_TIME_OUT 7
#define ERR_SMS_DELETE_MSG 8

extern CFGSmsApp theApp;

extern long int htoi(CString hexValue);
/////////////////////////////////////////////////////////////////////////////
// CDlgCfgCell dialog

CDlgCfgCell::CDlgCfgCell(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCfgCell::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCfgCell)
	m_nConnectionType = 1;
	m_nDataBits = 1;
	m_nParityType = 1;
	m_nSerialPort = 0;
	m_nStopBits = 1;
	m_nBaudRate = 7;
	m_strNCentroServizi = _T("+393492000300");
	//}}AFX_DATA_INIT
    m_bComOk=FALSE;
	bFlashMode=FALSE;
}


void CDlgCfgCell::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCfgCell)
	DDX_CBIndex(pDX, IDC_CMB_CONN, m_nConnectionType);
	DDX_CBIndex(pDX, IDC_CMB_DATI, m_nDataBits);
	DDX_CBIndex(pDX, IDC_CMB_PARITY, m_nParityType);
	DDX_CBIndex(pDX, IDC_CMB_PORT, m_nSerialPort);
	DDX_CBIndex(pDX, IDC_CMB_STOP, m_nStopBits);
	DDX_CBIndex(pDX, IDC_CMB_VEL, m_nBaudRate);
	DDX_Text(pDX, IDC_EDT_SCSM, m_strNCentroServizi);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCfgCell, CDialog)
	//{{AFX_MSG_MAP(CDlgCfgCell)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgCell message handlers

HBRUSH CDlgCfgCell::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}


void CDlgCfgCell::OnOK(){
 TestPhoneComm();
 CDialog::OnOK();
}

void CDlgCfgCell::TestPhoneComm(){
 int sts=0,i=0;

 CString msgErr;
 CString strModel,strID,strSN,strRev,strBatInfo,strAlim("#N/A"),strStatoBat("#N/A"),strSignal("#N/A"),strBer("#N/A");
 CString strCommand,strResult,strErr,strCommandId;
 int nIndex=0;

 UpdateData(TRUE);

 OpenComPort();

 SendData("ATZ"); //Reset 
 strResult= ReceiveData();

 //TEST FOR CABLE CONNECTION AND PHONE CONNECTION
 strCommand=theApp.m_GsmAtCommands.GetCmd("GetModel",nIndex);
 sts=SendData(strCommand);
 if(sts){
  msgErr.Format("Errore(Send): Impossibile comunicare con il Cellulare/Modem su Com%d !",m_nSerialPort+1);
 }else{
  strResult= ReceiveData();
  CheckResult(strResult,strCommandId,strModel,strErr);
  if(strErr!="OK")
   msgErr.Format("Errore(Receive): Impossibile comunicare con il Cellulare/Modem su Com%d !",m_nSerialPort+1);
  else{
   SendSimpleCmdToPhone("IdentifyModem",strID);
   SendSimpleCmdToPhone("GetSerialNumber",strSN);
   SendSimpleCmdToPhone("GetRevisionId",strRev);
   SendSimpleCmdToPhone("GetBatteryStatus",strBatInfo);
   int pos=-1;
   pos=strBatInfo.Find(",",0);
   if(pos != -1){
    strAlim=strBatInfo.Mid(pos-1,1);
    switch(atoi(strAlim)){
     case 0: strAlim="solo batteria"; break; 
     case 1: strAlim="a rete fissa con batteria collegata "; break;
     case 2: strAlim="a rete fissa senza batteria collegata "; break;
     case 3: strAlim="ALLARME: PROBLEMI CON L'ALIMENTAZIONE!"; break;
    }
    strStatoBat="Rimane il ";
    strStatoBat+=strBatInfo.Mid(pos+1);
    strStatoBat+=" %";
   }
   SendSimpleCmdToPhone("GetSignal",strBatInfo);
   pos=strBatInfo.Find(",",0);
   if(pos != -1){
    strSignal=strBatInfo.Mid(pos-1,1);
    if(atoi(strSignal) >1 && atoi(strSignal) <31) 
     strSignal=" -109  a -53 dBm";
    else{
     switch(atoi(strSignal)){
      case  0: strSignal ="<= -113 dBm"; break;
      case  1: strSignal ="= -111 dBm"; break;
      case 31: strSignal =">= -51 dBm"; break;
      case 99: strSignal ="Non individuabile"; break;
     }
    }
    strBer=strBatInfo.Mid(pos+1);
    if(atoi(strBer)==99)
     strBer="#N/A";
   }
   msgErr.Format("Test di comunicazione superato su Com%d.\nTelefono Collegato Modello: %s\nIdentificativo: %s\nNumero di serie: %s\nRevisione Telefono: %s\nAlimentazione: %s\nStato Carica Batteria: %s\nSegnale: %s/%s",m_nSerialPort+1,strModel,strID,strSN,strRev,strAlim,strStatoBat,strSignal,strBer);
  }
 }
 CString msgTit;
 msgTit="Informazioni cellulare ";
 msgTit+=strModel;
 MessageBox(msgErr,msgTit);
 m_psiSerialPort->SetPortOpen(FALSE); //Close serial port
}

void CDlgCfgCell::OpenComPort(){
 CString msgErr;

 m_psiSerialPort	= &(((CFGSmsDlg *)theApp.m_pMainWnd)->m_siSerialPort);

 m_nConnectionType=theApp.m_nConnectionType;
 m_nDataBits=theApp.m_nDataBits;
 m_nParityType=theApp.m_nParityType;
 m_nSerialPort=theApp.m_nSerialPort;
 m_nStopBits=theApp.m_nStopBits;
 m_nBaudRate=theApp.m_nBaudRate;
 m_strNCentroServizi=theApp.m_strNCentroServizi;

 //Initialize serial port
 m_psiSerialPort->SetPortNumber(m_nSerialPort); //COM1 = 0
 m_psiSerialPort->SetBaudRate(m_nBaudRate+3); //Because start with minimum 1200bps
 m_psiSerialPort->SetParity(m_nParityType);
 m_psiSerialPort->SetWordLength(m_nDataBits+2); //Because use only 7 or 8 bits data
 m_psiSerialPort->SetStopBits(m_nStopBits);
 m_psiSerialPort->SetCardType(CardWinApi);
 m_psiSerialPort->SetCommTicks(CommTickMilliSecond);
 //m_psiSerialPort->SetIrq(10); 

 m_psiSerialPort->SetPortOpen(TRUE); //Open serial port
 m_bComOk=m_psiSerialPort->GetPortOpen(); //Check status 
 if(!m_bComOk){
  msgErr.Format("Errore: Impossibile aprire la porta seriale Com%d con i valori indicati!",m_nSerialPort+1);
  MessageBox(msgErr);
 }
 Sleep(500L);
}

void CDlgCfgCell::CloseComPort(){
 m_psiSerialPort->SetPortOpen(FALSE); //Open serial port
 m_bComOk=FALSE; 
}


BOOL CDlgCfgCell::SendSimpleCmdToPhone(CString cmd,CString& result){
 CString strCommand,strResult,strValue,strErr,strCommandId;
 int sts=0;
 int nIndex=0;
 strCommand=theApp.m_GsmAtCommands.GetCmd(cmd,nIndex);
 sts=SendData(strCommand);
 if(!sts){
  strResult= ReceiveData();
  CheckResult(strResult,strCommandId,strValue,strErr);
 }
 if(strErr=="OK"){
  result=strValue;
  return TRUE;
 }
 return FALSE;
}

BOOL CDlgCfgCell::OnInitDialog() 
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


int CDlgCfgCell::SendSMS(CString PhoneNumber,CString MsgText,BOOL bUseFlashMode){
 //Len 
  CString strValue,strLenSMSC,fit,strFmtInt,strNCentroServ,strATCommand;
  CString strCommand,strResult,strErr,strCommandId,strPhoneNumber;
  CString strSMSCommand,strSMSoption,strLenPHNR,strTPPID,strTPDCS,strTPVP;
		
  int nRetry=0,sts=0;

		CString flgSts,strNumTelUser,strIdUser;

  PhoneNumber.TrimRight();

		strNumTelUser = PhoneNumber;

  MsgText.TrimRight();

  if(MsgText.GetLength() > 160){
   AfxMessageBox("Errore: Messaggio troppo lungo! %d",MsgText.GetLength());
   return ERR_SMS_SENDING;
  }


  bFlashMode=bUseFlashMode;

  int len=0,lenPH=0,lenOfPDU=0;
  double nValue=0.0;
  BOOL bFormatInt=FALSE;
  int status=0; //OK

  if(m_strNCentroServizi.GetAt(0)=='+'){
   bFormatInt=TRUE;
   fit=m_strNCentroServizi.Mid(1);
   m_strNCentroServizi=fit;
   strFmtInt="91";
  }else{
   bFormatInt=FALSE;
   strFmtInt="81";
  }
  len=m_strNCentroServizi.GetLength();
  if(len % 2){
   m_strNCentroServizi+="F";
  }

  strLenSMSC.Format("%02X",(m_strNCentroServizi.GetLength()/2)+1);

  TrasfSemiOct(m_strNCentroServizi,strNCentroServ);

  strCommand =strLenSMSC;
  strCommand+=strFmtInt;
  strCommand+=strNCentroServ;

  strSMSCommand="11"; //SMS-SUBMIT
  strSMSoption="00";  //TP-Message Reference
  lenOfPDU=0; 
  strCommand+=strSMSCommand;
  lenOfPDU++; 
  strCommand+=strSMSoption;
  lenOfPDU++; 

  if(PhoneNumber.GetAt(0)=='+'){
   bFormatInt=TRUE;
   fit=PhoneNumber.Mid(1);
   PhoneNumber=fit;
   strFmtInt="91";
  }else{
   bFormatInt=FALSE;
   strFmtInt="81";
  }
  lenPH=PhoneNumber.GetLength();
  strLenPHNR.Format("%02X",lenPH);
  if(lenPH % 2){
   PhoneNumber+="F";
  }
  
  TrasfSemiOct(PhoneNumber,strPhoneNumber);

  lenOfPDU+=(lenPH/2); 

  strCommand+=strLenPHNR;
  lenOfPDU++; 
  strCommand+=strFmtInt;
  lenOfPDU++; 

  strCommand+=strPhoneNumber;

  strTPPID="00";
  strCommand+=strTPPID; //TP-PID
  lenOfPDU++; 

  if(bFlashMode)
   strTPDCS="F0"; //F0= FLASH
  else
   strTPDCS="00"; //F0= FLASH
  strCommand+=strTPDCS; //TP-DCS
  lenOfPDU++; 

  strTPVP="FF";
  strCommand+=strTPVP; //TP-VP
  lenOfPDU++; 

  strCommand+=ConvTxtToBin(MsgText,lenOfPDU);

  nRetry=10;
  
  START_SEND:

  strATCommand.Format("AT+CMGS=%-d",lenOfPDU); 
  SendData(strATCommand);
  strResult= ReceiveData();
  CheckResult(strResult,strCommandId,strValue,strErr); 

  if(strValue!=">" || !strErr.IsEmpty()){
  //if(strErr!="OK"){ //Error... retry; 
   if(nRetry--){
	ReceiveData(); 
    goto START_SEND;
   }else{
	status=ERR_SMS_SEND_AT_CMGS;
   }
  }

  //Send MSG
  if(status==0){
				sts=theApp.m_pTabUserCopy->FindByNumTel(strNumTelUser);
				if(sts==RC_SI){
     strIdUser=theApp.m_pTabUserCopy->m_IdUser;
					CString nMsgSend,nMsgReceived;
     nMsgSend.Format("%10.0f",atof(theApp.m_pTabUserCopy->m_nMsgSend)+1);
					nMsgReceived.Format("%10.0f",atof(theApp.m_pTabUserCopy->m_nMsgReceived));
					theApp.m_pTabUserCopy->UpdateMsgCounter(strIdUser,nMsgSend,nMsgReceived);
				}else
					strIdUser="";


   SendData(strCommand);
   strResult= ReceiveData();
   CheckResult(strResult,strCommandId,strValue,strErr); 
   if(strErr == "ERROR")
    status=ERR_SMS_SENDING;
  }
  //Waiting for confirm ...
  nRetry=10;
  for(;;){
   nRetry--;
   Sleep(1000L);
   strResult= ReceiveData();
   if(!strResult.IsEmpty() || !nRetry)
    break;
  }
  if(!nRetry)
   status=ERR_SMS_SEND_OK_NO_CONFIRM;
  CheckResult(strResult,strCommandId,strValue,strErr); 
  if(strErr!="OK")
   status=ERR_SMS_SEND_OK_NOT_DELIVERED;


		CBseData dtConv;
		dtConv.Oggi();
		dtConv.SetDataAAAAMMGG();
 	flgSts="S";

		if(status==0)
 	 strID="ok,";
		else
 	 strID="KO,";

		if(bUseFlashMode)
			strID+="Flash";
		else
			strID+="SMS";

  theApp.m_pTabStoricoMsg->Insert(
        strID,
	       MsgText,
	       flgSts,
	       strNumTelUser,
	       dtConv.data,
	       dtConv.ora,
	       strIdUser
   );



  return status;
}


void CDlgCfgCell::TrasfSemiOct(CString PhoneNumber,CString& strPhoneNumber){
 int len=PhoneNumber.GetLength();
 strPhoneNumber="                    ";
 int i=0;
 for(i=0; i< len; i++){
  strPhoneNumber.SetAt(i+1,PhoneNumber.GetAt(i));
  i++;
  //PROVAif(i < len)
  strPhoneNumber.SetAt(i-1,PhoneNumber.GetAt(i));
 }
 strPhoneNumber.TrimRight();
}

//Octect defininition
union{
 struct{
  unsigned char b0:1;
  unsigned char b1:1;
  unsigned char b2:1;
  unsigned char b3:1;
  unsigned char b4:1;
  unsigned char b5:1;
  unsigned char b6:1;
  unsigned char b7:1;
 }b;
 unsigned char byte;
}oct,octNext;

CString CDlgCfgCell::ConvTxtToBin(CString MsgText,int& lenMsg){
 CString strResult,msgBitVal,strLenBytes;
 char bytesToSend[4096];
 unsigned char ch,chNext;
 CString hexByte;
 int len=0,i=0,lenBytes=0;

 MsgText.TrimRight();
 if(MsgText.GetLength()==0)
  return _T("");
 
 memset(bytesToSend,0x00,1023);

 //Convert double byte char
 MsgText=ConvDBchar(MsgText);

 len=MsgText.GetLength();

 int bitLeft=1,pos=0;

 ch=MsgText.GetAt(0);
 oct.byte=table7bit[ch];

 for(i=1;i<len;i++){
  chNext=MsgText.GetAt(i);
  octNext.byte=table7bit[chNext];

  if(bitLeft==1)
   oct.b.b7=octNext.b.b0;
  if(bitLeft==2){
   oct.b.b7=octNext.b.b1;
   oct.b.b6=octNext.b.b0;
  }
  if(bitLeft==3){
   oct.b.b7=octNext.b.b2;
   oct.b.b6=octNext.b.b1;
   oct.b.b5=octNext.b.b0;
  }
  if(bitLeft==4){
   oct.b.b7=octNext.b.b3;
   oct.b.b6=octNext.b.b2;
   oct.b.b5=octNext.b.b1;
   oct.b.b4=octNext.b.b0;
  }
  if(bitLeft==5){
   oct.b.b7=octNext.b.b4;
   oct.b.b6=octNext.b.b3;
   oct.b.b5=octNext.b.b2;
   oct.b.b4=octNext.b.b1;
   oct.b.b3=octNext.b.b0;
  }
  if(bitLeft==6){
   oct.b.b7=octNext.b.b5;
   oct.b.b6=octNext.b.b4;
   oct.b.b5=octNext.b.b3;
   oct.b.b4=octNext.b.b2;
   oct.b.b3=octNext.b.b1;
   oct.b.b2=octNext.b.b0;
  }
  if(bitLeft==7){
   oct.b.b7=octNext.b.b6;
   oct.b.b6=octNext.b.b5;
   oct.b.b5=octNext.b.b4;
   oct.b.b4=octNext.b.b3;
   oct.b.b3=octNext.b.b2;
   oct.b.b2=octNext.b.b1;
   oct.b.b1=octNext.b.b0;
  }
  ch=oct.byte;
  if(bitLeft != 8){ // ch != 0x00){
   hexByte.Format("%02X",(unsigned char) ch);
   bytesToSend[pos++]=hexByte.GetAt(0); //save byte
   bytesToSend[pos++]=hexByte.GetAt(1); //save byte
  }else
   bitLeft=0;

  octNext.byte = octNext.byte >> bitLeft;

  bitLeft++; //increment bits need for next octect
  if(bitLeft==9)
   bitLeft=1;

  //msgBitVal.Format("CH: %c Hex: %x Dec: %d Bin: %d %d %d %d   %d %d %d %d ",ch,ch,ch,oct.b.b7,oct.b.b6,oct.b.b5,oct.b.b4,oct.b.b3,oct.b.b2,oct.b.b1,oct.b.b0);
  //MessageBox(msgBitVal,"Bits",MB_OK);

  oct.byte=octNext.byte;

 }
 //Last byte
 if(bitLeft != 8){//if(oct.byte != 0x00){
  hexByte.Format("%02X",(unsigned char) oct.byte);
  bytesToSend[pos++]=hexByte.GetAt(0); //save byte
  bytesToSend[pos++]=hexByte.GetAt(1); //save byte
 }
 bytesToSend[pos]=0x00;

 lenBytes=(strlen(bytesToSend)/2);
 lenMsg+=lenBytes+1;
 strLenBytes.Format("%02X",len); //len
 strResult=strLenBytes;
 strResult+=bytesToSend;
 strResult+="\x1a"; //Close MSG
 return strResult;
}


//Convert double byte char
CString CDlgCfgCell::ConvDBchar(CString MsgText){
 CString strResult,fit;
 strResult=_T("");
 char newbytemsg[4096];
 memset(newbytemsg,0x00,1023);
 int len=MsgText.GetLength();
 int pos=0,i=0;
 unsigned char ch=0;
 for(i=0,pos=0; i < len; i++){
  ch=MsgText.GetAt(i);
  if(ch == 94  || ch == 123 || ch == 125 || ch == 92  || ch == 91  || ch == 126 || ch == 93  || ch == 124 || ch == 164){
   newbytemsg[pos++]=0x1b; //ESC
  }
  newbytemsg[pos++]=ch;
 }
 newbytemsg[pos]=0x00;
 strResult=newbytemsg;
 if(strResult.GetLength() > 160){
  fit=strResult.Mid(0,160);
  strResult=fit;
 }

 return strResult;
}

BOOL CDlgCfgCell::SetMemoryMsg(BOOL bSIM){
  CString strATCommand,strResult,strErr,strCommandId,strValue;
  if(bSIM)
   strATCommand="AT+CPMS=\"SM\",\"SM\",\"SM\""; 
  else
   strATCommand="AT+CPMS=\"ME\",\"ME\",\"SM\"";
  SendData(strATCommand);
  strResult= ReceiveData();
  CheckResult(strResult,strCommandId,strValue,strErr); 
  if(strErr=="OK")
   return 0;
  return 1; //Error
}


//Read SMS
int CDlgCfgCell::ReadSMS(CStringArray& saMsg,CStringArray& saID,CStringArray& saSTS,CStringArray& saTel,CStringArray& saDate,CStringArray& saTime,CStatic *pLabelOperSts){
 int sts=0;
 int nTimeOut=50;
 CString strATCommand,strResult,strErr,strCommandId,strValue;
 CString finalData;

 if(pLabelOperSts != NULL)
  pLabelOperSts->SetWindowText("Attendere prego, controllo nuovi messaggi...");

  //SET PDU mode
  strATCommand="AT+CMGF=0"; 
  SendData(strATCommand);
  strResult= ReceiveData();
  CheckResult(strResult,strCommandId,strValue,strErr); 
  if(strErr=="OK"){
   //Send Get List of all message 
   strATCommand="AT+CMGL"; 
   SendData(strATCommand);
   strResult= ReceiveData();
   CheckResult(strResult,strCommandId,strValue,strErr); 
   if(strCommandId == strATCommand && strErr!="ERROR"){
	   finalData+=strResult;
    for(;;){
     nTimeOut--;
     Sleep(100L);
     strResult= ReceiveData();
	 finalData+=strResult;
     if((strResult.Find("OK")!=-1) || (!nTimeOut))
      break;
    }
   }else
	sts=ERR_SMS_READ_AT_CMGL;
  }else
   sts=ERR_SMS_READ_AT_CMCF;
  if(!nTimeOut){
   sts=ERR_SMS_READ_TIME_OUT;
			MessageBox("TimeOut");
		}



  //Parse Data 
  CString msg,strIdUser,flgSts;
		CBseData dtConv;
  for(;;){
   msg=GetMsgFromPDU(finalData);
   if(msg.IsEmpty())
    break;
   if(msg!="Stored"){
    if(pLabelOperSts != NULL)
     pLabelOperSts->SetWindowText("--"); //Stored
    if(pLabelOperSts != NULL)
     pLabelOperSts->SetWindowText("Messaggio N "+strID+" letto.");

				 dtConv.SetDataVis(strDate);
					dtConv.SetDataAAAAMMGG();
					strNumTel.TrimRight();
					sts=theApp.m_pTabUserCopy->FindByNumTel(strNumTel);
					if(sts==RC_SI){
      strIdUser=theApp.m_pTabUserCopy->m_IdUser;
						CString nMsgSend,nMsgReceived;
      nMsgSend.Format("%10.0f",atof(theApp.m_pTabUserCopy->m_nMsgSend));
						nMsgReceived.Format("%10.0f",atof(theApp.m_pTabUserCopy->m_nMsgReceived)+1);
						theApp.m_pTabUserCopy->UpdateMsgCounter(strIdUser,nMsgSend,nMsgReceived);
					}else
						strIdUser="";

					flgSts="R";
				 
     theApp.m_pTabStoricoMsg->Insert(
							 strID,
	       msg,
	       flgSts,
	       strNumTel,
	       dtConv.data,
	       strTime,
	       strIdUser
   );

    saMsg.Add(msg);
    saID.Add(strID);
    saSTS.Add(strSTS);
    saTel.Add(strNumTel);
    saDate.Add(strDate);
    saTime.Add(strTime);
	//Now delete msg on the phone
	DeleteSMS(strID);
    if(pLabelOperSts != NULL)
     pLabelOperSts->SetWindowText("Messaggio N "+strID+" cancellato.");
   }
  }
  //AfxMessageBox(finalData);
  if(pLabelOperSts != NULL)
   pLabelOperSts->SetWindowText("Operazione conclusa.");
 return sts;
}

CString CDlgCfgCell::GetMsgFromPDU(CString & finalData){
 CString idCmd,strAlpha,strPDUlen,fit,wrkStr;
 CString strResult(""),strSMSC,strPDU,sign,strNumTelTmp;
 CString strDateTmp,strTimeTmp,strMSGCode,strMsg;
 int pos=0,posFin=0,startPos=0,lenNumTel=0,strLenMsg=0,lenMsgCode=0;
 int lenSMSC=0,lenPH=0,lenEffective=0;
	strID="";
	strSTS="";
	strAlpha="";
 pos=finalData.Find(":",startPos);

 if(pos != -1){ //Ok, found response MSG
  posFin=finalData.Find(",",pos);
  if(posFin != -1){ //Get MSG ID 
   strID=finalData.Mid(pos+1,posFin-pos-1);
   pos=posFin+1;
  }
  posFin=finalData.Find(",",pos);
  if(posFin != -1){ //Get STATUS MSG
   strSTS=finalData.Mid(pos,posFin-pos);
   pos=posFin+1;
  }
  posFin=finalData.Find(",",pos);
  if(posFin != -1){ //Get ALPHA MSG
   strAlpha=finalData.Mid(pos,posFin-pos);
   pos=posFin+1;
  }
  posFin=finalData.Find("\x0d",pos);
  if(posFin != -1){ //Get LEN PDU MSG
   strPDUlen=finalData.Mid(pos,posFin-pos);
   pos=0;
  }

  lenMsgCode = atoi(strPDUlen) * 2;
  //Now Processing data 
  wrkStr=finalData.Mid(posFin+2);
  fit=wrkStr.Mid(0,2); //Len of SMSC Hex value 
  lenSMSC=htoi(fit)*2;
  strSMSC = wrkStr.Mid(2,lenSMSC);

  fit=finalData.Mid(posFin+2+lenSMSC);
  finalData=fit;


  //PDU Message
  strPDU=wrkStr.Mid(2+lenSMSC,(atoi(strPDUlen)*2));


  ASSERT(strPDU.GetLength() == (atoi(strPDUlen)*2));


//45FC384D2F0 3390010708050806200706136FB2D0F83C4F2F778FC66A7DD6F16E89C0E83E6F6F2999D7E837EA079585E168BCBA0BA1B642FCBDF2078793C0ED3DFA0B9BD7C66A7C3727A1A444E83E6617198FE06B5C3747ADA1D76B95C2EF71BF403B540E23CE87EBFBBCAF8719A5E76A5E9
  
  lenMsgCode-=2; //04
  sign="";
  wrkStr=strPDU.Mid(2,2); 
  lenMsgCode-=2; //Len of ntel
  lenNumTel=htoi(wrkStr);
  lenEffective=lenNumTel;

  if(lenNumTel % 2)
   lenNumTel++;

  strNumTelTmp = strPDU.Mid(6,lenNumTel);

  CString TypeOfAddress= strPDU.Mid(4,2);
  if(TypeOfAddress == "D0"){ //ALPHA
   strNumTel=ConvBinToTxt(strNumTelTmp);
  }else{
   TrasfSemiOct(strNumTelTmp,strNumTel);
   if(strPDU.Mid(4,2)=="91")
    sign="+";
   strNumTel=strNumTel.Mid(0,lenEffective);
   strNumTel=sign+strNumTel;
   lenMsgCode-=2; //prefix
  }

  lenMsgCode-=lenNumTel;

  lenMsgCode-=4;  //0000

  fit=finalData.Mid(6+lenNumTel+6);

  strDateTmp=fit.Mid(0,6);
  TrasfSemiOct(strDateTmp,strDate);
  strDateTmp=strDate;
  strDate=strDateTmp.Mid(4,2)+"/"+strDateTmp.Mid(2,2)+"/"+"20"+strDateTmp.Mid(0,2);

  strTimeTmp=fit.Mid(6,6);
  TrasfSemiOct(strTimeTmp,strTime);
  strTimeTmp=strTime;
  strTime=strTimeTmp.Mid(0,2)+":"+strTimeTmp.Mid(2,2)+":"+strTimeTmp.Mid(4,2);
  finalData=fit;
  lenMsgCode-=14; 

	  //posFin+(atoi(strPDUlen)*2));
  wrkStr=finalData.Mid(14,2);
  strLenMsg=htoi(wrkStr);
  lenMsgCode-=2; 

  fit=finalData.Mid(16);
  finalData=fit;

  strMSGCode=fit.Mid(0,lenMsgCode);

  strMsg=ConvBinToTxt(strMSGCode);
  
  strResult=strMsg;

  //STORED READ and STORED UNREAD are not implemented
  if(atoi(strSTS)==3 || atoi(strSTS)==2){
   fit=finalData.Mid(lenMsgCode);
   finalData=fit;

   strResult="Stored";
   strTime="";
   strDate="";
  }
 }else
  strResult="";
 return strResult;
}

//Convert string value in HEX to LONG INT
long int htoi(CString hexValue){
 int len=0;
 unsigned char ch;
 long int result=0L,val=0;
 len=hexValue.GetLength()-1;
 for(int i=len; i>=0; i--){ 
  ch=hexValue.GetAt(i);
  if((ch>='A' && ch <='F') || (ch>='0' && ch <='9')){
   if(ch>='A' && ch <='F')
    val = ch - '0' - 7;
   else
    val = ch - '0';
   result+=(long int)(val * pow(16,(len-i)));  
  }else
   return -1L; //Error...
 }
 return result;
}

CString CDlgCfgCell::ConvBinToTxt(CString MsgText){
 CString strResult,msgBitVal,strLenBytes;
 char bytesToSend[4096];
 unsigned char ch;
 CString hexByte;
 BOOL bExtCode=FALSE,bExit=FALSE;
 int len=0,i=0,lenBytes=0;

 MsgText.TrimRight();
 if(MsgText.GetLength()<=1)
  return _T("");
 
 memset(bytesToSend,0x00,1023);
 len=MsgText.GetLength();

 int pos=0,nBytes=0;
 int val=0;
 int bitLeft=1;

 hexByte=MsgText.Mid(pos,2);

 ch=(unsigned char) htoi(hexByte);
 oct.byte=ch;
 
 octNext.byte= ch;

 oct.byte= oct.byte  << bitLeft;
 oct.byte= oct.byte  >> bitLeft;
 ch=oct.byte;

  if(ch == 0x1b){ //ESC
   bExtCode=TRUE;
  }else{
   if(ch==0x00)
    bytesToSend[nBytes++]=64; //@
   else
    bytesToSend[nBytes++]=findtable7bit(ch);
  }

 pos+=2;
 for(;pos<=len;pos+=2){

 if(bitLeft==8){
   bitLeft=1;
   ch=octNext.byte << 1;
   ch=ch >> 1;
   if(ch == 0x1b){ //ESC
    bExtCode=TRUE;
    continue;
   }
   if(!bExtCode){
    if(ch==0x00)
     bytesToSend[nBytes++]=64; //@
	else
     bytesToSend[nBytes++]=findtable7bit(ch);
   }else{
    bytesToSend[nBytes++]=findtable7bitExt(ch);
    bExtCode=FALSE;
   }
  }

  hexByte=MsgText.Mid(pos,2);
  if(hexByte.IsEmpty())
   bExit=TRUE;
  ch=(unsigned char) htoi(hexByte);
  oct.byte=ch;

  oct.byte= oct.byte << bitLeft;

  if(bitLeft==1){
   oct.b.b0=octNext.b.b7;
  }
  if(bitLeft==2){
   oct.b.b1=octNext.b.b7;
   oct.b.b0=octNext.b.b6;
  }
  if(bitLeft==3){
   oct.b.b2=octNext.b.b7;
   oct.b.b1=octNext.b.b6;
   oct.b.b0=octNext.b.b5;
  }
  if(bitLeft==4){
   oct.b.b3=octNext.b.b7;
   oct.b.b2=octNext.b.b6;
   oct.b.b1=octNext.b.b5;
   oct.b.b0=octNext.b.b4;
  }
  if(bitLeft==5){
   oct.b.b4=octNext.b.b7;
   oct.b.b3=octNext.b.b6;
   oct.b.b2=octNext.b.b5;
   oct.b.b1=octNext.b.b4;
   oct.b.b0=octNext.b.b3;
  }
  if(bitLeft==6){
   oct.b.b5=octNext.b.b7;
   oct.b.b4=octNext.b.b6;
   oct.b.b3=octNext.b.b5;
   oct.b.b2=octNext.b.b4;
   oct.b.b1=octNext.b.b3;
   oct.b.b0=octNext.b.b2;
  }
  if(bitLeft==7){
   oct.b.b6=octNext.b.b7;
   oct.b.b5=octNext.b.b6;
   oct.b.b4=octNext.b.b5;
   oct.b.b3=octNext.b.b4;
   oct.b.b2=octNext.b.b3;
   oct.b.b1=octNext.b.b2;
   oct.b.b0=octNext.b.b1;
  }
  bitLeft++;

  octNext.byte=ch;
  oct.b.b7=0;
  ch=oct.byte;

  if(ch== 0x00 && bExit) //Ok, exit
   break;
   
  if(ch == 0x1b){ //ESC
   bExtCode=TRUE;
   continue;
  }
  if(!bExtCode){
   if(ch==0x00)
    bytesToSend[nBytes++]=64; //@
   else
    bytesToSend[nBytes++]=findtable7bit(ch);
  }else{
   bytesToSend[nBytes++]=findtable7bitExt(ch);
   bExtCode=FALSE;
  }
 }

 bytesToSend[nBytes]=0x00;

 strResult= bytesToSend;

 return strResult;
}

//Delete SMS 
int CDlgCfgCell::DeleteSMS(CString msgID){
 int sts=0;
 int nTimeOut=50;

 CString strATCommand,strResult,strErr,strCommandId,strValue;
 CString finalData;
 msgID.TrimLeft(); 
 strATCommand="AT+CMGD="+msgID; 

  SendData(strATCommand);
  Sleep(1000);
  strResult= ReceiveData();
  CheckResult(strResult,strCommandId,strValue,strErr); 
  if(strValue!="OK"){
   sts=ERR_SMS_DELETE_MSG;
  }

 return sts;
}

/* ORIGINAL VERSION 
//Invia un comando Dati
BOOL CDlgCfgCell::SendData(CString strCmd){
 //m_psiSerialPort->FlushRxBuffer();
 m_psiSerialPort->FlushTxBuffer();
 int i=0;
 BOOL sts=FALSE;
 CString strCommand,strTerm("\x0d"); //\x0d \x0a
 strCommand=strCmd+strTerm;
 int len=strCommand.GetLength();
 for(i=0;i<len;i++){
  sts=m_psiSerialPort->PutByte(strCommand.GetAt(i));
  if(sts==FALSE)
   break;
 }
 if(i != len){
  CString msg;
  msg.Format("I= %d Len = %d",i,len);
  AfxMessageBox(msg);
  return TRUE;
 }

 return FALSE;
}

//Riceve Dati
CString CDlgCfgCell::ReceiveData(){
 CString strResult("");
 BOOL sts;
 unsigned char rxBuf[4096];
 short ch;
 memset(rxBuf,4096,0);
 int i=0;
 Sleep(100L);
 m_psiSerialPort->SetIOTimeOut(200);
 for(;;){
  sts=m_psiSerialPort->GetByte(&ch);
  if(!sts)
   break;
  rxBuf[i]=(unsigned char) ch;
  i++;
  if(i >= 4095)
   break;
 }
 rxBuf[i]='\0';

 strResult = (char *) rxBuf;
 return strResult;
}

*/

BOOL CDlgCfgCell::SendData(CString strCmd){
 m_psiSerialPort->FlushTxBuffer();
 int i=0;
 BSTR bstrStr;
 BOOL sts=FALSE;
 CString strCommand,strTerm("\x0d\x0a"); //\x0d \x0a

 strCommand=strCmd+strTerm;
 i=strCommand.GetLength();

 bstrStr = strCommand.AllocSysString();
 int len=m_psiSerialPort->PutString(&bstrStr);
 if(len != i){
  CString msg;
  msg.Format("Da Tx= %d -> Tx = %d",i,len);
  AfxMessageBox(msg);
  return TRUE;
 }
 return FALSE;
}


//Riceve Dati
CString CDlgCfgCell::ReceiveData(){
 CString strResult("");
 long nBytes=0L;
 int nRetry=10;
 BSTR bstr;
 BOOL bRead=FALSE;


 Sleep(300);
 for(;;){
  nBytes = m_psiSerialPort->GetBytesInReceiveBuffer();
  if( nBytes > 0L) {
   bRead=TRUE;
   break;
  }else{
   nRetry--;
   if(nRetry == 0){
	//MessageBox("Time-Out!");
	bRead=FALSE;
	break;
   }
   Sleep(100L);
  }
 }
 if(bRead){
  bstr=strResult.AllocSysString();
  nBytes = m_psiSerialPort->GetString(&bstr);
  if( nBytes > 0L) {
   strResult = bstr;
  ::SysFreeString(bstr);
   //MessageBox(strResult);
  }
 }
 return strResult;
}

void CDlgCfgCell::CheckResult(CString strResult,CString& strCmdId,CString& strValue,CString& strErr){
 int pos=0;
 CString fit;

 //Result code is: 
 //CMD \x0d | \x0d \x0a OK \x0d \x0a \x78//Like ATZ
 //CMD \x0d | \x0d \x0a RESULTDATA \x0d \x0a \x0d \x0a OK \x0d \x0a
 //     CR       |                       |

 strValue=_T(""); 
 strErr=_T(""); 
 strCmdId=_T(""); 

 pos=strResult.Find(0x0d,pos);
 if(pos!=-1){
  char test[4096];
  strcpy(test,strResult);
  strCmdId=strResult.Mid(0,pos);
  fit=strResult.Mid(pos+1);
  strResult=fit;
 }
 if(!strCmdId.IsEmpty()){

  if(strCmdId.Find("ATZ")!=-1) 
   strErr=GetStrVal(strResult);

  if(strCmdId.Find("AT+CMGR=")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("AT+CGMM")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("ATI")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("AT+GSN")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("AT+CGMR")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("AT+CBC")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("AT+CSQ")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }
  
  if(strCmdId.Find("AT+CMGS")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("AT+CMGF")!=-1){
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("AT+CMGD=")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("AT+CPMS")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  if(strCmdId.Find("AT+CMGL")!=-1){
   strValue=GetStrVal(strResult);
   strErr=GetStrVal(strResult);
  }

  //Check for command error 
  if(strValue.Find("+CMS ERROR") != -1 || strValue.Find("+CME ERROR") != -1){
   strErr=strValue;
   strValue=_T("");
  }
 }else{
  strValue=GetStrVal(strResult);
  strErr=GetStrVal(strResult);
 }
}

CString CDlgCfgCell::GetStrVal(CString& strResult){
 int posIni=0;
 int posFin=0;
 CString res,fit;

 posIni=strResult.Find(">",0);
 if(posIni != -1){
  res=">";
  strResult="";
 }

 posIni=strResult.Find(0x0a,0);
 if(posIni != -1){
  posFin=strResult.Find(0x0a,posIni+1);
  if(posFin != -1){
   res=strResult.Mid(posIni+1,posFin-posIni-2);
   fit=strResult.Mid(posFin+1);
   strResult=fit;
  }
 }
 return res;
}

//End
