// CDlgCfgFGSms.cpp : implementation file
//

#include "stdafx.h"
#include "FGSms.h"
#include "CDlgCfgFGSms.h"
#include "CDlgPWRequest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//La Classe Applicazione 
extern CFGSmsApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgFGSms dialog


CDlgCfgFGSms::CDlgCfgFGSms(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCfgFGSms::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCfgFGSms)
	m_bConfigurationEnable = FALSE;
	m_strWorkDir = _T("");
	m_strMemSharedName = _T("");
	m_strTmPolling = _T("");
	//}}AFX_DATA_INIT
}


void CDlgCfgFGSms::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCfgFGSms)
	DDX_Check(pDX, IDC_CHK_CFG, m_bConfigurationEnable);
	DDX_Text(pDX, IDC_EDT_DIRWORK, m_strWorkDir);
	DDX_Text(pDX, IDC_EDT_SHARMEM, m_strMemSharedName);
	DDX_Text(pDX, IDC_EDT_TMPOLL, m_strTmPolling);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCfgFGSms, CDialog)
	//{{AFX_MSG_MAP(CDlgCfgFGSms)
	ON_BN_CLICKED(IDC_BTN_BROWSE, OnBtnBrowse)
	ON_BN_CLICKED(IDC_CHK_CFG, OnChkCfg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgFGSms message handlers

void CDlgCfgFGSms::OnBtnBrowse() 
{
 char BASED_CODE szInputFilter[] = "Qualsiasi (*.*) |";
 CString m_strDest;
 UpdateData(TRUE);
 CFileDialog wndInputFileDlg ( TRUE, NULL, "*.*", OFN_LONGNAMES | OFN_EXPLORER | OFN_NOVALIDATE | OFN_NOCHANGEDIR, szInputFilter );
 SetCurrentDirectory(m_strWorkDir);
 if(wndInputFileDlg.DoModal () == IDOK ){
  m_strDest=wndInputFileDlg.GetPathName();

  //Elimino estensione del file, in modo da recuperare solo il percorso
  int len=m_strDest.GetLength();
  for(int i=len-1; i>0; i--){
   if(m_strDest.GetAt(i)=='\\' && i+1<len){ 
    m_strDest.SetAt(i+1,'\0');
    break;
   }
  }
  m_strWorkDir=m_strDest;
  UpdateData(FALSE);
 }
}

void CDlgCfgFGSms::OnChkCfg() 
{
 UpdateData(TRUE);
 if(m_bConfigurationEnable){
  //Check for password
  CDlgPWRequest dlgPWRequest(this);
  if(dlgPWRequest.DoModal()==IDOK && dlgPWRequest.m_strPW==theApp.m_PassWordCfg){
   //NOP
  }else{
   MessageBox("Password errata!","Errore di accesso",MB_OK);
   m_bConfigurationEnable=FALSE;
   UpdateData(FALSE);
  }
 }
}
