// CDlgCfgUtenti.cpp : implementation file
//

#include "stdafx.h"
#include "FGSms.h"
#include "CDlgCfgUtenti.h"
#include "CBseData.h"

//La Classe Applicazione 
extern CFGSmsApp theApp;

extern void MkNumEdit(CWnd *pWnd,CNumEdit *pCtrl,int idOldID, int idNewID,double dMin,double dMax,int nDec);
extern void MkDataEdit(CWnd *pWnd,CDatEdit *pCtrl,int idOldID, int idNewID);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgUtenti dialog


CDlgCfgUtenti::CDlgCfgUtenti(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCfgUtenti::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCfgUtenti)
	m_strUserID = _T("");
	m_strCognomeNome = _T("");
	m_strNumCellulare = _T("");
	m_strSrvPop3 = _T("");
	m_strSimNumero = _T("");
	m_strGGvalidita = _T("");
	m_strEmailAddr = _T("");
	m_strEmailPW = _T("");
	m_strFgsmsPW = _T("");
	m_bAbilitato = FALSE;
	m_bCanUseBatchCmd = FALSE;
	m_bCanDeleteMsg = FALSE;
	m_bCanUseScheduleCmd = FALSE;
	m_bSendConfirmSentMsg = FALSE;
	m_bUseFlashSMS = FALSE;
	m_bMakeCopyBeforeDeleteMsg = FALSE;
	m_bSendNotifyMsg = FALSE;
	m_bCMOnlyOne = FALSE;
	m_bCMShort = FALSE;
	m_bPMStandBy = FALSE;
	m_strGrp = _T("");
	m_strDescGrp = _T("");
	m_strMailAccount = _T("");
	m_strnBits = _T("");
	m_strnLpt = _T("");
	m_strMsgInviati = _T("");
	m_strMsgRicevuti = _T("");
	//}}AFX_DATA_INIT
 m_strnMsgSend= _T("0");
 m_strnMsgReceived= _T("0");
 m_strnLastValue= _T("0");

}


void CDlgCfgUtenti::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCfgUtenti)
	DDX_Control(pDX, IDC_EDT_LPT, m_edtnLpt);
	DDX_Control(pDX, IDC_EDT_BITS, m_edtnBits);
	DDX_Control(pDX, IDC_EDT_EMAILACCOUNT, m_edtMailAccount);
	DDX_Control(pDX, IDC_EDTGG, m_edtGG);
	DDX_Control(pDX, IDC_EDT_SIMNUM, m_edtSimNum);
	DDX_Control(pDX, IDC_EDT_POP3, m_edtPop3);
	DDX_Control(pDX, IDC_EDT_NUMCELL, m_edtNumCell);
	DDX_Control(pDX, IDC_EDT_NOME, m_edtCognNome);
	DDX_Control(pDX, IDC_EDT_ID, m_edtID);
	DDX_Control(pDX, IDC_EDT_GRP, m_edtGrp);
	DDX_Control(pDX, IDC_EDT_FGSMSPW, m_edtFGSMSPW);
	DDX_Control(pDX, IDC_EDT_EMAILPW, m_edtEmailPW);
	DDX_Control(pDX, IDC_EDT_EMAILADDR, m_edtEmailAddr);
	DDX_Control(pDX, IDC_CHK_STANDBY, m_chkStandBy);
	DDX_Control(pDX, IDC_CHK_SHORT, m_chkShort);
	DDX_Control(pDX, IDC_CHK_ONLY1, m_chkOnly1);
	DDX_Control(pDX, IDC_CHK_NOTIFY, m_chkNotify);
	DDX_Control(pDX, IDC_CHK_MKCOPY, m_chkMkCopy);
	DDX_Control(pDX, IDC_CHK_FLASH, m_chkFlash);
	DDX_Control(pDX, IDC_CHK_CONFIRM, m_chkConf);
	DDX_Control(pDX, IDC_CHK_CANSCHED, m_chkSched);
	DDX_Control(pDX, IDC_CHK_CAN_DEL, m_chkDel);
	DDX_Control(pDX, IDC_CHK_BATCH, m_chkBatch);
	DDX_Control(pDX, IDC_CHK_ABIL, m_chkAbil);
	DDX_Text(pDX, IDC_EDT_ID, m_strUserID);
	DDX_Text(pDX, IDC_EDT_NOME, m_strCognomeNome);
	DDX_Text(pDX, IDC_EDT_NUMCELL, m_strNumCellulare);
	DDX_Text(pDX, IDC_EDT_POP3, m_strSrvPop3);
	DDX_Text(pDX, IDC_EDT_SIMNUM, m_strSimNumero);
	DDX_Text(pDX, IDC_EDTGG, m_strGGvalidita);
	DDX_Text(pDX, IDC_EDT_EMAILADDR, m_strEmailAddr);
	DDX_Text(pDX, IDC_EDT_EMAILPW, m_strEmailPW);
	DDX_Text(pDX, IDC_EDT_FGSMSPW, m_strFgsmsPW);
	DDX_Check(pDX, IDC_CHK_ABIL, m_bAbilitato);
	DDX_Check(pDX, IDC_CHK_BATCH, m_bCanUseBatchCmd);
	DDX_Check(pDX, IDC_CHK_CAN_DEL, m_bCanDeleteMsg);
	DDX_Check(pDX, IDC_CHK_CANSCHED, m_bCanUseScheduleCmd);
	DDX_Check(pDX, IDC_CHK_CONFIRM, m_bSendConfirmSentMsg);
	DDX_Check(pDX, IDC_CHK_FLASH, m_bUseFlashSMS);
	DDX_Check(pDX, IDC_CHK_MKCOPY, m_bMakeCopyBeforeDeleteMsg);
	DDX_Check(pDX, IDC_CHK_NOTIFY, m_bSendNotifyMsg);
	DDX_Check(pDX, IDC_CHK_ONLY1, m_bCMOnlyOne);
	DDX_Check(pDX, IDC_CHK_SHORT, m_bCMShort);
	DDX_Check(pDX, IDC_CHK_STANDBY, m_bPMStandBy);
	DDX_Text(pDX, IDC_EDT_GRP, m_strGrp);
	DDX_Text(pDX, IDC_EDT_DESCGRP, m_strDescGrp);
	DDX_Text(pDX, IDC_EDT_EMAILACCOUNT, m_strMailAccount);
	DDX_Text(pDX, IDC_EDT_BITS, m_strnBits);
	DDX_Text(pDX, IDC_EDT_LPT, m_strnLpt);
	DDX_Text(pDX, IDC_EDT_NMSG_INV, m_strMsgInviati);
	DDX_Text(pDX, IDC_EDT_NMSG_RIC, m_strMsgRicevuti);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCfgUtenti, CDialog)
	//{{AFX_MSG_MAP(CDlgCfgUtenti)
	ON_BN_CLICKED(IDC_BTN_MODIFICA, OnBtnModifica)
	ON_BN_CLICKED(IDC_BTN_ELENCA, OnBtnElenca)
	ON_BN_CLICKED(IDC_BTN_STAMPA, OnBtnStampa)
	ON_BN_CLICKED(IDC_BTN_ELEGRP, OnBtnElegrp)
	ON_BN_CLICKED(IDC_BTN_REGISTRA, OnBtnRegistra)
	ON_BN_CLICKED(IDC_BTN_CANCELLA, OnBtnCancella)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgUtenti message handlers

void CDlgCfgUtenti::OnBtnModifica() 
{
 int sts=0;
 UpdateData(TRUE);

 m_strUserID.TrimRight();
 if(m_strUserID.IsEmpty())
  return;

 sts=theApp.m_pTabUser->LoadDati(m_strUserID);
 if(sts==RC_SI){ //Exist...
  CBseData bseData;
  bseData.SetDataR(theApp.m_pTabUser->m_ExpirationDate);
  m_nCost.m_Dato=theApp.m_pTabUser->m_CostOfService;
  bseData.SetVisData();
  m_EdtData.m_Dato = bseData.data;
  m_strCognomeNome = theApp.m_pTabUser->m_UsrName;
  m_strCognomeNome.TrimRight();
  m_strNumCellulare = theApp.m_pTabUser->m_phoneNumber;
  m_strNumCellulare.TrimRight();
  m_strSrvPop3 = theApp.m_pTabUser->m_mailPOP3svr;
  m_strSrvPop3.TrimRight();
  m_strSimNumero = theApp.m_pTabUser->m_phoneSIMNumber;
  m_strSimNumero.TrimRight();
  m_strGGvalidita = theApp.m_pTabUser->m_ChkReqDays;
  m_strGGvalidita.TrimRight();
  m_strEmailAddr = theApp.m_pTabUser->m_mailAddress;
  m_strEmailAddr.TrimRight();
  m_strEmailPW = theApp.m_pTabUser->m_mailPassword;
  m_strEmailPW.TrimRight();
  m_strMailAccount = theApp.m_pTabUser->m_mailAccount;
  m_strMailAccount.TrimRight();
  m_strFgsmsPW = theApp.m_pTabUser->m_phonePassword;
  m_strFgsmsPW.TrimRight();
  m_strGrp = theApp.m_pTabUser->m_UsrGrp;
  m_strGrp.TrimRight();

 	m_strMsgInviati = theApp.m_pTabUser->m_nMsgSend;
	 m_strMsgRicevuti = theApp.m_pTabUser->m_nMsgReceived;


  if(atoi(theApp.m_pTabUser->m_ServiceEnable))
   m_bAbilitato = TRUE;
  else
   m_bAbilitato = FALSE;

  if(atoi(theApp.m_pTabUser->m_STCanUseBatchCmd))
   m_bCanUseBatchCmd = TRUE;
  else
   m_bCanUseBatchCmd = FALSE;

  if(atoi(theApp.m_pTabUser->m_DMCanDeleteMsg))
   m_bCanDeleteMsg = TRUE;
  else
   m_bCanDeleteMsg = FALSE;

  if(atoi(theApp.m_pTabUser->m_STCanScheduleMsg))
   m_bCanUseScheduleCmd = TRUE;
  else
   m_bCanUseScheduleCmd = FALSE;

  if(atoi(theApp.m_pTabUser->m_PMSendConfirm))
   m_bSendConfirmSentMsg = TRUE;
  else
   m_bSendConfirmSentMsg = FALSE;

  if(atoi(theApp.m_pTabUser->m_CMFlashMode))
   m_bUseFlashSMS = TRUE;
  else
   m_bUseFlashSMS = FALSE;

  if(atoi(theApp.m_pTabUser->m_DMMakeCopyMsg))
   m_bMakeCopyBeforeDeleteMsg = TRUE;
  else
   m_bMakeCopyBeforeDeleteMsg = FALSE;

  if(atoi(theApp.m_pTabUser->m_CMNotifyEnable))
   m_bSendNotifyMsg = TRUE;
  else
   m_bSendNotifyMsg = FALSE;

  if(atoi(theApp.m_pTabUser->m_CMOnlyOne))
   m_bCMOnlyOne = TRUE;
  else
   m_bCMOnlyOne = FALSE;

  if(atoi(theApp.m_pTabUser->m_CMShortMode))
   m_bCMShort = TRUE;
  else
   m_bCMShort = FALSE;

  if(atoi(theApp.m_pTabUser->m_PMStandByMsg))
   m_bPMStandBy = TRUE;
  else
   m_bPMStandBy = FALSE;


  m_strnMsgSend= theApp.m_pTabUser->m_nMsgSend;
  m_strnMsgReceived= theApp.m_pTabUser->m_nMsgReceived;
  m_strnLastValue= theApp.m_pTabUser->m_nLastValue;

  m_strnLpt= theApp.m_pTabUser->m_nLpt;
  m_strnBits= theApp.m_pTabUser->m_nBits;

 }else
  CleanUp();
 UpdateData(FALSE);
 m_nCost.Refresh();
 m_EdtData.Refresh();
 EnableCtrl(FALSE);
}

void CDlgCfgUtenti::OnBtnElenca() 
{
 CString m_tipo;
 UpdateData(TRUE);
 int  c_len[50];
 char c_str[50][101];
 int sts=0;
 
 c_len[0]=80;
 c_len[1]=300;

 strcpy(c_str[0],"Identificatvo");
 strcpy(c_str[1],"Nome e Cognome  ");
 m_strFiltro="";
 m_pDlgVisElenco=new CDlgVisTabGenerica(theApp.m_pTabUser,2,c_len,c_str,"Utenti",this,m_strFiltro); 
 
 if(m_pDlgVisElenco->DoModal()==IDOK){
  m_strUserID=m_pDlgVisElenco->Codice;
  UpdateData(FALSE);
  OnBtnModifica();
 }
}

void CDlgCfgUtenti::OnBtnStampa() 
{
	// TODO: Add your control notification handler code here
	
}

void CDlgCfgUtenti::OnBtnElegrp() 
{
 CString m_tipo;
 UpdateData(TRUE);
 int  c_len[50];
 char c_str[50][101];
 int sts=0;
 
 c_len[0]=80;
 c_len[1]=220;
 c_len[2]=90;

 strcpy(c_str[0],"Gruppo");
 strcpy(c_str[1],"Descrizione");
 strcpy(c_str[2],"Costo servizio");
 m_strFiltro="";
 m_pDlgVisElenco=new CDlgVisTabGenerica(theApp.m_pTabGroup,3,c_len,c_str,"Gruppi Utenti",this,m_strFiltro); 
 
 if(m_pDlgVisElenco->DoModal()==IDOK){
  m_strGrp=m_pDlgVisElenco->Codice;
  sts=theApp.m_pTabGroup->LoadDati(m_strGrp);
  if(sts==RC_SI)
   m_strDescGrp =theApp.m_pTabGroup->m_Description;
  else
   m_strDescGrp ="";
  m_strDescGrp.TrimRight();
  UpdateData(FALSE);
 }
}



BOOL CDlgCfgUtenti::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_edtGG.SetLimitText(theApp.m_pTabUser->m_len_ChkReqDays);
	m_edtSimNum.SetLimitText(theApp.m_pTabUser->m_len_phoneSIMNumber);
	m_edtPop3.SetLimitText(theApp.m_pTabUser->m_len_mailPOP3svr);
	m_edtNumCell.SetLimitText(theApp.m_pTabUser->m_len_phoneNumber);
	m_edtCognNome.SetLimitText(theApp.m_pTabUser->m_len_UsrName);
	m_edtID.SetLimitText(theApp.m_pTabUser->m_len_IdUser);
	m_edtGrp.SetLimitText(theApp.m_pTabUser->m_len_UsrGrp);
	m_edtFGSMSPW.SetLimitText(theApp.m_pTabUser->m_len_phonePassword);
	m_edtEmailPW.SetLimitText(theApp.m_pTabUser->m_len_mailPassword);
	m_edtEmailAddr.SetLimitText(theApp.m_pTabUser->m_len_mailAddress);

	//Creo controlli personalizzati
	MkNumEdit(this,&m_nCost,IDC_EDT_COSTO,IDC_NEDT_COSTO,0.0,9999999.9999,4);
	m_nCost.m_Len=15;
	m_nCost.m_NumDec=4;

	MkDataEdit(this,&m_EdtData,IDC_EDT_DTSCAD,IDC_DEDT_DTSCAD);
	m_EdtData.Reset();

	EnableCtrl(TRUE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgCfgUtenti::OnBtnRegistra() 
{
	int sts=0;
 UpdateData(TRUE);

 m_strUserID.TrimRight();
 if(m_strUserID.IsEmpty())
  return;

 CBseData bseData;
 bseData.SetDataVis(m_EdtData.m_Dato);
 bseData.SetDataAAAAMMGG();

 m_strServiceEnable.Format("%1d",m_bAbilitato);
 m_strCanUseBatchCmd.Format("%1d",m_bCanUseBatchCmd);
 m_strCanDeleteMsg.Format("%1d",m_bCanDeleteMsg);
 m_strCanUseScheduleCmd.Format("%1d",m_bCanUseScheduleCmd);
 m_strSendConfirmSentMsg.Format("%1d",m_bSendConfirmSentMsg);
 m_strUseFlashSMS.Format("%1d",m_bUseFlashSMS);
 m_strMakeCopyBeforeDeleteMsg.Format("%1d",m_bMakeCopyBeforeDeleteMsg); 
 m_strSendNotifyMsg.Format("%1d",m_bSendNotifyMsg); 
 m_strCMOnlyOne.Format("%1d",m_bCMOnlyOne); 
 m_strCMShort.Format("%1d",m_bCMShort); 
 m_strPMStandBy.Format("%1d",m_bPMStandBy); 

 m_strCost.Format("%15.4f",atof(m_nCost.m_Dato)); 

	//Se non viene indicato il costo del utente...uso il costo del gruppo.
	if(atof(m_strCost) == 0.0){
		sts=theApp.m_pTabGroup->LoadDati(m_strGrp);
		if(sts==RC_SI)
   m_strCost.Format("%15.4f",atof(theApp.m_pTabGroup->m_CostOfService)); 
	}

 theApp.m_pTabUser->Insert(
  m_strUserID,
	 m_strCognomeNome,
	 m_strGrp,
	 m_strServiceEnable,
	 bseData.data,
	 m_strGGvalidita,
	 m_strEmailAddr,
	 m_strEmailPW,
	 m_strSrvPop3,
	 m_strNumCellulare,
	 m_strSimNumero,
	 m_strFgsmsPW,
	 m_strCMOnlyOne,
	 m_strCMShort,
	 m_strSendNotifyMsg,
	 m_strUseFlashSMS,
	 m_strPMStandBy,
	 m_strSendConfirmSentMsg,
	 m_strCanDeleteMsg,
	 m_strMakeCopyBeforeDeleteMsg,
	 m_strCanUseScheduleCmd,
	 m_strCanUseBatchCmd,
	 m_strCost,
	 m_strMailAccount,
  m_strnMsgSend,
  m_strnMsgReceived,
  m_strnLpt,
  m_strnBits,
  m_strnLastValue
 );

 CleanUp();
}


void CDlgCfgUtenti::CleanUp(){
	m_strCognomeNome = _T("");
	m_strNumCellulare = _T("");
	m_strSrvPop3 = _T("");
	m_strSimNumero = _T("");
	m_strGGvalidita = _T("");
	m_strEmailAddr = _T("");
	m_strEmailPW = _T("");
	m_strMailAccount= _T("");
	m_strFgsmsPW = _T("");
	m_bAbilitato = FALSE;
	m_bCanUseBatchCmd = FALSE;
	m_bCanDeleteMsg = FALSE;
	m_bCanUseScheduleCmd = FALSE;
	m_bSendConfirmSentMsg = FALSE;
	m_bUseFlashSMS = FALSE;
	m_bMakeCopyBeforeDeleteMsg = FALSE;
	m_bSendNotifyMsg = FALSE;
	m_bCMOnlyOne = FALSE;
	m_bCMShort = FALSE;
	m_bPMStandBy = FALSE;
	m_strGrp = _T("");
	m_strDescGrp = _T("");
	m_nCost.m_Dato="";
    m_nCost.Refresh();
    m_EdtData.Reset();
    m_EdtData.Refresh();

	UpdateData(FALSE);
	EnableCtrl(TRUE);
}

void CDlgCfgUtenti::EnableCtrl(BOOL sts){
	m_edtID.EnableWindow(sts);
	m_edtGG.EnableWindow(!sts);
	m_edtSimNum.EnableWindow(!sts);
	m_edtPop3.EnableWindow(!sts);
	m_edtNumCell.EnableWindow(!sts);
	m_edtCognNome.EnableWindow(!sts);
	m_edtGrp.EnableWindow(!sts);
	m_edtFGSMSPW.EnableWindow(!sts);
	m_edtEmailPW.EnableWindow(!sts);
	m_edtEmailAddr.EnableWindow(!sts);
	m_edtMailAccount.EnableWindow(!sts);
	m_chkStandBy.EnableWindow(!sts);
	m_chkShort.EnableWindow(!sts);
	m_chkOnly1.EnableWindow(!sts);
	m_chkNotify.EnableWindow(!sts);
	m_chkMkCopy.EnableWindow(!sts);
	m_chkFlash.EnableWindow(!sts);
	m_chkConf.EnableWindow(!sts);
	m_chkSched.EnableWindow(!sts);
	m_chkDel.EnableWindow(!sts);
	m_chkBatch.EnableWindow(!sts);
	m_chkAbil.EnableWindow(!sts);
	m_nCost.EnableWindow(!sts);
	m_EdtData.EnableWindow(!sts);
	m_edtnLpt.EnableWindow(!sts);
	m_edtnBits.EnableWindow(!sts);

	GetDlgItem(IDC_BTN_ELEGRP)->EnableWindow(!sts);
	GetDlgItem(IDC_BTN_REGISTRA)->EnableWindow(!sts);
	GetDlgItem(IDC_BTN_MODIFICA)->EnableWindow(sts);
	GetDlgItem(IDC_BTN_CANCELLA)->EnableWindow(!sts);
}

void CDlgCfgUtenti::OnBtnCancella() 
{
  UpdateData(TRUE);

  m_strUserID.TrimRight();
  if(m_strUserID.IsEmpty())
   return;

  theApp.m_pTabUser->DeleteRec(m_strUserID);

  CleanUp();
	
}
