// CDlgWriteSMS.cpp : implementation file
//

#include "stdafx.h"
#include "FGSms.h"
#include "CDlgWriteSMS.h"
#include "CDlgCfgCell.h"

extern CFGSmsApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgWriteSMS dialog


CDlgWriteSMS::CDlgWriteSMS(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgWriteSMS::IDD, pParent)
{
	nMaxChar=160;

	//{{AFX_DATA_INIT(CDlgWriteSMS)
	m_strMsgText = _T("");
	m_strPhoneNumber = _T("");
	m_stsEsito = _T("");
	m_stsIDSendTo = _T("");
	//}}AFX_DATA_INIT
	m_nFlashMSG=FALSE;
	m_stsCharacterToLeft.Format("%3d",nMaxChar);
	m_strGrp="";
}


void CDlgWriteSMS::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgWriteSMS)
	DDX_Text(pDX, IDC_EDT_TXT, m_strMsgText);
	DDX_Text(pDX, IDC_EDT_NUMTEL, m_strPhoneNumber);
	DDX_Text(pDX, IDC_STS_NCHAR, m_stsCharacterToLeft);
	DDX_Text(pDX, IDC_STS_ESITO, m_stsEsito);
	DDX_Text(pDX, IDC_STS_ID, m_stsIDSendTo);
	//}}AFX_DATA_MAP
	DDX_Check(pDX, IDC_CHK_FLASH, m_nFlashMSG);
}


BEGIN_MESSAGE_MAP(CDlgWriteSMS, CDialog)
	//{{AFX_MSG_MAP(CDlgWriteSMS)
	ON_BN_CLICKED(IDC_BTN_SELUTE, OnBtnSelute)
	ON_BN_CLICKED(IDC_BTN_SEND, OnBtnNewSend)
	ON_EN_CHANGE(IDC_EDT_TXT, OnChangeEdtTxt)
	ON_BN_CLICKED(IDC_BTN_GRP, OnBtnGrp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgWriteSMS message handlers

void CDlgWriteSMS::OnBtnSelute() 
{
 CString m_tipo;
 UpdateData(TRUE);
 int  c_len[50];
 char c_str[50][101];
 int sts=0;
 CString strUserID;
 
 c_len[0]=80;
 c_len[1]=300;

 strcpy(c_str[0],"Identificatvo");
 strcpy(c_str[1],"Nome e Cognome  ");
 m_strFiltro="";
 m_pDlgVisElenco=new CDlgVisTabGenerica(theApp.m_pTabUser,2,c_len,c_str,"Utenti",this,m_strFiltro); 
 
 if(m_pDlgVisElenco->DoModal()==IDOK){
  strUserID=m_pDlgVisElenco->Codice;
  sts=theApp.m_pTabUser->LoadDati(strUserID);
  if(sts==RC_SI){
   m_strPhoneNumber = theApp.m_pTabUser->m_phoneNumber;
   m_strPhoneNumber.TrimRight();
   m_stsIDSendTo=theApp.m_pTabUser->m_UsrName;
   m_stsIDSendTo.TrimRight();
   m_strGrp="";
  }
  UpdateData(FALSE);
 }
}

void CDlgWriteSMS::OnBtnSend() 
{
 CString strRes;
 CDlgCfgCell dlgCfgCell(this);
 int sts=0;
 UpdateData(TRUE);
 dlgCfgCell.OpenComPort();

 //dlgCfgCell.SendSimpleCmdToPhone("GetModel",strRes);
 //AfxMessageBox(strRes);

 m_strMsgText.TrimRight();
 sts=dlgCfgCell.SendSMS(m_strPhoneNumber,m_strMsgText,m_nFlashMSG);
 dlgCfgCell.CloseComPort();

 if(!sts)
  m_stsEsito="Inviato";
 else
  m_stsEsito="Errore";
 UpdateData(FALSE);
}

void CDlgWriteSMS::OnChangeEdtTxt() 
{
	UpdateData(TRUE);
	int len=m_strMsgText.GetLength();
	m_stsCharacterToLeft.Format("%3d", nMaxChar - len);
	m_stsEsito="";
	UpdateData(FALSE);
}

BOOL CDlgWriteSMS::OnInitDialog() 
{
	CDialog::OnInitDialog();

	((CEdit *)GetDlgItem(IDC_EDT_TXT))->SetLimitText(nMaxChar);

	m_strGrp="";
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgWriteSMS::OnBtnGrp() 
{
 CString m_tipo;
 UpdateData(TRUE);
 int  c_len[50];
 char c_str[50][101];
 int sts=0;
 
 c_len[0]=80;
 c_len[1]=220;
 c_len[2]=90;

 strcpy(c_str[0],"Gruppo");
 strcpy(c_str[1],"Descrizione");
 strcpy(c_str[2],"Costo servizio");
 m_strFiltro="";
 m_pDlgVisElenco=new CDlgVisTabGenerica(theApp.m_pTabGroup,3,c_len,c_str,"Gruppi Utenti",this,m_strFiltro); 
 
 if(m_pDlgVisElenco->DoModal()==IDOK){
  m_strGrp=m_pDlgVisElenco->Codice;
  sts=theApp.m_pTabGroup->LoadDati(m_strGrp);
  if(sts!=RC_SI)
   m_strGrp="";
  else{
   m_strPhoneNumber=m_strGrp;
   m_strPhoneNumber.TrimRight();
   UpdateData(FALSE);
  }
 }
}


void CDlgWriteSMS::OnBtnNewSend() 
{

 GetDlgItem(IDC_BTN_SEND)->EnableWindow(FALSE);
 GetDlgItem(IDCANCEL)->EnableWindow(FALSE);
 GetDlgItem(IDC_BTN_SELUTE)->EnableWindow(FALSE);

 CString strRes,PhoneNumber,qry,IDSendTo;
 int sts=0;
 UpdateData(TRUE);


 if(atof(m_strPhoneNumber)==0)
  m_strGrp=m_strPhoneNumber;

 m_strGrp.TrimRight();
 if(m_strGrp.IsEmpty() && atof(m_strPhoneNumber)>0){ //SINGOLO UTENTE
  PhoneNumber = m_strPhoneNumber;

  sts=theApp.m_pTabUser->FindByNumTel(PhoneNumber);
  if(sts==RC_SI){
   IDSendTo=theApp.m_pTabUser->m_UsrName;
   IDSendTo.TrimRight();
  }else
   IDSendTo="Sconosciuto";

  SendSMS(PhoneNumber,IDSendTo);
 }else{
  //Elenco Utenti del gruppo
  qry="SELECT * FROM CFGUSER WHERE UsrGrp='"+m_strGrp+"'";
  theApp.m_pTabUser->Open(CRecordset::dynamic,qry,CRecordset::none);
  if(theApp.m_pTabUser->IsOpen()){
   while(!theApp.m_pTabUser->IsEOF()){ 

    PhoneNumber = theApp.m_pTabUser->m_phoneNumber;
    PhoneNumber.TrimRight();

	IDSendTo = theApp.m_pTabUser->m_UsrName;
	IDSendTo.TrimRight();

	m_strPhoneNumber = PhoneNumber;


    SendSMS(PhoneNumber,IDSendTo);

	Sleep(100);

	theApp.m_pTabUser->MoveNext();
   }
   theApp.m_pTabUser->Close();
  }
 }

 GetDlgItem(IDC_BTN_SEND)->EnableWindow(TRUE);
 GetDlgItem(IDCANCEL)->EnableWindow(TRUE);
 GetDlgItem(IDC_BTN_SELUTE)->EnableWindow(TRUE);
 m_strGrp="";
}


void CDlgWriteSMS::SendSMS(CString PhoneNumber,CString IDSendTo){
 CString strRes;
 CDlgCfgCell dlgCfgCell(this);
 int sts=0;
 UpdateData(TRUE);
 dlgCfgCell.OpenComPort();

 //dlgCfgCell.SendSimpleCmdToPhone("GetModel",strRes);
 //AfxMessageBox(strRes);

 m_stsIDSendTo=IDSendTo;
 UpdateData(FALSE);

 m_strMsgText.TrimRight();
 sts=dlgCfgCell.SendSMS(PhoneNumber,m_strMsgText,m_nFlashMSG);
 dlgCfgCell.CloseComPort();

 if(!sts)
  m_stsEsito="Inviato";
 else
  m_stsEsito="Errore";
 UpdateData(FALSE);
}


BOOL CDlgWriteSMS::SendSMStoRecipient(CString recipient, CString msgText) 
{


 CString strRes,PhoneNumber,qry,IDSendTo;
	int nType=0; //0=Numero di telefono, 1=Singolo utente 2=Gruppo 3=Numero Telefono Sconosciuto
 int sts=0;
	BOOL status=false;

	recipient.TrimRight();

	nType=3;
	IDSendTo="Sconosciuto";

	//Cerco elementi...
 PhoneNumber = recipient;

 sts=theApp.m_pTabUser->FindByNumTel(PhoneNumber);
 if(sts==RC_SI){ //Ok, e' un numero di telefono di un utente di fgSMS...
  IDSendTo=theApp.m_pTabUser->m_UsrName;
  IDSendTo.TrimRight();
		nType=0;
	}

	if(nType == 3){ //Provo a vedere se esiste come utente del sistema fgSMS...
  sts=theApp.m_pTabUser->LoadDati(recipient);
  if(sts==RC_SI){ //Ok, e' un utente di fgSMS...
   IDSendTo=theApp.m_pTabUser->m_UsrName;
   IDSendTo.TrimRight();
			PhoneNumber = theApp.m_pTabUser->m_phoneNumber;
			PhoneNumber.TrimRight();
	 	nType=1;
	 }else{ //Provo a vedere se  un gruppo...
   m_strGrp=recipient;
   //Elenco Utenti del gruppo
   qry="SELECT * FROM CFGUSER WHERE UsrGrp='"+m_strGrp+"'";
   theApp.m_pTabUser->Open(CRecordset::dynamic,qry,CRecordset::none);
   if(theApp.m_pTabUser->IsOpen()){
    if(!theApp.m_pTabUser->IsEOF())
					nType=2;
				theApp.m_pTabUser->Close();
			}
		}
	}

 //ok, try to send...

	if(nType==0 || nType==1 || nType == 3){
	 status=SendSMSNoDialog(PhoneNumber,IDSendTo,msgText);
	}else{
		m_strGrp=recipient;
  //Elenco Utenti del gruppo
  qry="SELECT * FROM CFGUSER WHERE UsrGrp='"+m_strGrp+"'";
  theApp.m_pTabUser->Open(CRecordset::dynamic,qry,CRecordset::none);
  if(theApp.m_pTabUser->IsOpen()){
   while(!theApp.m_pTabUser->IsEOF()){ 
    PhoneNumber = theApp.m_pTabUser->m_phoneNumber;
    PhoneNumber.TrimRight();
   	IDSendTo = theApp.m_pTabUser->m_UsrName;
	   IDSendTo.TrimRight();
    status=SendSMSNoDialog(PhoneNumber,IDSendTo,msgText);
				if(status!=0)
					break;
    Sleep(500);
   	theApp.m_pTabUser->MoveNext();
   }
   theApp.m_pTabUser->Close();
  }
 }
	return status;
}


BOOL CDlgWriteSMS::SendSMSNoDialog(CString PhoneNumber,CString IDSendTo,CString msgText){
 CString strRes;
 CDlgCfgCell dlgCfgCell(this);
 BOOL sts=0;

 dlgCfgCell.OpenComPort();

 // to log ... IDSendTo;

 msgText.TrimRight();
 sts=dlgCfgCell.SendSMS(PhoneNumber,msgText,false);
 dlgCfgCell.CloseComPort();
 return sts;
}
