//Definition on standard GSM AT MODEM COMMAND BY Francesco Germinara (c) 2001
//20/04/2001

#include"stdafx.h"
#include"CGsmAtCommands.h"

//Contructor
CGsmAtCommands::CGsmAtCommands(){
 m_nNumOfCmd=0;
}

//Destructor
CGsmAtCommands::~CGsmAtCommands(){
 for(int i=0; i< m_nNumOfCmd; i++)
  delete m_pCGsmAtCommands[i];
}

int CGsmAtCommands::SetupCommands(){
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("Attention"),_T("AT"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("Dial"),_T("ATD"),_T("%s"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("Answer"),_T("ATA"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("Hangup"),_T("ATH"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GSMHangup"),_T("AT+CHUP"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GetSignal"),_T("AT+CSQ"),_T(""),_T(""),_T(""),_T(""),_T("%2d"),_T("%2d"),_T(""),_T(""));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GetPhoneBookIndex"),_T("AT+CPBR=?"),_T(""),_T(""),_T(""),_T(""),_T("%3d"),_T("%3d"),_T(""),_T(""));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GetPhoneBookEntry"),_T("AT+CPBR="),_T("%3d"),_T("%3d"),_T(""),_T(""),_T("%3d"),_T("%s"),_T("%s"),_T("%s"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("WriteRegisterS"),_T("ATS"),_T("%2d"),_T("="),_T("%s"),_T(""),_T(""),_T(""),_T(""),_T(""));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("ReadRegisterS"),_T("ATS"),_T("%2d"),_T("=?"),_T(""),_T(""),_T(""),_T(""),_T(""),_T(""));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("Reset"),_T("ATZ"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("LoadFactorySetting"),_T("AT&F"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("SetErrorControl"),_T("AT\\N"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("LoadFactorySetting"),_T("AT&F"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("EchoOn"),_T("ATE1"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("EchoOff"),_T("ATE0"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("Echo"),_T("ATE"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("ResultCodeFormat"),_T("ATV"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("ResultCodeResponse"),_T("ATQ"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("ErrCorrSpeedReport"),_T("ATW"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("ExtendedResulCode"),_T("ATX"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("RTSCTSOptions"),_T("AT&R"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("DCDOptions"),_T("AT&C"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("DSROptions"),_T("AT&S"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("DTROptions"),_T("AT&D"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("ReqManufacturedId"),_T("AT+CGMI"),_T(""),_T("%s"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GetBatteryStatus"),_T("AT+CBC"),_T(""),_T(""),_T(""),_T(""),_T("%1d"),_T("%3d"),_T(""),_T(""));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GetModel"),_T("AT+CGMM"),_T(""),_T("%s"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("IdentifyModem"),_T("ATI"),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GetRevisionId"),_T("AT+CGMR"),_T(""),_T("%s"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GetSerialNumber"),_T("AT+GSN"),_T(""),_T("%s")); 
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GetMessageFormat"),_T("AT+CMGF=?"),_T(""),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("SetMessageFormat"),_T("AT+CMGF="),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("SetMessageFormatText"),_T("AT+CMGF=1"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("SetMessageFormatHex"),_T("AT+CMGF=0"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("DeleteMessage"),_T("AT+CMGD="),_T("%3d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("GetErrorMessage"),_T("AT+CMEE?"),_T(""),_T("%3d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("SetErrorMessageMode"),_T("AT+CMEE="),_T("%1d"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("ListMessage"),_T("AT+CMGL"),_T(""),_T("%s"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("ListMessageStat"),_T("AT+CMGL="),_T("%s"),_T("%s"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("ReadMessage"),_T("AT+CMGR="),_T("%d"),_T("%s"));
 m_pCGsmAtCommands[m_nNumOfCmd++]=new CGsmAtCommand(_T("SendMessage"),_T("AT+CMGS="),_T("%d"),_T("%s"));

 return m_nNumOfCmd;
}

//Return the name of command and the numeric index of command
CString CGsmAtCommands::LookUpCmd(CString code,int& nIndex){

 for(nIndex=0; nIndex < m_nNumOfCmd; nIndex++){
  if(code == m_pCGsmAtCommands[nIndex]->GetCode())
   return m_pCGsmAtCommands[nIndex]->GetName();
 }
 nIndex=-1; //Error
 return _T("");
}

//Return the complete string to send and the numeric index of command
CString CGsmAtCommands::GetCmd(CString name,int& nIndex){
 CString strCmd;

 for(nIndex=0; nIndex < m_nNumOfCmd; nIndex++){
  if(name == m_pCGsmAtCommands[nIndex]->GetName()){
   strCmd=m_pCGsmAtCommands[nIndex]->GetCode();
   strCmd+=m_pCGsmAtCommands[nIndex]->GetEndCode();
   return strCmd;
  }
 }
 nIndex=-1; //Error
 return _T("");
}

//Return the complete string to send	
CString CGsmAtCommands::GetCmd(int nIndex){
 CString strCmd;
 if(nIndex >= 0 && nIndex < m_nNumOfCmd){
  strCmd=m_pCGsmAtCommands[nIndex]->GetCode();
  strCmd+=m_pCGsmAtCommands[nIndex]->GetEndCode();
  return strCmd;
 }
 return _T("");
}

//Return ptr of command object
CGsmAtCommand *CGsmAtCommands::GetPtrCmd(int nIndex){
 if(nIndex >= 0 && nIndex < m_nNumOfCmd)
  return m_pCGsmAtCommands[nIndex];
 return NULL;
}
//End