//Classe per Edit di Soli Numeri

#if !defined(CNUMEDIT_H)
#define CNUMEDIT_H

class CNumEdit : public CEdit
{
 private:

 public:
 int m_pos_cur;    //Posizione del cursore durante l'immissione dati
 int m_cxChar; 
 int m_cyChar; 
 int m_Len; //Lunghezza massima del campo

 CString strLeft;
 CString strRight;
 
 CNumEdit();
 CString m_Dato;   //Valore Immesso da Utente
 double  m_LimMin; //Limite Minimo Consentito
 double  m_LimMax; //Limite Massimo Consentito
 double  m_Valore; //Valore Numerico Inserito
 int     m_NumDec; //Numero di Decimali consentito
 UINT m_ID;
 CPoint m_ptCaretPos;

 int GetNDec();    //Restituisce il numero di decimali
 BOOL IsBlank();   //Restituisce Vero se  tutto Blank
 void Refresh();   //Refresh a video del valore 
 BOOL IsNumValid();//Visualizza eventuale errore.
 BOOL IsValid(UINT nChar); //Controllo i caratteri digitati
 
 protected:
 afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
 afx_msg void OnKeyUp (UINT, UINT, UINT);
 afx_msg void OnSysKeyUp (UINT, UINT, UINT);
 afx_msg void OnSysKeyDown (UINT, UINT, UINT);
 afx_msg void OnChar (UINT, UINT, UINT);
 afx_msg void OnSysChar (UINT, UINT, UINT);
 afx_msg void OnSetFocus(CWnd *OldWnd);
 afx_msg void OnKillFocus(CWnd *NewWnd);
 DECLARE_MESSAGE_MAP ()
};

#endif