#if !defined(AFX_CTESTINTERFACE_H__1C5DEBF7_EC10_11D5_89BF_00105ACEC4F3__INCLUDED_)
#define AFX_CTESTINTERFACE_H__1C5DEBF7_EC10_11D5_89BF_00105ACEC4F3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CParInterface.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CParInterface dialog

class CParInterface 
{
// Construction
public:
	CParInterface(CString strBaseHexPort=_T("378"));   // standard constructor
private:
	int m_nPortBse;  //LPT port Base Address Numeric value
	CString	m_strBse;//LPT port Base Address String value


	int m_nWrtBit; //Number of the bit to write or read

	CString	m_strVersioneOS; //Info OS
	int nVersione;   //Version Number OS
	CString vers;    // Version string OS
	CString tipo;    // Type OS
	CString srvpack; //Service Pack Info

public:
   int GetBit(int nBit); //Read single bit status
   int ReadByte(int portBaseAdd); //Read byte from specified address
   int ReadDataINP(int portAdd);  //Read Inputs Lines from fgHWsms interface
   void WriteByte(int portBaseAdd,unsigned char value);//Write a byte to specified address
   void WriteDataSingleBit(int portAdd,int nBit); //Write single Bit
   void WriteDataOUT(int portAdd,int value); //Write data to OUT signal of the fgHWsms interface
   int  ReadByteOUT(int portAdd); //Read Status of OUTPUT lines (Latch register)
   BOOL GetSystemVersion(int& nVersione,CString& vers,CString& tipo,CString& srvpack); //Get OS version

   void SetBaseAddr(CString strBaseHex); //Set Parallel Base ADDRESS port HEX Value
   void SetBaseAddr(int nBaseAddr); //Set Parallel Base ADDRESS numeric value
   int  GetBsePortAddr(int memAddr);//Get the base address of Lpt(memAddr-> =0 Lpt1 =1 Lpt2 =2 Lpt3)
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CTESTINTERFACE_H__1C5DEBF7_EC10_11D5_89BF_00105ACEC4F3__INCLUDED_)
