////////////////////////////////////////////
// Programma:       
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabCfgIO.h 
// Storia:
// Data Creazione: 21/10/2001
// (c) 2001 SofTech di Germinara Francesco 
////////////////////////////////////////////////
// Ultima Modifica al tracciato base 22/05/2001/
////////////////////////////////////////////////

#include "stdafx.h"

#ifndef CLASS_CTabCfgIO_INCLUDED
#define CLASS_CTabCfgIO_INCLUDED
//
/////////////////////////////////////////////////////////////////////////////
class CTabCfgIO : public CRecordset
{
public:
	CTabCfgIO(CDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CTabCfgIO)
 
    CDatabase *m_pDB; //Puntatore al Database aperto

// Campi
	CString m_memAddr;
	CString m_nBit;
	CString m_type;
	CString m_des;
//Fine Elenco Campi della tabella di database --- 

//Lunghezze dei campi
	int m_len_memAddr;
	int m_len_nBit;
	int m_len_type;
	int m_len_des;
//Fine Elenco Variabili per dimensione campi della tabella di database --- 

	public:

	//Funzioni di accesso alla tabella del database
	virtual CString GetDefaultConnect(); 
	virtual CString GetDefaultSQL(); 	
	virtual void DoFieldExchange(CFieldExchange* pFX);	

	//Funzioni Standard implementate su ciascuna Tabella

    //Restituisce il numero di record nella tabella
	virtual long int Count(CString filtro=""); 
    
	//Riempio ListBox per visualizzazione
    virtual int MakeList(CListCtrl *m_listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro="");

    //Trova il record indicato
	int LoadDati(CString& memAddr,CString& nBit,CString& type); 

	//Inserisce/Varia record di dato
    int Insert(
	 CString& memAddr,
	 CString& nBit,
	 CString& type,
	 CString& des
	); 

	//Cancella Singolo Record
    int DeleteRec(CString& memAddr,CString& nBit,CString& type);

	//Cancello Tutto
	int DeleteAll();

    //Esportazione dati in file ASCII
    void Export(CProgressCtrl *progBar);
    
	//Importazione dati da file ASCII
    void Import(CProgressCtrl *progBar);

	//Apertura File per la stampa
    virtual int OpenRecordSet(qtHead *m_inttab,CString filtro="");

	//Riempio una riga con il record corrente
	virtual int GetRecordForDispInfo(CListCtrl *m_qtListCtrl,LVITEM* pItem);
	

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
#endif

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 2001