// FGSmsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FGSms.h"
#include "FGSmsDlg.h"

#include "CDlgCfgCell.h"
#include "CDlgCfgSMPT.h"
#include "CDlgCfgUtenti.h"
#include "CDlgCfgGruppi.h"
#include "CDlgCfgFGSms.h"
#include "CFGSmsParser.h"
#include "CDlgWriteSMS.h"
#include "CDlgReadSMS.h"
#include "CDlgCfgIO.h"
#include "CDlgStoricoMsg.h"
#include "CDlgStoricoMsgInviati.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CFGSmsApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFGSmsDlg dialog

CFGSmsDlg::CFGSmsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFGSmsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFGSmsDlg)
	m_stsStatus = _T("");
	m_strStsLpts = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFGSmsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFGSmsDlg)
	DDX_Control(pDX, IDC_SICOMMCTRL1, m_siSerialPort);
	DDX_Text(pDX, IDC_EDT_STATUS, m_stsStatus);
	DDX_Text(pDX, IDC_STS_LPTSTS, m_strStsLpts);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFGSmsDlg, CDialog)
	//{{AFX_MSG_MAP(CFGSmsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_BTN_CFG_CELL, OnBtnCfgCell)
	ON_BN_CLICKED(IDC_BTN_SMTP, OnBtnSmtp)
	ON_BN_CLICKED(IDC_BTN_USER, OnBtnUser)
	ON_BN_CLICKED(IDC_BTN_GRP, OnBtnGrp)
	ON_BN_CLICKED(IDC_BTN_CFGFGSMS, OnBtnCfgfgsms)
	ON_BN_CLICKED(IDC_BTN_SRTSMS, OnBtnSrtsms)
	ON_BN_CLICKED(IDC_BTN_READSMS, OnBtnReadsms)
	ON_BN_CLICKED(IDC_BTN_CFGIO, OnBtnCfgio)
	ON_BN_CLICKED(IDC_BTN_RICEV, OnBtnRicev)
	ON_BN_CLICKED(IDC_BTN_SEND, OnBtnSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFGSmsDlg message handlers

BOOL CFGSmsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	SetWindowText("fgSMS: "+theApp.m_strSessionName);

	CheckConfigOption();

	/* Command Parser...
	CString m_strParseCmd;
	m_strParseCmd="#PM \\prova\\pippo\\oggetto\\testo di prova ";
    CFGSmsParser myParser(m_strParseCmd);
    myParser.Parser(); //TRUE for Debug mode
	*/

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

    GetStatus();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFGSmsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFGSmsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFGSmsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

HBRUSH CFGSmsDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CFGSmsDlg::OnBtnCfgCell() 
{
  CDlgCfgCell dlgCfgCell(this);

 dlgCfgCell.m_nConnectionType=theApp.m_nConnectionType;
 dlgCfgCell.m_nDataBits=theApp.m_nDataBits;
 dlgCfgCell.m_nParityType=theApp.m_nParityType;
 dlgCfgCell.m_nSerialPort=theApp.m_nSerialPort;
 dlgCfgCell.m_nStopBits=theApp.m_nStopBits;
 dlgCfgCell.m_nBaudRate=theApp.m_nBaudRate;
 dlgCfgCell.m_strNCentroServizi=theApp.m_strNCentroServizi;

 if(dlgCfgCell.DoModal()==IDOK){
  theApp.m_nConnectionType=dlgCfgCell.m_nConnectionType;
  theApp.m_nDataBits=dlgCfgCell.m_nDataBits;
  theApp.m_nParityType=dlgCfgCell.m_nParityType;
  theApp.m_nSerialPort=dlgCfgCell.m_nSerialPort;
  theApp.m_nStopBits=dlgCfgCell.m_nStopBits;
  theApp.m_nBaudRate=dlgCfgCell.m_nBaudRate;
  theApp.m_strNCentroServizi=dlgCfgCell.m_strNCentroServizi;
 }
}

void CFGSmsDlg::OnBtnSmtp() 
{
  CDlgCfgSMPT dlgCfgSMPT(this);
  dlgCfgSMPT.DoModal();
}

void CFGSmsDlg::OnBtnUser() 
{
  CDlgCfgUtenti dlgCfgUtenti(this);
  dlgCfgUtenti.DoModal();
}

void CFGSmsDlg::OnBtnGrp() 
{
  CDlgCfgGruppi dlgCfgGruppi(this);
  dlgCfgGruppi.DoModal();
}

void CFGSmsDlg::OnBtnCfgfgsms() 
{
  CDlgCfgFGSms	dlgCfgFGSms(this);

  dlgCfgFGSms.m_bConfigurationEnable = theApp.m_bConfigurationEnable;
  dlgCfgFGSms.m_strMemSharedName = theApp.m_strMemSharedName;
  dlgCfgFGSms.m_strWorkDir = theApp.m_strWorkDir;
  dlgCfgFGSms.m_strTmPolling = theApp.m_strTmPolling;
  if(dlgCfgFGSms.DoModal()==IDOK){
   theApp.m_bConfigurationEnable = dlgCfgFGSms.m_bConfigurationEnable;
   theApp.m_strMemSharedName = dlgCfgFGSms.m_strMemSharedName;
   theApp.m_strWorkDir = dlgCfgFGSms.m_strWorkDir;
   theApp.m_strTmPolling =dlgCfgFGSms.m_strTmPolling;
   CheckConfigOption();
  }
}


//If the Configuration option flag is set, user can change configuration information.
void CFGSmsDlg::CheckConfigOption(){
 GetDlgItem(IDC_BTN_CFG_CELL)->EnableWindow(theApp.m_bConfigurationEnable);
 GetDlgItem(IDC_BTN_SMTP)->EnableWindow(theApp.m_bConfigurationEnable);
 GetDlgItem(IDC_BTN_USER)->EnableWindow(theApp.m_bConfigurationEnable);
 GetDlgItem(IDC_BTN_GRP)->EnableWindow(theApp.m_bConfigurationEnable);
}

void CFGSmsDlg::OnBtnSrtsms() 
{
  CDlgWriteSMS dlgWriteSMS(this);
  dlgWriteSMS.DoModal();
}


void CFGSmsDlg::GetStatus() 
{
 CString strRes;
 CDlgCfgCell dlgCfgCell(this);
 int sts=0;
 UpdateData(TRUE);
 dlgCfgCell.OpenComPort();
 dlgCfgCell.SendSimpleCmdToPhone("GetModel",m_stsStatus);
 m_stsStatus.TrimRight();
 dlgCfgCell.CloseComPort();
 if(m_stsStatus.IsEmpty())
  m_stsStatus="Errore: Cellulare non collegato!";
 UpdateData(FALSE);
}

void CFGSmsDlg::OnBtnReadsms() 
{
  CDlgReadSMS dlgReadSMS(this);
  dlgReadSMS.DoModal();
}

void CFGSmsDlg::OnBtnCfgio() 
{
 CDlgCfgIO dlgCfgIO(this);
	dlgCfgIO.DoModal();
}

void CFGSmsDlg::OnBtnRicev() 
{
 CDlgStoricoMsg dlgStoricoMsg(this);
	dlgStoricoMsg.DoModal();
}

void CFGSmsDlg::OnBtnSend() 
{
 CDlgStoricoMsgInviati dlgStoricoMsgInviati(this);
 dlgStoricoMsgInviati.DoModal();
}
