////////////////////////////////////////////
// Programma:
// Per NT 4.00 e Successive
// Realizzato da: SofTech di Germinara Francesco 
// CTabVirtual.cpp 
// Storia:
// Data Creazione: 31/12/1999
// (c) SofTech di Germinara Francesco 
////////////////////////////////////////////

#include "stdafx.h"
#include "CTabVirtual.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNAMIC(CTabVirtual, CRecordset)

CTabVirtual::CTabVirtual(CDatabase* pdb)
	: CRecordset(pdb)
{
    //Inizializzazione dei campi, del numero di campi
	//e del tipo di gestione del database
	m_codute= _T("");
	m_nome= _T("");
	m_cogn= _T("");
	m_flgpw= _T("");
	m_pw= _T("");
	m_pl= _T("");
	m_email= _T("");
	m_exchangedn= _T("");

	m_nFields = 8;

	m_nDefaultType = dynaset;
	m_pDB=pdb; //Assegno il puntatore al database aperto
	
	//Lunghezze dei campi della tabella
	m_len_codute= 4;
	m_len_nome= 30;
	m_len_cogn= 30;
	m_len_flgpw= 1;
	m_len_pw= 10;
	m_len_pl= 1;
	m_len_email= 128;
	m_len_exchangedn= 128;
}

//Connessione con il database
CString CTabVirtual::GetDefaultConnect()
{
 //Apre la connessione stabilita con il database
 return _T(m_pDB->GetConnect());
}

//Connessione con la tabella
CString CTabVirtual::GetDefaultSQL()
{
 //Nessuna operazione iniziale
 return _T("");
}

//Funzione per interscambio dati da/verso tabella del DB
void CTabVirtual::DoFieldExchange(CFieldExchange* pFX)
{
   	pFX->SetFieldType(CFieldExchange::outputColumn);
	RFX_Text(pFX, _T("[codute]"),m_codute);
	RFX_Text(pFX, _T("[nome]"),m_nome);
	RFX_Text(pFX, _T("[cogn]"),m_cogn);
	RFX_Text(pFX, _T("[flgpw]"),m_flgpw);
	RFX_Text(pFX, _T("[pw]"),m_pw);
	RFX_Text(pFX, _T("[pl]"),m_pl);
	RFX_Text(pFX, _T("[email]"),m_email);
	RFX_Text(pFX, _T("[exchangedn]"),m_exchangedn);
}

//ESPORTA IN FILE ASCII
void CTabVirtual::Export(CProgressCtrl *progBar=NULL){
}

//IMPORTA IL FILE ASCII
void CTabVirtual::Import(CProgressCtrl *progBar){
}

//Restituisce il numero di record nella tabella
long int CTabVirtual::Count(CString filtro){
  long nrec=0L;
  //Virtuale
  return nrec;
}


//Controlla se esiste il codice specificato, se esiste carica i dati
//nelle rispettive variabili
int CTabVirtual::LoadDati(CString& codute){
  return qtRC_SI;
}

//Immissione dati
int CTabVirtual::Insert(
	 CString& codute,
	 CString& nome,
	 CString& cogn,
	 CString& flgpw,
	 CString& pw,
	 CString& pl,
	 CString& email,
	 CString& exchangedn
 ){
  return qtRC_SI;
}

//Cancellazione Singolo Dato
int CTabVirtual::DeleteRec(CString& codute){
  return qtRC_SI;
}

//Cancello tutti i dati 
int CTabVirtual::DeleteAll(){
  return qtRC_SI;
}

//Inserisce i record nella listview
int CTabVirtual::MakeList(CListCtrl *m_Listview,qtHead *m_inttab,CProgressCtrl *progBar,CString filtro){

  //Virtuale 

  return 0;
}


//Imposta Recordset
int CTabVirtual::OpenRecordSet(qtHead *m_inttab,CString filtro){
  //Virtuale
  return qtRC_SI;   //OK
}

//Inserisce i record nella listview
int CTabVirtual::GetRecordForDispInfo(CListCtrl *m_FG,LVITEM* pItem){
  //Virtuale
  return qtRC_SI;   //OK
}


/////////////////////////////////////////////////////////////////////////////
// CTabVirtual Diagnostica

#ifdef _DEBUG
void CTabVirtual::AssertValid() const
{
	CRecordset::AssertValid();
}

void CTabVirtual::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG

//Realizzato in modo automatico con MKCTab di Francesco Germinara (c) 1999
