//----------------------------------------------------------------
// Nome Progetto        : Labels.exe
// Nome file            : qtHead.h
// Classe               : qtHead
//----------------------------------------------------------------
// Descrizione          : Classe Intestazione Colonne Report
// Data 1 Realizzazione: 22/05/2001
// Autore               : SofTech  di Francesco Germinara  
// Copyright (c)        : SofTech  di Francesco Germinara  
//----------------------------------------------------------------
// Storia:
// 
//----------------------------------------------------------------

#ifndef CLASS_INTESTATAB_INCLUDED
#define CLASS_INTESTATAB_INCLUDED

#include "QT_CONST.h"

class qtHead{
 private:
 int n_col; //Numero di colonne
 char szHtab[M_CAMPI][40]; //50 colonne max, descr 39 ch. max
 int lenVHtab[M_CAMPI];    //Lunghezze delle 50 colonne a video 
 int lenSHtab[M_CAMPI];    //Lunghezze delle 50 colonne in stampa -1 non viene stampato
 int lenCMPtab[M_CAMPI];   //Lunghezze del CAMPO 0=TUTTO
 int m_ordine;        //Numero colonna di ordinamento
 int m_tipord;        //0=Crescente 1=Decrescente

 public:

 int m_tipoCampo[M_CAMPI];//Tipo di campo 0=ALFANUM 1=Numerico 2=Data 3=Ora
 int m_nDecCampo[M_CAMPI];//Numero di decimali per campi numerici
 
 //Costruttore 
 qtHead();

 CRect rcPos[M_CAMPI];               //Posizione dei campi calcolata per la stampa
 CString *m_strValore[M_CAMPI];      //Valore del campo
 BOOL m_bUseTranslateFunct[M_CAMPI]; //TRUE=Uso la funzione di decodifica del valore

 //Array delle funzioni di trasformazione dei dati esposti
 CString (__cdecl *m_pFunct[M_CAMPI])(CString strCodice); //Funzione di decodifica

 //Array Flag Abilitazione della stampa del campo
 BOOL m_bFieldEnabled[M_CAMPI]; //TRUE=stampa il campo indicato

 //Funzioni di accesso
 int getnumcol(){return n_col;}
 int getlargcolV(int col){return lenVHtab[col];}
 int getlargcolS(int col){return lenSHtab[col];}
 int getlargcmp(int col){return lenCMPtab[col];}
 int getorder(){return m_ordine;}
 int gettipord(){return m_tipord;}
 char* getdesccol(int col){return szHtab[col];}

 void setorder(int ord){m_ordine=ord;}
 void settipord(int ord){m_tipord=ord;}
 void setnumcol(int ncol){n_col=ncol;}
 void setlargcolV(int col,int larg){lenVHtab[col]=larg;}
 void setlargcolS(int col,int larg){lenSHtab[col]=larg;}
 void setlargcmp(int col,int larg){lenCMPtab[col]=larg;}
 void setdesccol(int col, char* descr){strcpy(szHtab[col],descr);}
 void setdesccol(int col, CString descr){strcpy(szHtab[col],descr);}
};

#endif