//----------------------------------------------------------------
// Nome Progetto        : Labels.exe
// Nome file            : qtListCtrl.h
// Classe               : qtListCtrl
//----------------------------------------------------------------
// Descrizione          : Classe Gestione List View Virtuali
// Data 1 Realizzazione: 22/05/2001
// Autore               : SofTech  di Francesco Germinara  
// Copyright (c)        : SofTech  di Francesco Germinara  
//----------------------------------------------------------------
// Storia:
// 
//----------------------------------------------------------------

#if !defined(AFX_QTLISTCTRL_H__AF685C53_C994_11D3_8DED_0050DA2A51E1__INCLUDED_)
#define AFX_QTLISTCTRL_H__AF685C53_C994_11D3_8DED_0050DA2A51E1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// qtListCtrl.h : header file
//

#include"CTabVirtual.h"

/////////////////////////////////////////////////////////////////////////////
// qtListCtrl window

class qtListCtrl : public CListCtrl
{
// Construction
public:
	qtListCtrl(CWnd *pWnd,UINT nID,CRect& rect,void *m_pTabGen);

// Attributes
public:
	CTabVirtual *m_pTabGenerica; 

// Overrides
public:
	virtual BOOL OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult);

protected:

	void PrepareCache(int iFrom, int iTo); //Non implementata
	int FindItem(int iStart, LVFINDINFO* plvfi); //Non implementata

	void GetDispInfo(LVITEM* pItem); 

// Operations
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(qtListCtrl)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~qtListCtrl();

	// Generated message map functions
protected:
	//{{AFX_MSG(qtListCtrl)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_QTLISTCTRL_H__AF685C53_C994_11D3_8DED_0050DA2A51E1__INCLUDED_)
