// CDlgCfgCell.cpp : implementation file
// By Francesco Germinara (c) 2001 

#if !defined(__table7bit__INCLUDED_)
#define __table7bit__INCLUDED_

//Conversion table from ASCII to 7 bit alphabet
// Note value with 27xxx = ESC (27)+ value
int table7bit[256]={
0, // 0
0, // 1
0, // 2
0, // 3
0, // 4
0, // 5
0, // 6
0, // 7
0, // 8
0, // 9
10, //10 = LF
0, // 1
10, // 2  = FF
13,// 3  = CR 
0, // 4
0, // 5
0, // 6 
0, // 7
0, // 8
0, // 9
0, // 20
0, // 1
0, // 2
0, // 3
0, // 4
0, // 5
0, // 6
27, // 7 = ESC
0, // 8
0, // 9
0, // 30
0, // 1
32, // 2 = space
33, // 3 = !
34, // 4 = "
35, // 5 = #
2, // 6 = $
37, // 7 = %
38, // 8 = &
39, // 9 = '
40, // 40 = (
41, // 1 = )
42, // 2 = *
43, // 3 = +
44, // 4 = ,
45, // 5 = -
46, // 6 = .
47, // 7 = /
48, // 8 = 0
49, // 9 = 1
50, // 50 = 2
51, // 1 = 3
52, // 2 = 4
53, // 3 = 5
54, // 4 = 6
55, // 5 = 7
56, // 6 = 8
57, // 7 = 9
58, // 8 = :
59, // 9 = ;
60, // 60 = <
61, // 1 = =
62, // 2 = >
63, // 3 = ?
0, // 4 = @
65, // 5 = A
66, // 6 = B
67, // 7 = C
68, // 8 = D
69, // 9 = E
70, // 70 = F
71, // 1 = G
72, // 2 = H
73, // 3 = I
74, // 4 = J
75, // 5 = K
76, // 6 = L
77, // 7 = M
78, // 8 = N
79, // 9 = O
80, // 80 = P
81, // 1 = Q
82, // 2 = R
83, // 3 = S
84, // 4 = T
85, // 5 = U
86, // 6 = V
87, // 7 = W
88, // 8 = X
89, // 9 = Y
90, // 90 = Z
60, // 1 = [
47, // 2 = \ 
62, // 3 = ]
20, // 4 = ^
17, // 5 = _
0, // 6
97, // 7 = a
98, // 8 = b
99, // 9 = c
100, // 100 = d
101, // 1 = e
102, // 2 = f
103, // 3 = g
104, // 4 = h
105, // 5 = i
106, // 6 = j
107, // 7 = k
108, // 8 = l
109, // 9 = m
110, // 110 = n
111, // 1 = o
112, // 2 = p
113, // 3 = q
114, // 4 = r
115, // 5 = s
116, // 6 = t
117, // 7 = u
118, // 8 = v
119, // 9 = w
120, // 120 = x
121, // 1 = y
122, // 2 = z
40, // 3 = {
64, // 4 = |
41, // 5 = }
61, // 6 = ~
0, // 7
0, // 8
0, // 9
0, // 130
0, // 1
0, // 2
0, // 3
0, // 4
0, // 5
0, // 6
0, // 7
0, // 8
0, // 9
0, // 140
0, // 1
0, // 2
0, // 3
0, // 4
0, // 5
0, // 6
0, // 7
0, // 8
0, // 9
0, // 150
0, // 1
0, // 2
0, // 3
0, // 4
0, // 5
0, // 6
0, // 7
0, // 8
0, // 9
0, // 160
64, // 1 = 
0, // 2
1, // 3 = 
36, // 4 = 
3, // 5 = 
0, // 6
95, // 7 = 
0, // 8
0, // 9
0, // 170
0, // 1
0, // 2
0, // 3
0, // 4
0, // 5
0, // 6
0, // 7
0, // 8
0, // 9
0, // 180
0, // 1
0, // 2
0, // 3
0, // 4
0, // 5
0, // 6
0, // 7
0, // 8
0, // 9
0, // 190
96, // 1 = 
0, // 2
0, // 3
0, // 4
0, // 5
91, // 6 = 
14, // 7 = 
28, // 8 = 
9, // 9 = 
0, // 200
0, // 1
31, // 2 = 
0, // 3
0, // 4
0, // 5
0, // 6
0, // 7
0, // 8
93, // 9 = 
0, // 210
0, // 1
0, // 2
0, // 3
92, // 4 = 
0, // 5
11, // 6 = 
0, // 7
0, // 8
0, // 9
94, // 220 = 
0, // 1
0, // 2
30, // 3 = 
127, // 4 = 
0, // 5
0, // 6
0, // 7
123, // 8 = 
15, // 9 = 
29, // 230 = 
0, // 1
4, // 2 = 
5, // 3 = 
0, // 4
0, // 5
7, // 6 = 
0, // 7
0, // 8
0, // 9
0, // 240
125, // 1 = 
8, // 2 = 
0, // 3
0, // 4
0, // 5
0, // 6
0, // 7
12, // 8 = 
6, // 9 = 
6, // 250 = 
0, // 1
126, // 2 = 
0, // 3
0, // 4
0 // 5
};

int findtable7bit(int ch){
 for(int j=0; j< 255;j++)
  if(table7bit[j]==ch)
   return j;
 return 0;
}
int findtable7bitExt(int ch){
 switch(ch){
  case 20: return '^'; 
  case 40: return '{'; 
  case 41: return '}'; 
  case 47: return '\\'; 
  case 60: return '['; 
  case 62: return ']'; 
  case 64: return '|'; 
  case 61: return '~'; 
  case 36: return ''; 
  default: return ' ';
 }
}
#else
extern int table7bit[256];
extern int findtable7bit(int ch);
extern int findtable7bitExt(int ch);
#endif